import { Component, Inject, NgModule, Pipe, Injectable, ɵɵdefineInjectable, ɵɵinject, Directive, ViewChild, HostListener, ElementRef, Renderer2, Input } from '@angular/core';
import { MatDialogRef, MAT_DIALOG_DATA, MAT_SNACK_BAR_DATA, MatButtonModule, MatDialogModule, MatIconModule, MatProgressSpinnerModule, MatSnackBar, MatDialog } from '@angular/material';
import { CommonModule } from '@angular/common';
import { BehaviorSubject, Subject, throwError, Observable, of, zip } from 'rxjs';
import moment from 'moment';
import { __awaiter } from 'tslib';
import { concatMap, tap, map, mergeMap, catchError } from 'rxjs/operators';
import { HttpClient, HttpResponse } from '@angular/common/http';
import { LocalStorage } from '@ngx-pwa/local-storage';
import { Router, ActivatedRoute } from '@angular/router';
import { FormControl, Validators } from '@angular/forms';
import { MatSnackBar as MatSnackBar$1 } from '@angular/material/snack-bar';
import { MatDialog as MatDialog$1 } from '@angular/material/dialog';

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class ConfirmDialogWindowComponent {
    /**
     * @param {?} dialogRef
     * @param {?} data
     */
    constructor(dialogRef, data) {
        this.dialogRef = dialogRef;
        this.data = data;
    }
    /**
     * @return {?}
     */
    ngOnInit() {
    }
    /**
     * @return {?}
     */
    onNegativeAnswerClick() {
        this.dialogRef.close(false);
    }
    /**
     * @return {?}
     */
    onPositiveAnswerClick() {
        this.dialogRef.close(true);
    }
}
ConfirmDialogWindowComponent.decorators = [
    { type: Component, args: [{
                selector: 'qsl-confirm-dialog-window',
                template: "<div mat-dialog-content>\n  <p><span i18n=\"@@dataNext\">data.text</span> <span class=\"data-entity-class\">{{data.entity.title}}</span> <span>?</span></p>\n</div>\n<div mat-dialog-content class=\"centr\">\n    <button class=\"negative-answer\" mat-button (click)=\"onNegativeAnswerClick()\" i18n=\"@@dataNegativeAnswer\"> data.negativeAnswer </button>\n\n    <button class=\"positive-answer\" mat-button (click)=\"onPositiveAnswerClick()\" i18n=\"@@dataPositiveAnswer\"> data.positiveAnswer </button>\n</div>\n",
                styles: [".centr{margin-right:auto;margin-left:auto;text-align:center}.positive-answer{background:#2e74e2;color:#fff}.positive-answer:hover{background-color:#2e74e2}.negative-answer{margin-right:15px;color:#4a90e2}.negative-answer:hover{background-color:rgba(68,130,226,.2)}.negative-answer:hover ::ng-deep .mat-button-focus-overlay{background:0 0}.data-entity-class{padding-left:5px;padding-right:5px}"]
            }] }
];
/** @nocollapse */
ConfirmDialogWindowComponent.ctorParameters = () => [
    { type: MatDialogRef },
    { type: undefined, decorators: [{ type: Inject, args: [MAT_DIALOG_DATA,] }] }
];
if (false) {
    /** @type {?} */
    ConfirmDialogWindowComponent.prototype.dialogRef;
    /** @type {?} */
    ConfirmDialogWindowComponent.prototype.data;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class SnackBarComponent {
    /**
     * @param {?} data
     */
    constructor(data) {
        this.data = data;
    }
    /**
     * @return {?}
     */
    ngOnInit() {
    }
}
SnackBarComponent.decorators = [
    { type: Component, args: [{
                selector: 'snack-bar-component',
                template: "<span i18n=\"@@popupMessage\">data.message</span>\n"
            }] }
];
/** @nocollapse */
SnackBarComponent.ctorParameters = () => [
    { type: undefined, decorators: [{ type: Inject, args: [MAT_SNACK_BAR_DATA,] }] }
];
if (false) {
    /** @type {?} */
    SnackBarComponent.prototype.data;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class ComponentsModule {
}
ComponentsModule.decorators = [
    { type: NgModule, args: [{
                imports: [
                    CommonModule,
                    MatButtonModule,
                    MatDialogModule
                ],
                declarations: [
                    ConfirmDialogWindowComponent,
                    SnackBarComponent
                ],
                entryComponents: [
                    ConfirmDialogWindowComponent,
                    SnackBarComponent
                ],
                exports: [
                    ConfirmDialogWindowComponent,
                    SnackBarComponent
                ]
            },] }
];

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/**
 * Created by yana on 20.04.18.
 */
class Event {
    constructor() {
        this.attachments = [];
    }
}
if (false) {
    /** @type {?} */
    Event.prototype.id;
    /** @type {?} */
    Event.prototype.title;
    /** @type {?} */
    Event.prototype.description;
    /** @type {?} */
    Event.prototype.location;
    /** @type {?} */
    Event.prototype.dateStart;
    /** @type {?} */
    Event.prototype.dateEnd;
    /** @type {?} */
    Event.prototype.streams;
    /** @type {?} */
    Event.prototype.status;
    /** @type {?} */
    Event.prototype.participantsLimit;
    /** @type {?} */
    Event.prototype.creator;
    /** @type {?} */
    Event.prototype.tags;
    /** @type {?} */
    Event.prototype.attachments;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/**
 * Created by yana on 20.04.18.
 */
class Location {
}
if (false) {
    /** @type {?} */
    Location.prototype.id;
    /** @type {?} */
    Location.prototype.latitude;
    /** @type {?} */
    Location.prototype.longitude;
    /** @type {?} */
    Location.prototype.formattedAddress;
    /** @type {?} */
    Location.prototype.cityName;
    /** @type {?} */
    Location.prototype.placeId;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/** @enum {string} */
const StatusEvent = {
    PUBLISH: 'PUBLISH',
    NOT_PUBLISH: 'NOT_PUBLISH',
};

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class Visitor {
}
if (false) {
    /** @type {?} */
    Visitor.prototype.username;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/**
 * Created by vlad on 23.04.18.
 */
class NextTimeEvents {
    /**
     * @param {?} items
     * @return {?}
     */
    transform(items) {
        if (!items) {
            return [];
        }
        /** @type {?} */
        const currentDate = new Date();
        return items.filter((/**
         * @param {?} it
         * @return {?}
         */
        it => {
            return it.dateStart > currentDate;
        }));
    }
}
NextTimeEvents.decorators = [
    { type: Pipe, args: [{ name: 'nextTimeEvents',
                pure: false },] }
];

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/**
 * Created by vlad on 25.05.18.
 */
class NotPublished {
    /**
     * @param {?} items
     * @return {?}
     */
    transform(items) {
        if (!items) {
            return [];
        }
        return items.filter((/**
         * @param {?} it
         * @return {?}
         */
        it => {
            return (it.status.toString() === 'NOT_PUBLISH');
        }));
    }
}
NotPublished.decorators = [
    { type: Pipe, args: [{ name: 'notPublishedEvents',
                pure: false },] }
];
if (false) {
    /** @type {?} */
    NotPublished.prototype.statusEvent;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/**
 * Created by vlad on 25.05.18.
 */
class PublishedEvents {
    /**
     * @param {?} items
     * @return {?}
     */
    transform(items) {
        if (!items) {
            return [];
        }
        return items.filter((/**
         * @param {?} it
         * @return {?}
         */
        it => {
            return (it.status.toString() === 'PUBLISH');
        }));
    }
}
PublishedEvents.decorators = [
    { type: Pipe, args: [{ name: 'publishedEvents',
                pure: false },] }
];
if (false) {
    /** @type {?} */
    PublishedEvents.prototype.statusEvent;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/**
 * Created by yana on 26.04.18.
 */
class SortByDatePipe {
    /**
     * @param {?} array
     * @param {?} args
     * @return {?}
     */
    transform(array, args) {
        if (typeof args[0] === 'undefined') {
            return array;
        }
        /** @type {?} */
        let direction;
        direction = args[0][0];
        /** @type {?} */
        const column = args.replace('-', '');
        array.sort((/**
         * @param {?} item1
         * @param {?} item2
         * @return {?}
         */
        (item1, item2) => {
            /** @type {?} */
            const left = Number(item1[column]);
            /** @type {?} */
            const right = Number(item2[column]);
            return (direction === '-') ? right - left : left - right;
        }));
        return array;
    }
}
SortByDatePipe.decorators = [
    { type: Pipe, args: [{
                name: 'sortByDate',
                pure: false
            },] },
    { type: Injectable }
];

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class AdminDetailsServiceService {
    constructor() {
    }
    /**
     * @param {?} event
     * @return {?}
     */
    assignLocation(event) {
        if (event.location == null) {
            event.location = new Location();
            event.location.latitude = 0;
            event.location.longitude = 0;
        }
    }
    /**
     * @param {?} startDate
     * @param {?} endDate
     * @return {?}
     */
    compareDates(startDate, endDate) {
        return startDate.startDate > endDate.startDate ? 1 : -1;
    }
}
AdminDetailsServiceService.decorators = [
    { type: Injectable, args: [{
                providedIn: 'root'
            },] }
];
/** @nocollapse */
AdminDetailsServiceService.ctorParameters = () => [];
/** @nocollapse */ AdminDetailsServiceService.ngInjectableDef = ɵɵdefineInjectable({ factory: function AdminDetailsServiceService_Factory() { return new AdminDetailsServiceService(); }, token: AdminDetailsServiceService, providedIn: "root" });

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/**
 * @template T
 */
class BaseBehaviorSubject {
    constructor() {
        this.subject = new BehaviorSubject([]);
    }
    /**
     * @param {?=} next
     * @return {?}
     */
    subscribe(next) {
        return this.subject.subscribe(next);
    }
    /**
     * @private
     * @param {?} items
     * @return {?}
     */
    notifySubjectChanged(items) {
        this.subject.next(items);
    }
    /**
     * @param {?} items
     * @return {?}
     */
    replaceAll(items) {
        this.notifySubjectChanged(items);
    }
    /**
     * @param {?} item
     * @return {?}
     */
    add(item) {
        if (!item) {
            return;
        }
        /** @type {?} */
        const currentValue = this.subject.getValue();
        currentValue.push(item);
        this.subject.next(currentValue);
    }
    /**
     * @param {?} item
     * @param {?} equals
     * @return {?}
     */
    remove(item, equals) {
        /** @type {?} */
        const items = this.subject.getValue();
        /** @type {?} */
        const positionInTheList = items.findIndex((/**
         * @param {?} e
         * @return {?}
         */
        (e) => equals(e, item)));
        if (positionInTheList > -1) {
            items.splice(positionInTheList, 1);
        }
        this.notifySubjectChanged(items);
    }
    /**
     * @param {?} item
     * @param {?} equals
     * @return {?}
     */
    replace(item, equals) {
        if (!item) {
            return;
        }
        /** @type {?} */
        const items = this.subject.getValue();
        /** @type {?} */
        const positionInTheList = items.findIndex((/**
         * @param {?} e
         * @return {?}
         */
        (e) => equals(e, item)));
        if (positionInTheList > -1) {
            items[positionInTheList] = item;
        }
        else {
            items.push(item);
        }
        this.notifySubjectChanged(items);
    }
}
if (false) {
    /** @type {?} */
    BaseBehaviorSubject.prototype.subject;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class EventStatusService {
    constructor() { }
    /**
     * @param {?} event
     * @return {?}
     */
    upComing(event) {
        return moment(event.dateStart).isAfter(moment());
    }
    /**
     * @param {?} events
     * @return {?}
     */
    notPassedEvents(events) {
        return !this.passed(events);
    }
    /**
     * @param {?} event
     * @return {?}
     */
    lasting(event) {
        return moment().isBetween(event.dateStart, event.dateEnd);
    }
    /**
     * @param {?} event
     * @return {?}
     */
    passed(event) {
        return moment(event.dateEnd).isBefore(moment());
    }
    /**
     * @param {?} event
     * @return {?}
     */
    afterNextMonth(event) {
        /** @type {?} */
        const nextNextMonth = moment().add(2, 'month');
        return moment(event.dateStart).isAfter(nextNextMonth);
    }
    /**
     * @param {?} event
     * @return {?}
     */
    onNextMonth(event) {
        /** @type {?} */
        const nextNextMonth = moment().add(2, 'month');
        /** @type {?} */
        const nextMonth = moment().add(1, 'month');
        return moment(event.dateStart).isBetween(nextMonth, nextNextMonth);
    }
    /**
     * @param {?} event
     * @return {?}
     */
    onThisMonth(event) {
        /** @type {?} */
        const nextMonth = moment().add(1, 'month');
        return moment(event.dateStart).isBetween(moment(), nextMonth);
    }
}
EventStatusService.decorators = [
    { type: Injectable, args: [{
                providedIn: 'root'
            },] }
];
/** @nocollapse */
EventStatusService.ctorParameters = () => [];
/** @nocollapse */ EventStatusService.ngInjectableDef = ɵɵdefineInjectable({ factory: function EventStatusService_Factory() { return new EventStatusService(); }, token: EventStatusService, providedIn: "root" });

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class QQRestConfig {
    /**
     * @param {?} url
     * @return {?}
     */
    static baseUrl(url) {
        this.BASE_URL = url;
    }
}
QQRestConfig.BASE_URL = '';
if (false) {
    /** @type {?} */
    QQRestConfig.BASE_URL;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/**
 * Created by yana on 20.04.18.
 */
class ApiUrlProvider {
    constructor() {
    }
    /**
     * @return {?}
     */
    getUrl() {
        return QQRestConfig.BASE_URL;
    }
}
ApiUrlProvider.decorators = [
    { type: Injectable, args: [{
                providedIn: 'root'
            },] }
];
/** @nocollapse */
ApiUrlProvider.ctorParameters = () => [];
/** @nocollapse */ ApiUrlProvider.ngInjectableDef = ɵɵdefineInjectable({ factory: function ApiUrlProvider_Factory() { return new ApiUrlProvider(); }, token: ApiUrlProvider, providedIn: "root" });

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class UserDetailsService {
    /**
     * @param {?} localStorage
     */
    constructor(localStorage) {
        this.localStorage = localStorage;
    }
    /**
     * @return {?}
     */
    getCurrentUserDisplayName() {
        return this.localStorage.getItem('display_name');
    }
    /**
     * @return {?}
     */
    getCurrentUserUsername() {
        return this.localStorage.getItem('username');
    }
    /**
     * @return {?}
     */
    getCurrentUserAccessToken() {
        return this.localStorage.getItem('access_token');
    }
    /**
     * @return {?}
     */
    getCurrentUserRefreshToken() {
        return this.localStorage.getItem('refresh_token');
    }
    /**
     * @return {?}
     */
    getCurrentUserRole() {
        return this.localStorage.getItem('role');
    }
    /**
     * @param {?} displayName
     * @return {?}
     */
    setCurrentUserDisplayName(displayName) {
        return this.localStorage.setItem('display_name', displayName);
    }
    /**
     * @param {?} username
     * @return {?}
     */
    setCurrentUserUsername(username) {
        return this.localStorage.setItem('username', username);
    }
    /**
     * @param {?} accessToken
     * @return {?}
     */
    setCurrentUserAccessToken(accessToken) {
        return this.localStorage.setItem('access_token', accessToken);
    }
    /**
     * @param {?} refreshToken
     * @return {?}
     */
    setCurrentUserRefreshToken(refreshToken) {
        return this.localStorage.setItem('refresh_token', refreshToken);
    }
    /**
     * @param {?} role
     * @return {?}
     */
    setCurrentUserRole(role) {
        return this.localStorage.setItem('role', role);
    }
    /**
     * @return {?}
     */
    clearCurrentUserDetails() {
        return this.localStorage.removeItem('display_name').pipe(concatMap((/**
         * @return {?}
         */
        () => this.localStorage.removeItem('username'))), concatMap((/**
         * @return {?}
         */
        () => this.localStorage.removeItem('access_token'))), concatMap((/**
         * @return {?}
         */
        () => this.localStorage.removeItem('refresh_token'))), concatMap((/**
         * @return {?}
         */
        () => this.localStorage.removeItem('role'))));
    }
}
UserDetailsService.decorators = [
    { type: Injectable, args: [{
                providedIn: 'root'
            },] }
];
/** @nocollapse */
UserDetailsService.ctorParameters = () => [
    { type: LocalStorage }
];
/** @nocollapse */ UserDetailsService.ngInjectableDef = ɵɵdefineInjectable({ factory: function UserDetailsService_Factory() { return new UserDetailsService(ɵɵinject(LocalStorage)); }, token: UserDetailsService, providedIn: "root" });
if (false) {
    /**
     * @type {?}
     * @private
     */
    UserDetailsService.prototype.localStorage;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class User {
}
if (false) {
    /** @type {?} */
    User.prototype.username;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class EventsService {
    /**
     * @param {?} http
     * @param {?} userDetailsService
     * @param {?} urlProvider
     */
    constructor(http, userDetailsService, urlProvider) {
        this.http = http;
        this.userDetailsService = userDetailsService;
        this.urlProvider = urlProvider;
        this.eventsContainer = new BaseBehaviorSubject();
    }
    /**
     * @return {?}
     */
    findAll() {
        return __awaiter(this, void 0, void 0, function* () {
            /** @type {?} */
            const currentEventList = yield this.http.get(`${this.urlProvider.getUrl()}api/events`)
                .toPromise();
            if (currentEventList) {
                this.eventsContainer.replaceAll(currentEventList);
            }
            return currentEventList;
        });
    }
    /**
     * @return {?}
     */
    getEventsContainer() {
        return this.eventsContainer;
    }
    /**
     * @return {?}
     */
    findAllCreatedByCurrentUser() {
        return this.userDetailsService.getCurrentUserUsername().pipe(concatMap((/**
         * @param {?} username
         * @return {?}
         */
        username => this.http.get(`${this.urlProvider.getUrl()}api/users/${username}/events`))))
            .pipe(tap((/**
         * @param {?} events
         * @return {?}
         */
        events => this.eventsContainer.replaceAll(events))));
    }
    /**
     * @return {?}
     */
    findPublished() {
        return this.http.get(`${this.urlProvider.getUrl()}api/events/published`)
            .pipe(tap((/**
         * @param {?} events
         * @return {?}
         */
        events => this.eventsContainer.replaceAll(events))));
    }
    /**
     * @param {?} id
     * @return {?}
     */
    findById(id) {
        return this.http.get(`${this.urlProvider.getUrl()}api/events/${id}`)
            .pipe(tap((/**
         * @param {?} event
         * @return {?}
         */
        event => this.eventsContainer.replace(event, (/**
         * @param {?} e1
         * @param {?} e2
         * @return {?}
         */
        (e1, e2) => e1.id == e2.id)))));
    }
    /**
     * @return {?}
     */
    createEmptyEvent() {
        return this.userDetailsService.getCurrentUserUsername().pipe(map((/**
         * @param {?} currentUsername
         * @return {?}
         */
        currentUsername => {
            return {
                title: 'New event title',
                description: 'Description',
                dateStart: new Date(),
                dateEnd: new Date(),
                creator: { username: currentUsername }
            };
        })), mergeMap((/**
         * @param {?} requestBody
         * @return {?}
         */
        requestBody => this.http.post(`${this.urlProvider.getUrl()}api/events/`, requestBody))));
    }
    /**
     * @param {?} event
     * @return {?}
     */
    deleteEvent(event) {
        return __awaiter(this, void 0, void 0, function* () {
            yield this.http.delete(`${this.urlProvider.getUrl()}api/events/${event.id}`)
                .toPromise()
                .then((/**
             * @return {?}
             */
            () => {
                this.eventsContainer.remove(event, (/**
                 * @param {?} e1
                 * @param {?} e2
                 * @return {?}
                 */
                (e1, e2) => e1.id == e2.id));
            }));
        });
    }
    /**
     * @param {?} event
     * @return {?}
     */
    updateEvent(event) {
        return this.http.put(`${this.urlProvider.getUrl()}api/events`, event);
    }
    /**
     * @param {?} id
     * @return {?}
     */
    publishEvent(id) {
        return this.http.post(`${this.urlProvider.getUrl()}api/events/${id}`, null);
    }
    /**
     * @param {?} event
     * @return {?}
     */
    createEvent(event) {
        return this.userDetailsService.getCurrentUserUsername().pipe(map((/**
         * @param {?} currentUsername
         * @return {?}
         */
        currentUsername => {
            event.creator = new User();
            event.creator.username = currentUsername;
            return event;
        })), mergeMap((/**
         * @param {?} eventRequestBody
         * @return {?}
         */
        eventRequestBody => this.http.post(`${this.urlProvider.getUrl()}api/events/`, eventRequestBody))));
    }
    /**
     * @param {?} id
     * @return {?}
     */
    getQrCode(id) {
        return this.http.get(`${this.urlProvider.getUrl()}api/events/${id}/qrcode`, { responseType: 'blob' });
    }
    /**
     * @param {?} text
     * @return {?}
     */
    getEventByTagNameIn(text) {
        /** @type {?} */
        const filteredEventList = this.http.post(`${this.urlProvider.getUrl()}api/events/filter/tags/`, text);
        if (filteredEventList) {
            filteredEventList.subscribe((/**
             * @param {?} events
             * @return {?}
             */
            events => {
                this.eventsContainer.replaceAll(events);
            }));
        }
        return filteredEventList;
    }
    /**
     * @param {?} tag
     * @return {?}
     */
    getEventByTagName(tag) {
        /** @type {?} */
        const filteredEventList = this.http.post(`${this.urlProvider.getUrl()}api/events/filter/tag/`, tag);
        if (filteredEventList) {
            filteredEventList.subscribe((/**
             * @param {?} events
             * @return {?}
             */
            events => {
                this.eventsContainer.replaceAll(events);
            }));
        }
        return filteredEventList;
    }
    /**
     * @param {?} eventId
     * @param {?} attachmentId
     * @return {?}
     */
    addAttachmentToEvent(eventId, attachmentId) {
        return this.http.put(`${this.urlProvider.getUrl()}api/events/${eventId}/attachments/${attachmentId}`, {});
    }
    /**
     * @param {?} eventId
     * @param {?} attachmentId
     * @return {?}
     */
    deleteAttachment(eventId, attachmentId) {
        return __awaiter(this, void 0, void 0, function* () {
            return yield this.http.delete(`${this.urlProvider.getUrl()}api/events/${eventId}/attachment/${attachmentId}`, {}).toPromise();
        });
    }
}
EventsService.decorators = [
    { type: Injectable, args: [{
                providedIn: 'root'
            },] }
];
/** @nocollapse */
EventsService.ctorParameters = () => [
    { type: HttpClient },
    { type: UserDetailsService },
    { type: ApiUrlProvider }
];
/** @nocollapse */ EventsService.ngInjectableDef = ɵɵdefineInjectable({ factory: function EventsService_Factory() { return new EventsService(ɵɵinject(HttpClient), ɵɵinject(UserDetailsService), ɵɵinject(ApiUrlProvider)); }, token: EventsService, providedIn: "root" });
if (false) {
    /**
     * @type {?}
     * @private
     */
    EventsService.prototype.eventsContainer;
    /**
     * @type {?}
     * @private
     */
    EventsService.prototype.http;
    /**
     * @type {?}
     * @private
     */
    EventsService.prototype.userDetailsService;
    /**
     * @type {?}
     * @private
     */
    EventsService.prototype.urlProvider;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/**
 * Created by yana on 25.04.18.
 */
class GoogleGeocoderService {
    /**
     * @param {?} http
     */
    constructor(http) {
        this.http = http;
        this.google_api_key = 'AIzaSyDSpY2u6qFKILrAsYTTSzfFhcz_xk3WQvY';
        this.base_url = 'https://maps.googleapis.com/maps/api/';
    }
    /**
     * @param {?} latitude
     * @param {?} longitude
     * @return {?}
     */
    findAddress(latitude, longitude) {
        return this.http
            .get(`${this.base_url}geocode/json?latlng=${latitude},${longitude}&key=${this.google_api_key}`, { withCredentials: false }).pipe(map((/**
         * @param {?} response
         * @return {?}
         */
        response => {
            return this.parseAddress(response);
        })));
    }
    /**
     * @private
     * @param {?} json
     * @return {?}
     */
    parseAddress(json) {
        return json['results'][0]['formatted_address'];
    }
    /**
     * @param {?} latitude
     * @param {?} longitude
     * @return {?}
     */
    findCity(latitude, longitude) {
        return this.http
            .get(`${this.base_url}geocode/json?latlng=${latitude},${longitude}&key=${this.google_api_key}`);
    }
}
GoogleGeocoderService.decorators = [
    { type: Injectable, args: [{
                providedIn: 'root'
            },] }
];
/** @nocollapse */
GoogleGeocoderService.ctorParameters = () => [
    { type: HttpClient }
];
/** @nocollapse */ GoogleGeocoderService.ngInjectableDef = ɵɵdefineInjectable({ factory: function GoogleGeocoderService_Factory() { return new GoogleGeocoderService(ɵɵinject(HttpClient)); }, token: GoogleGeocoderService, providedIn: "root" });
if (false) {
    /**
     * @type {?}
     * @private
     */
    GoogleGeocoderService.prototype.google_api_key;
    /**
     * @type {?}
     * @private
     */
    GoogleGeocoderService.prototype.base_url;
    /**
     * @type {?}
     * @private
     */
    GoogleGeocoderService.prototype.http;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class LocationChangeService {
    constructor() {
        this.subject = new Subject();
    }
    /**
     * @param {?} location
     * @return {?}
     */
    changeLocation(location) {
        this.subject.next(location);
    }
}
LocationChangeService.decorators = [
    { type: Injectable, args: [{
                providedIn: 'root'
            },] }
];
/** @nocollapse */
LocationChangeService.ctorParameters = () => [];
/** @nocollapse */ LocationChangeService.ngInjectableDef = ɵɵdefineInjectable({ factory: function LocationChangeService_Factory() { return new LocationChangeService(); }, token: LocationChangeService, providedIn: "root" });
if (false) {
    /** @type {?} */
    LocationChangeService.prototype.subject;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class ParticipantsService {
    /**
     * @param {?} http
     * @param {?} urlProvider
     */
    constructor(http, urlProvider) {
        this.http = http;
        this.urlProvider = urlProvider;
    }
    /**
     * @param {?} participantsCount
     * @param {?} participantsLimit
     * @return {?}
     */
    formattedParticipantsStr(participantsCount, participantsLimit) {
        return this.isParticipantsCountLimited(participantsLimit)
            ? `${participantsCount}/${participantsLimit}`
            : `${participantsCount}`;
    }
    /**
     * @param {?} participantsCount
     * @param {?} participantsLimit
     * @return {?}
     */
    placesNotAvailable(participantsCount, participantsLimit) {
        return this.isParticipantsCountLimited(participantsLimit) && participantsCount >= participantsLimit;
    }
    /**
     * @param {?} participantsLimit
     * @return {?}
     */
    isParticipantsCountLimited(participantsLimit) {
        return participantsLimit > 0;
    }
}
ParticipantsService.decorators = [
    { type: Injectable, args: [{
                providedIn: 'root'
            },] }
];
/** @nocollapse */
ParticipantsService.ctorParameters = () => [
    { type: HttpClient },
    { type: ApiUrlProvider }
];
/** @nocollapse */ ParticipantsService.ngInjectableDef = ɵɵdefineInjectable({ factory: function ParticipantsService_Factory() { return new ParticipantsService(ɵɵinject(HttpClient), ɵɵinject(ApiUrlProvider)); }, token: ParticipantsService, providedIn: "root" });
if (false) {
    /**
     * @type {?}
     * @private
     */
    ParticipantsService.prototype.http;
    /**
     * @type {?}
     * @private
     */
    ParticipantsService.prototype.urlProvider;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class DisableDirective {
    /**
     * @return {?}
     */
    disableClick() {
        console.log(this.elementRef.nativeElement);
    }
}
DisableDirective.decorators = [
    { type: Directive, args: [{
                selector: '[qslDisable]'
            },] }
];
DisableDirective.propDecorators = {
    elementRef: [{ type: ViewChild, args: ['mat-button', { static: false },] }],
    disableClick: [{ type: HostListener, args: ['click',] }]
};
if (false) {
    /** @type {?} */
    DisableDirective.prototype.elementRef;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class DirectiveModule {
}
DirectiveModule.decorators = [
    { type: NgModule, args: [{
                declarations: [DisableDirective]
            },] }
];

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class QQEventModule {
}
QQEventModule.decorators = [
    { type: NgModule, args: [{
                declarations: [
                    NextTimeEvents,
                    NotPublished,
                    PublishedEvents,
                    SortByDatePipe
                ],
                exports: [
                    NextTimeEvents,
                    NotPublished,
                    PublishedEvents,
                    SortByDatePipe
                ],
                imports: [
                    DirectiveModule
                ]
            },] }
];

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class SaveRequestNotificator {
    constructor() {
        this.requestSubject = new Subject();
        this.requestLifecycle = this.requestSubject.asObservable();
    }
    /**
     * @param {?} show
     * @return {?}
     */
    notify(show) {
        this.requestSubject.next(show);
    }
}
SaveRequestNotificator.decorators = [
    { type: Injectable, args: [{
                providedIn: 'root'
            },] }
];
/** @nocollapse */
SaveRequestNotificator.ctorParameters = () => [];
/** @nocollapse */ SaveRequestNotificator.ngInjectableDef = ɵɵdefineInjectable({ factory: function SaveRequestNotificator_Factory() { return new SaveRequestNotificator(); }, token: SaveRequestNotificator, providedIn: "root" });
if (false) {
    /**
     * @type {?}
     * @private
     */
    SaveRequestNotificator.prototype.requestSubject;
    /** @type {?} */
    SaveRequestNotificator.prototype.requestLifecycle;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class ProgressInterceptor {
    /**
     * @param {?} loader
     */
    constructor(loader) {
        this.loader = loader;
    }
    /**
     * @param {?} req
     * @param {?} next
     * @return {?}
     */
    intercept(req, next) {
        /** @type {?} */
        const condition = this.conditionSpining(req);
        if (condition) {
            this.showSaveIndicator();
        }
        console.log();
        return next
            .handle(req).pipe(tap((/**
         * @param {?} event
         * @return {?}
         */
        event => {
            if (event instanceof HttpResponse && condition) {
                this.hideSaveIndicator();
            }
        })), catchError((/**
         * @param {?} e
         * @return {?}
         */
        (e) => {
            this.errorMessage();
            return throwError(e);
        })));
    }
    /**
     * @param {?} req
     * @return {?}
     */
    conditionSpining(req) {
        return (req.method === 'POST' || req.method === 'DELETE' || req.method === 'PUT');
    }
    /**
     * @return {?}
     */
    showSaveIndicator() {
        this.loader.notify(true);
    }
    /**
     * @return {?}
     */
    hideSaveIndicator() {
        this.loader.notify(false);
    }
    /**
     * @return {?}
     */
    errorMessage() {
        this.loader.notify(null);
    }
}
ProgressInterceptor.decorators = [
    { type: Injectable }
];
/** @nocollapse */
ProgressInterceptor.ctorParameters = () => [
    { type: SaveRequestNotificator }
];
if (false) {
    /**
     * @type {?}
     * @private
     */
    ProgressInterceptor.prototype.loader;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class ErrorForbiddenPageInterceptor {
    /**
     * @param {?} router
     */
    constructor(router) {
        this.router = router;
    }
    /**
     * @param {?} req
     * @param {?} next
     * @return {?}
     */
    intercept(req, next) {
        return next
            .handle(req).pipe(tap((/**
         * @return {?}
         */
        () => { })), catchError((/**
         * @param {?} e
         * @return {?}
         */
        (e) => {
            if (e['status'] === 403) {
                this.router.navigate(['forbidden']);
            }
            return throwError(e);
        })));
    }
}
ErrorForbiddenPageInterceptor.decorators = [
    { type: Injectable }
];
/** @nocollapse */
ErrorForbiddenPageInterceptor.ctorParameters = () => [
    { type: Router }
];
if (false) {
    /**
     * @type {?}
     * @private
     */
    ErrorForbiddenPageInterceptor.prototype.router;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class ErrorNotFoundPageInterceptor {
    /**
     * @param {?} router
     */
    constructor(router) {
        this.router = router;
    }
    /**
     * @param {?} req
     * @param {?} next
     * @return {?}
     */
    intercept(req, next) {
        return next
            .handle(req).pipe(tap((/**
         * @return {?}
         */
        () => { })), catchError((/**
         * @param {?} e
         * @return {?}
         */
        (e) => {
            if (e['status'] === 404) {
                this.router.navigate(['error']);
            }
            return throwError(e);
        })));
    }
}
ErrorNotFoundPageInterceptor.decorators = [
    { type: Injectable }
];
/** @nocollapse */
ErrorNotFoundPageInterceptor.ctorParameters = () => [
    { type: Router }
];
if (false) {
    /**
     * @type {?}
     * @private
     */
    ErrorNotFoundPageInterceptor.prototype.router;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class FilterByPredicatePipe {
    /**
     * @param {?} fields
     * @param {?} predicate
     * @return {?}
     */
    transform(fields, predicate) {
        return fields.filter((/**
         * @param {?} e
         * @return {?}
         */
        (e) => predicate(e)));
    }
}
FilterByPredicatePipe.decorators = [
    { type: Pipe, args: [{
                name: 'filterByPredicate',
                pure: false
            },] }
];

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class ProgressLoaderComponent {
    /**
     * @param {?} requestNotificator
     */
    constructor(requestNotificator) {
        this.requestNotificator = requestNotificator;
        this.showSpiner = false;
        this.showSuccess = false;
        this.showError = false;
        this.startSaveProcess = false;
        this.count = 0;
    }
    /**
     * @return {?}
     */
    ngOnInit() {
        this.requestNotificator.requestLifecycle.subscribe((/**
         * @param {?} startSaveProcess
         * @return {?}
         */
        startSaveProcess => {
            this.startSaveProcess = startSaveProcess;
            this.turnOnSaveIndicator();
        }));
    }
    /**
     * @return {?}
     */
    zeroingCountOfRequest() {
        if (this.startSaveProcess) {
            this.count++;
        }
        else {
            if (!this.startSaveProcess) {
                --this.count;
            }
        }
    }
    /**
     * @return {?}
     */
    setIndicators() {
        if (this.count !== 0) {
            this.showSpiner = true;
            this.showSuccess = false;
            this.showError = false;
        }
        else {
            if (this.count === 0) {
                setTimeout((/**
                 * @return {?}
                 */
                () => {
                    this.showSpiner = false;
                    this.showError = false;
                    this.showSuccess = true;
                    setTimeout((/**
                     * @return {?}
                     */
                    () => {
                        this.showSuccess = false;
                    }), 1000);
                }), 1000);
            }
        }
    }
    /**
     * @return {?}
     */
    errorIndicator() {
        this.count--;
        this.showSpiner = true;
        this.showSuccess = false;
        this.showError = false;
        setTimeout((/**
         * @return {?}
         */
        () => {
            this.showSpiner = false;
            this.showError = true;
            setTimeout((/**
             * @return {?}
             */
            () => {
                this.showError = false;
            }), 1000);
        }), 2000);
    }
    /**
     * @return {?}
     */
    turnOnSaveIndicator() {
        if (this.startSaveProcess != null) {
            this.zeroingCountOfRequest();
            this.setIndicators();
        }
        else {
            this.errorIndicator();
        }
    }
}
ProgressLoaderComponent.decorators = [
    { type: Component, args: [{
                selector: 'qsl-progress-loader',
                template: "<mat-progress-spinner mode=\"indeterminate\" diameter=\"30\" strokeWidth=\"3\" [style.display]=\"showSpiner ? 'block' : 'none'\">\n</mat-progress-spinner>\n<mat-icon    [style.display]=\"showSuccess ? 'block' : 'none'\"\n             [style.animation-name]=\"showSuccess ? 'trans' : 'none'\">check_circle</mat-icon>\n<mat-icon    [style.display]=\"showError ? 'block' : 'none'\"\n             [style.animation-name]=\"showSuccess ? 'trans' : 'none'\">highlight_off</mat-icon>\n\n",
                styles: [".mat-spinner circle,::ng-deep .mat-progress-spinner circle{stroke:#9b9b9b;position:absolute}.mat-icon{height:30px!important;width:30px!important;font-size:30px;color:#9b9b9b;-webkit-animation-delay:.5s;animation-delay:.5s;-webkit-animation-duration:1s;animation-duration:1s}@-webkit-keyframes trans{from{opacity:1}to{opacity:0}}@keyframes trans{from{opacity:1}to{opacity:0}}"]
            }] }
];
/** @nocollapse */
ProgressLoaderComponent.ctorParameters = () => [
    { type: SaveRequestNotificator }
];
if (false) {
    /** @type {?} */
    ProgressLoaderComponent.prototype.showSpiner;
    /** @type {?} */
    ProgressLoaderComponent.prototype.showSuccess;
    /** @type {?} */
    ProgressLoaderComponent.prototype.showError;
    /** @type {?} */
    ProgressLoaderComponent.prototype.startSaveProcess;
    /** @type {?} */
    ProgressLoaderComponent.prototype.count;
    /**
     * @type {?}
     * @private
     */
    ProgressLoaderComponent.prototype.requestNotificator;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class PipesModule {
}
PipesModule.decorators = [
    { type: NgModule, args: [{
                declarations: [
                    FilterByPredicatePipe
                ],
                exports: [
                    FilterByPredicatePipe
                ]
            },] }
];

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class ProgressModule {
}
ProgressModule.decorators = [
    { type: NgModule, args: [{
                imports: [
                    MatIconModule,
                    MatProgressSpinnerModule
                ],
                declarations: [
                    ProgressLoaderComponent
                ],
                exports: [
                    ProgressLoaderComponent
                ]
            },] }
];

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/**
 * Created by yana on 26.04.18.
 */
class Question {
}
if (false) {
    /** @type {?} */
    Question.prototype.id;
    /** @type {?} */
    Question.prototype.votes;
    /** @type {?} */
    Question.prototype.content;
    /** @type {?} */
    Question.prototype.questionStatus;
    /** @type {?} */
    Question.prototype.authorDisplayName;
    /** @type {?} */
    Question.prototype.authorUserName;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/** @enum {number} */
const Status = {
    NEW: 0, OPENED: 1, CLOSED: 2,
};
Status[Status.NEW] = 'NEW';
Status[Status.OPENED] = 'OPENED';
Status[Status.CLOSED] = 'CLOSED';

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class Vote {
}
if (false) {
    /** @type {?} */
    Vote.prototype.username;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class QuestionStatusService {
    constructor() { }
    /**
     * @param {?} isTopicPassed
     * @param {?} question
     * @return {?}
     */
    isUpcoming(isTopicPassed, question) {
        return isTopicPassed
            ? question.questionStatus === 'NEW' || question.questionStatus === 'ACTIVE'
            : question.questionStatus === 'NEW';
    }
}
QuestionStatusService.decorators = [
    { type: Injectable, args: [{
                providedIn: 'root'
            },] }
];
/** @nocollapse */
QuestionStatusService.ctorParameters = () => [];
/** @nocollapse */ QuestionStatusService.ngInjectableDef = ɵɵdefineInjectable({ factory: function QuestionStatusService_Factory() { return new QuestionStatusService(); }, token: QuestionStatusService, providedIn: "root" });

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/**
 * Created by yana on 26.04.18.
 */
class QuestionsService {
    /**
     * @param {?} http
     * @param {?} urlProvider
     */
    constructor(http, urlProvider) {
        this.http = http;
        this.urlProvider = urlProvider;
        this.questionsCollection = new BaseBehaviorSubject();
    }
    /**
     * @param {?} topicId
     * @return {?}
     */
    findAllByTopicId(topicId) {
        return this.http.get(`${this.urlProvider.getUrl()}api/topics/${topicId}/questions`)
            .pipe(tap((/**
         * @param {?} questions
         * @return {?}
         */
        questions => this.questionsCollection.replaceAll(questions))));
    }
    /**
     * @param {?} questionId
     * @return {?}
     */
    findById(questionId) {
        return this.http.get(`${this.urlProvider.getUrl()}api/questions/${questionId}`);
    }
    /**
     * @param {?} topicId
     * @param {?} question
     * @return {?}
     */
    post(topicId, question) {
        return this.http.post(`${this.urlProvider.getUrl()}api/topics/${topicId}/questions`, question);
    }
    /**
     * @param {?} questionId
     * @return {?}
     */
    vote(questionId) {
        return this.http.post(`${this.urlProvider.getUrl()}api/questions/${questionId}/vote`, null);
    }
    /**
     * @param {?} questionId
     * @return {?}
     */
    removeVote(questionId) {
        return this.http.post(`${this.urlProvider.getUrl()}api/questions/${questionId}/unvote`, null);
    }
    /**
     * @param {?} questionId
     * @return {?}
     */
    delete(questionId) {
        return this.http.delete(`${this.urlProvider.getUrl()}api/questions/${questionId}`);
    }
    /**
     * @param {?} questionId
     * @return {?}
     */
    open(questionId) {
        return this.http.post(`${this.urlProvider.getUrl()}api/questions/${questionId}/open`, null);
    }
    /**
     * @param {?} questionId
     * @return {?}
     */
    close(questionId) {
        return this.http.post(`${this.urlProvider.getUrl()}api/questions/${questionId}/close`, null);
    }
}
QuestionsService.decorators = [
    { type: Injectable, args: [{
                providedIn: 'root'
            },] }
];
/** @nocollapse */
QuestionsService.ctorParameters = () => [
    { type: HttpClient },
    { type: ApiUrlProvider }
];
/** @nocollapse */ QuestionsService.ngInjectableDef = ɵɵdefineInjectable({ factory: function QuestionsService_Factory() { return new QuestionsService(ɵɵinject(HttpClient), ɵɵinject(ApiUrlProvider)); }, token: QuestionsService, providedIn: "root" });
if (false) {
    /** @type {?} */
    QuestionsService.prototype.questionsCollection;
    /**
     * @type {?}
     * @private
     */
    QuestionsService.prototype.http;
    /**
     * @type {?}
     * @private
     */
    QuestionsService.prototype.urlProvider;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class Oauth2Service {
    /**
     * @param {?} http
     * @param {?} urlProvider
     * @param {?} userDetailsService
     */
    constructor(http, urlProvider, userDetailsService) {
        this.http = http;
        this.urlProvider = urlProvider;
        this.userDetailsService = userDetailsService;
        this.basicAuthToken = 'Basic Y29uZmFzc2lzdGFudDpzZWNyZXQ=';
    }
    /**
     * @param {?} userId
     * @param {?} displayName
     * @param {?} image
     * @return {?}
     */
    authorize(userId, displayName, image) {
        return this.registerUser(userId, displayName, image).pipe(concatMap((/**
         * @param {?} user
         * @return {?}
         */
        (user) => this.authenticate(user['username'], user['password']))));
    }
    /**
     * @param {?} userId
     * @param {?} displayName
     * @param {?} image
     * @return {?}
     */
    authorizeAdmin(userId, displayName, image) {
        return this.registerAdmin(userId, displayName, image).pipe(concatMap((/**
         * @param {?} admin
         * @return {?}
         */
        (admin) => this.authenticate(admin['username'], admin['password']))));
    }
    /**
     * @param {?} username
     * @param {?} password
     * @return {?}
     */
    authenticate(username, password) {
        return this.requestToken(username, password).pipe(concatMap((/**
         * @param {?} authData
         * @return {?}
         */
        (authData) => this.parseAndSaveAuthData(authData))), concatMap((/**
         * @return {?}
         */
        () => this.requestUserInfo())), concatMap((/**
         * @param {?} user
         * @return {?}
         */
        user => this.userDetailsService.setCurrentUserDisplayName(user['displayName']).pipe(concatMap((/**
         * @return {?}
         */
        () => this.userDetailsService.setCurrentUserUsername(user['username']))), concatMap((/**
         * @return {?}
         */
        () => this.userDetailsService.setCurrentUserRole(user['role'])))))));
    }
    /**
     * @return {?}
     */
    logout() {
        return this.userDetailsService.clearCurrentUserDetails();
    }
    /**
     * @param {?} username
     * @param {?} password
     * @return {?}
     */
    requestToken(username, password) {
        return this.http.post(`${this.urlProvider.getUrl()}oauth/token`, `grant_type=password&username=${username}&password=${password}`, { headers: { 'Content-Type': 'application/x-www-form-urlencoded' }, withCredentials: true });
    }
    /**
     * @return {?}
     */
    requestUserInfo() {
        return this.http.get(`${this.urlProvider.getUrl()}users/me`);
    }
    /**
     * @return {?}
     */
    refreshToken() {
        return this.userDetailsService.getCurrentUserRefreshToken().pipe(concatMap((/**
         * @param {?} refreshToken
         * @return {?}
         */
        refreshToken => {
            return this.http.post(`${this.urlProvider.getUrl()}oauth/token`, `grant_type=refresh_token&refresh_token=${refreshToken}`, { headers: { 'Content-Type': 'application/x-www-form-urlencoded' }, withCredentials: true });
        })), concatMap((/**
         * @param {?} authData
         * @return {?}
         */
        authData => {
            if (authData) {
                return this.parseAndSaveAuthData(authData);
            }
        })));
    }
    /**
     * @private
     * @param {?} username
     * @param {?} displayName
     * @param {?} image
     * @return {?}
     */
    registerUser(username, displayName, image) {
        return this.http.post(`${this.urlProvider.getUrl()}users/register`, {
            'username': username,
            'displayName': displayName,
            'image': image
        });
    }
    /**
     * @private
     * @param {?} username
     * @param {?} displayName
     * @param {?} image
     * @return {?}
     */
    registerAdmin(username, displayName, image) {
        return this.http.post(`${this.urlProvider.getUrl()}users/register/admin`, {
            'username': username,
            'displayName': displayName,
            'image': image
        });
    }
    /**
     * @param {?} authData
     * @return {?}
     */
    parseAndSaveAuthData(authData) {
        /** @type {?} */
        const accessToken = authData['access_token'];
        /** @type {?} */
        const refreshToken = authData['refresh_token'];
        return this.userDetailsService.setCurrentUserAccessToken(accessToken).pipe(concatMap((/**
         * @return {?}
         */
        () => this.userDetailsService.setCurrentUserRefreshToken(refreshToken))));
    }
    /**
     * @return {?}
     */
    isAuthenticated() {
        return this.userDetailsService.getCurrentUserAccessToken().pipe(map((/**
         * @param {?} accessToken
         * @return {?}
         */
        accessToken => accessToken !== null)));
    }
}
Oauth2Service.decorators = [
    { type: Injectable, args: [{
                providedIn: 'root'
            },] }
];
/** @nocollapse */
Oauth2Service.ctorParameters = () => [
    { type: HttpClient },
    { type: ApiUrlProvider },
    { type: UserDetailsService }
];
/** @nocollapse */ Oauth2Service.ngInjectableDef = ɵɵdefineInjectable({ factory: function Oauth2Service_Factory() { return new Oauth2Service(ɵɵinject(HttpClient), ɵɵinject(ApiUrlProvider), ɵɵinject(UserDetailsService)); }, token: Oauth2Service, providedIn: "root" });
if (false) {
    /** @type {?} */
    Oauth2Service.prototype.basicAuthToken;
    /**
     * @type {?}
     * @private
     */
    Oauth2Service.prototype.http;
    /**
     * @type {?}
     * @private
     */
    Oauth2Service.prototype.urlProvider;
    /**
     * @type {?}
     * @private
     */
    Oauth2Service.prototype.userDetailsService;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class StreamService {
    /**
     * @param {?} http
     * @param {?} urlProvider
     */
    constructor(http, urlProvider) {
        this.http = http;
        this.urlProvider = urlProvider;
    }
    /**
     * @param {?} streamId
     * @return {?}
     */
    getStreamById(streamId) {
        return this.http.get(`${this.urlProvider.getUrl()}api/streams/${streamId}`);
    }
    /**
     * @param {?} eventId
     * @return {?}
     */
    getStreamsByEvent(eventId) {
        return this.http.get(`${this.urlProvider.getUrl()}api/events/${eventId}/streams`);
    }
    /**
     * @param {?} eventId
     * @param {?} stream
     * @return {?}
     */
    add(eventId, stream) {
        return this.http.post(`${this.urlProvider.getUrl()}api/events/${eventId}/streams/`, stream);
    }
    /**
     * @param {?} stream
     * @return {?}
     */
    update(stream) {
        return this.http.put(`${this.urlProvider.getUrl()}api/streams/`, stream);
    }
    /**
     * @param {?} stream
     * @return {?}
     */
    delete(stream) {
        return this.http.delete(`${this.urlProvider.getUrl()}api/streams/${stream.id}`);
    }
}
StreamService.decorators = [
    { type: Injectable, args: [{
                providedIn: 'root'
            },] }
];
/** @nocollapse */
StreamService.ctorParameters = () => [
    { type: HttpClient },
    { type: ApiUrlProvider }
];
/** @nocollapse */ StreamService.ngInjectableDef = ɵɵdefineInjectable({ factory: function StreamService_Factory() { return new StreamService(ɵɵinject(HttpClient), ɵɵinject(ApiUrlProvider)); }, token: StreamService, providedIn: "root" });
if (false) {
    /**
     * @type {?}
     * @private
     */
    StreamService.prototype.http;
    /**
     * @type {?}
     * @private
     */
    StreamService.prototype.urlProvider;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class AdminAuthGuard {
    /**
     * @param {?} userDetailsService
     * @param {?} oauthService
     * @param {?} streamService
     * @param {?} router
     */
    constructor(userDetailsService, oauthService, streamService, router) {
        this.userDetailsService = userDetailsService;
        this.oauthService = oauthService;
        this.streamService = streamService;
        this.router = router;
    }
    /**
     * @param {?} route
     * @return {?}
     */
    canActivate(route) {
        return this.userDetailsService.getCurrentUserRole().pipe(map((/**
         * @param {?} userRole
         * @return {?}
         */
        userRole => {
            if (!userRole || userRole !== route.data.expectedRole) {
                this.redirectToLogin();
                return false;
            }
            return true;
        })));
    }
    /**
     * @private
     * @return {?}
     */
    redirectToLogin() {
        this.router.navigate(['login']);
    }
}
AdminAuthGuard.decorators = [
    { type: Injectable, args: [{
                providedIn: 'root'
            },] }
];
/** @nocollapse */
AdminAuthGuard.ctorParameters = () => [
    { type: UserDetailsService },
    { type: Oauth2Service },
    { type: StreamService },
    { type: Router }
];
/** @nocollapse */ AdminAuthGuard.ngInjectableDef = ɵɵdefineInjectable({ factory: function AdminAuthGuard_Factory() { return new AdminAuthGuard(ɵɵinject(UserDetailsService), ɵɵinject(Oauth2Service), ɵɵinject(StreamService), ɵɵinject(Router)); }, token: AdminAuthGuard, providedIn: "root" });
if (false) {
    /**
     * @type {?}
     * @private
     */
    AdminAuthGuard.prototype.userDetailsService;
    /**
     * @type {?}
     * @private
     */
    AdminAuthGuard.prototype.oauthService;
    /**
     * @type {?}
     * @private
     */
    AdminAuthGuard.prototype.streamService;
    /**
     * @type {?}
     * @private
     */
    AdminAuthGuard.prototype.router;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class ClientAuthGuard {
    /**
     * @param {?} authService
     * @param {?} streamService
     * @param {?} router
     */
    constructor(authService, streamService, router) {
        this.authService = authService;
        this.streamService = streamService;
        this.router = router;
    }
    /**
     * @param {?} next
     * @param {?} state
     * @return {?}
     */
    canActivate(next, state) {
        return true;
        // this.authService.isAuthenticated().pipe(
        //   tap(authenticated => {
        //     if (!authenticated) {
        //       this.router.navigate(['login'], { queryParams: { returnUrl: state.url }});
        //     }
        //   }));
    }
}
ClientAuthGuard.decorators = [
    { type: Injectable, args: [{
                providedIn: 'root'
            },] }
];
/** @nocollapse */
ClientAuthGuard.ctorParameters = () => [
    { type: Oauth2Service },
    { type: StreamService },
    { type: Router }
];
/** @nocollapse */ ClientAuthGuard.ngInjectableDef = ɵɵdefineInjectable({ factory: function ClientAuthGuard_Factory() { return new ClientAuthGuard(ɵɵinject(Oauth2Service), ɵɵinject(StreamService), ɵɵinject(Router)); }, token: ClientAuthGuard, providedIn: "root" });
if (false) {
    /**
     * @type {?}
     * @private
     */
    ClientAuthGuard.prototype.authService;
    /**
     * @type {?}
     * @private
     */
    ClientAuthGuard.prototype.streamService;
    /**
     * @type {?}
     * @private
     */
    ClientAuthGuard.prototype.router;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
// import {AuthService} from 'angularx-social-login';
class LoginPageGuard {
    /**
     * @param {?} authService
     * @param {?} router
     */
    constructor(authService, router) {
        this.authService = authService;
        this.router = router;
    }
    /**
     * @param {?} next
     * @param {?} state
     * @return {?}
     */
    canActivate(next, state) {
        return true;
        // this.authService.isAuthenticated().pipe(
        //   tap(authenticated => {
        //     if (authenticated) {
        //       this.router.navigate(next.data.destinationRoute);
        //     }
        //   }),
        //   map(authentificated => !authentificated ),);
    }
}
LoginPageGuard.decorators = [
    { type: Injectable, args: [{
                providedIn: 'root'
            },] }
];
/** @nocollapse */
LoginPageGuard.ctorParameters = () => [
    { type: Oauth2Service },
    { type: Router }
];
/** @nocollapse */ LoginPageGuard.ngInjectableDef = ɵɵdefineInjectable({ factory: function LoginPageGuard_Factory() { return new LoginPageGuard(ɵɵinject(Oauth2Service), ɵɵinject(Router)); }, token: LoginPageGuard, providedIn: "root" });
if (false) {
    /**
     * @type {?}
     * @private
     */
    LoginPageGuard.prototype.authService;
    /**
     * @type {?}
     * @private
     */
    LoginPageGuard.prototype.router;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class AuthInterceptor {
    /**
     * @param {?} authService
     * @param {?} userDetailsService
     * @param {?} router
     */
    constructor(authService, userDetailsService, router) {
        this.authService = authService;
        this.userDetailsService = userDetailsService;
        this.router = router;
    }
    /**
     * @param {?} originRequest
     * @param {?} next
     * @return {?}
     */
    intercept(originRequest, next) {
        return this.addAuthHeader(originRequest).pipe(concatMap((/**
         * @param {?} request
         * @return {?}
         */
        request => next.handle(request))), catchError((/**
         * @param {?} error
         * @return {?}
         */
        error => {
            switch (error.status) {
                case 401:
                    return this.handle401Error(originRequest, next);
                case 400:
                    return this.handle401Error(originRequest, next);
                default:
                    return throwError(error);
            }
        })));
    }
    /**
     * @param {?} originRequest
     * @param {?} next
     * @return {?}
     */
    handle401Error(originRequest, next) {
        return this.authService.refreshToken().pipe(concatMap((/**
         * @param {?} success
         * @return {?}
         */
        (success) => {
            if (success) {
                return this.addAuthHeader(originRequest).pipe(concatMap((/**
                 * @param {?} request
                 * @return {?}
                 */
                request => next.handle(request))));
            }
        })), catchError((/**
         * @return {?}
         */
        () => this.logout())));
    }
    /**
     * @private
     * @param {?} request
     * @return {?}
     */
    addAuthHeader(request) {
        /** @type {?} */
        const url = request.url;
        if (url.includes('users/register')
            || url.includes('oauth/token') || request.method === 'GET') {
            return Observable.create((/**
             * @param {?} observer
             * @return {?}
             */
            observer => {
                /** @type {?} */
                const headers = request.headers.set('Authorization', this.authService.basicAuthToken);
                observer.next(request.clone({ headers: headers }));
                observer.complete();
            }));
        }
        else if (!url.includes('maps.googleapis.com') && (url.includes('/api/') || url.includes('/users/me'))) {
            return this.userDetailsService.getCurrentUserAccessToken().pipe(map((/**
             * @param {?} accessToken
             * @return {?}
             */
            (accessToken) => {
                /** @type {?} */
                const headers = request.headers.set('Authorization', `bearer ${accessToken}`);
                return request.clone({ headers: headers });
            })));
        }
        else {
            return of(request);
        }
    }
    /**
     * @private
     * @return {?}
     */
    logout() {
        return this.authService.logout().pipe(concatMap((/**
         * @return {?}
         */
        () => this.router.navigate(['login']))));
    }
}
AuthInterceptor.decorators = [
    { type: Injectable, args: [{
                providedIn: 'root'
            },] }
];
/** @nocollapse */
AuthInterceptor.ctorParameters = () => [
    { type: Oauth2Service },
    { type: UserDetailsService },
    { type: Router }
];
/** @nocollapse */ AuthInterceptor.ngInjectableDef = ɵɵdefineInjectable({ factory: function AuthInterceptor_Factory() { return new AuthInterceptor(ɵɵinject(Oauth2Service), ɵɵinject(UserDetailsService), ɵɵinject(Router)); }, token: AuthInterceptor, providedIn: "root" });
if (false) {
    /**
     * @type {?}
     * @private
     */
    AuthInterceptor.prototype.authService;
    /**
     * @type {?}
     * @private
     */
    AuthInterceptor.prototype.userDetailsService;
    /**
     * @type {?}
     * @private
     */
    AuthInterceptor.prototype.router;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/**
 * Created by yana on 25.04.18.
 */
class Speaker {
}
if (false) {
    /** @type {?} */
    Speaker.prototype.username;
    /** @type {?} */
    Speaker.prototype.email;
    /** @type {?} */
    Speaker.prototype.displayName;
    /** @type {?} */
    Speaker.prototype.image;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class SpeakersService {
    /**
     * @param {?} http
     * @param {?} urlProvider
     */
    constructor(http, urlProvider) {
        this.http = http;
        this.urlProvider = urlProvider;
    }
    /**
     * @param {?} eventId
     * @return {?}
     */
    findAllByEvent(eventId) {
        return this.http.get(`${this.urlProvider.getUrl()}users/events/${eventId}/speakers`);
    }
    /**
     * @param {?} topicId
     * @return {?}
     */
    findAllByTopic(topicId) {
        return this.http.get(`${this.urlProvider.getUrl()}users/topics/${topicId}/speakers`);
    }
    /**
     * @return {?}
     */
    findAll() {
        return this.http.get(`${this.urlProvider.getUrl()}users/public`);
    }
    /**
     * @param {?} eventId
     * @return {?}
     */
    findAllEventUsers(eventId) {
        return this.http.get(`${this.urlProvider.getUrl()}users/events/${eventId}/all`);
    }
}
SpeakersService.decorators = [
    { type: Injectable, args: [{
                providedIn: 'root'
            },] }
];
/** @nocollapse */
SpeakersService.ctorParameters = () => [
    { type: HttpClient },
    { type: ApiUrlProvider }
];
/** @nocollapse */ SpeakersService.ngInjectableDef = ɵɵdefineInjectable({ factory: function SpeakersService_Factory() { return new SpeakersService(ɵɵinject(HttpClient), ɵɵinject(ApiUrlProvider)); }, token: SpeakersService, providedIn: "root" });
if (false) {
    /**
     * @type {?}
     * @private
     */
    SpeakersService.prototype.http;
    /**
     * @type {?}
     * @private
     */
    SpeakersService.prototype.urlProvider;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class Stream {
    /**
     * @param {?} id
     * @param {?} location
     * @param {?} name
     * @param {?} topics
     */
    constructor(id, location, name, topics) {
        this.id = id;
        this.location = location;
        this.name = name;
        this.topics = topics;
    }
}
if (false) {
    /** @type {?} */
    Stream.prototype.id;
    /** @type {?} */
    Stream.prototype.location;
    /** @type {?} */
    Stream.prototype.name;
    /** @type {?} */
    Stream.prototype.topics;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class StreamEvent {
    /**
     * @param {?} event_
     * @param {?} stream_
     */
    constructor(event_, stream_) {
        this.eventType = event_;
        this.stream = stream_;
    }
}
if (false) {
    /** @type {?} */
    StreamEvent.prototype.eventType;
    /** @type {?} */
    StreamEvent.prototype.stream;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/** @enum {number} */
const StreamEventType = {
    delete: 0,
    add: 1,
};
StreamEventType[StreamEventType.delete] = 'delete';
StreamEventType[StreamEventType.add] = 'add';

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class StreamEventService {
    constructor() {
        this.subject = new Subject();
    }
    /**
     * @param {?} stream
     * @return {?}
     */
    addEvent(stream) {
        this.subject.next(new StreamEvent(StreamEventType.add, stream));
    }
    /**
     * @param {?} stream
     * @return {?}
     */
    deleteEvent(stream) {
        this.subject.next(new StreamEvent(StreamEventType.delete, stream));
    }
    /**
     * @return {?}
     */
    getEvent() {
        return this.subject;
    }
}
StreamEventService.decorators = [
    { type: Injectable, args: [{
                providedIn: 'root'
            },] }
];
/** @nocollapse */
StreamEventService.ctorParameters = () => [];
/** @nocollapse */ StreamEventService.ngInjectableDef = ɵɵdefineInjectable({ factory: function StreamEventService_Factory() { return new StreamEventService(); }, token: StreamEventService, providedIn: "root" });
if (false) {
    /**
     * @type {?}
     * @private
     */
    StreamEventService.prototype.subject;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class TopilListElementDirective {
    /**
     * @param {?} elementRef
     * @param {?} render
     */
    constructor(elementRef, render) {
        this.elementRef = elementRef;
        this.render = render;
    }
    /**
     * @param {?} topicActivity
     * @return {?}
     */
    set changeColor(topicActivity) {
        if (topicActivity === 'ACTIVE') {
            this.render.setStyle(this.elementRef.nativeElement, 'background-color', '#6391E6');
            this.render.setStyle(this.elementRef.nativeElement, 'color', '#E6E4D9');
        }
    }
}
TopilListElementDirective.decorators = [
    { type: Directive, args: [{
                selector: '[backGround]'
            },] }
];
/** @nocollapse */
TopilListElementDirective.ctorParameters = () => [
    { type: ElementRef },
    { type: Renderer2 }
];
TopilListElementDirective.propDecorators = {
    changeColor: [{ type: Input, args: ['backGround',] }]
};
if (false) {
    /**
     * @type {?}
     * @private
     */
    TopilListElementDirective.prototype.elementRef;
    /**
     * @type {?}
     * @private
     */
    TopilListElementDirective.prototype.render;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class Topic {
    constructor() { }
}
if (false) {
    /** @type {?} */
    Topic.prototype.id;
    /** @type {?} */
    Topic.prototype.description;
    /** @type {?} */
    Topic.prototype.startDate;
    /** @type {?} */
    Topic.prototype.endDate;
    /** @type {?} */
    Topic.prototype.title;
    /** @type {?} */
    Topic.prototype.users;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class TopicStatusService {
    constructor() { }
    /**
     * @param {?} topic
     * @return {?}
     */
    ongoing(topic) {
        return moment(topic.startDate).isSameOrBefore(moment()) && moment(topic.endDate).isSameOrAfter(moment());
    }
    /**
     * @param {?} topic
     * @return {?}
     */
    upcoming(topic) {
        return moment(topic.startDate).isAfter(moment());
    }
    /**
     * @param {?} topic
     * @return {?}
     */
    passed(topic) {
        return moment(topic.endDate).isBefore(moment());
    }
}
TopicStatusService.decorators = [
    { type: Injectable, args: [{
                providedIn: 'root'
            },] }
];
/** @nocollapse */
TopicStatusService.ctorParameters = () => [];
/** @nocollapse */ TopicStatusService.ngInjectableDef = ɵɵdefineInjectable({ factory: function TopicStatusService_Factory() { return new TopicStatusService(); }, token: TopicStatusService, providedIn: "root" });

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class TopicService {
    /**
     * @param {?} http
     * @param {?} urlProvider
     */
    constructor(http, urlProvider) {
        this.http = http;
        this.urlProvider = urlProvider;
    }
    /**
     * @param {?} streamId
     * @return {?}
     */
    getTopics(streamId) {
        return this.http.get(`${this.urlProvider.getUrl()}api/streams/${streamId}/topics`);
    }
    /**
     * @param {?} topicId
     * @return {?}
     */
    findById(topicId) {
        return this.http.get(`${this.urlProvider.getUrl()}api/topics/${topicId}`);
    }
    /**
     * @param {?} topicId
     * @return {?}
     */
    delete(topicId) {
        return __awaiter(this, void 0, void 0, function* () {
            return yield this.http.delete(`${this.urlProvider.getUrl()}api/topics/${topicId}`)
                .toPromise();
        });
    }
    /**
     * @param {?} streamId
     * @param {?} topic
     * @return {?}
     */
    update(streamId, topic) {
        return this.http.put(`${this.urlProvider.getUrl()}api/streams/${streamId}/topics`, topic);
    }
    /**
     * @param {?} streamId
     * @param {?} topic
     * @return {?}
     */
    create(streamId, topic) {
        return __awaiter(this, void 0, void 0, function* () {
            return yield this.http.post(`${this.urlProvider.getUrl()}api/streams/${streamId}/topics`, topic)
                .toPromise();
        });
    }
}
TopicService.decorators = [
    { type: Injectable, args: [{
                providedIn: 'root'
            },] }
];
/** @nocollapse */
TopicService.ctorParameters = () => [
    { type: HttpClient },
    { type: ApiUrlProvider }
];
/** @nocollapse */ TopicService.ngInjectableDef = ɵɵdefineInjectable({ factory: function TopicService_Factory() { return new TopicService(ɵɵinject(HttpClient), ɵɵinject(ApiUrlProvider)); }, token: TopicService, providedIn: "root" });
if (false) {
    /**
     * @type {?}
     * @private
     */
    TopicService.prototype.http;
    /**
     * @type {?}
     * @private
     */
    TopicService.prototype.urlProvider;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class TopicEditService {
    constructor() {
        this.subject = new Subject();
    }
    /**
     * @param {?} topic
     * @return {?}
     */
    edit(topic) {
        this.subject.next(topic);
    }
    /**
     * @return {?}
     */
    getEditedTopic() {
        return this.subject.asObservable();
    }
}
TopicEditService.decorators = [
    { type: Injectable, args: [{
                providedIn: 'root'
            },] }
];
/** @nocollapse */
TopicEditService.ctorParameters = () => [];
/** @nocollapse */ TopicEditService.ngInjectableDef = ɵɵdefineInjectable({ factory: function TopicEditService_Factory() { return new TopicEditService(); }, token: TopicEditService, providedIn: "root" });
if (false) {
    /**
     * @type {?}
     * @private
     */
    TopicEditService.prototype.subject;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class TopicValidationService {
    constructor() { }
    /**
     * @param {?} value
     * @return {?}
     */
    isStatusValid(value) {
        return new FormControl(value, [Validators.required])['status'] === 'INVALID';
    }
    /**
     * @param {?} topicDate
     * @param {?} event
     * @return {?}
     */
    isDateOfTopicIncludeInEventRange(topicDate, event) {
        return (!moment(topicDate).set({ 'hour': 0, 'minutes': 0, 'seconds': 1 }).isBetween(moment(event.dateStart).set({ 'hour': 0, 'minutes': 0, 'seconds': 0 }).startOf('day'), moment(event.dateEnd).endOf('day')));
    }
    /**
     * @param {?} topic
     * @return {?}
     */
    isTitleNotEmpty(topic) {
        return topic.title === undefined || topic.title.length === 0;
    }
}
TopicValidationService.decorators = [
    { type: Injectable, args: [{
                providedIn: 'root'
            },] }
];
/** @nocollapse */
TopicValidationService.ctorParameters = () => [];
/** @nocollapse */ TopicValidationService.ngInjectableDef = ɵɵdefineInjectable({ factory: function TopicValidationService_Factory() { return new TopicValidationService(); }, token: TopicValidationService, providedIn: "root" });

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class SortTopicByMinutesAndHours {
    /**
     * @param {?} array
     * @return {?}
     */
    transform(array) {
        return array.sort((/**
         * @param {?} a
         * @param {?} b
         * @return {?}
         */
        (a, b) => {
            return moment(a.startDate).unix() - moment(b.startDate).unix();
        }));
    }
}
SortTopicByMinutesAndHours.decorators = [
    { type: Pipe, args: [{
                name: 'uniqueHoursminutes',
                pure: false
            },] }
];

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class SortTopicByDatesPipe {
    /**
     * @param {?} value
     * @param {?} shortDate
     * @return {?}
     */
    transform(value, shortDate) {
        return value.filter((/**
         * @param {?} it
         * @return {?}
         */
        it => {
            if (moment(it.startDate).isSame(moment(shortDate), 'day') && moment(it.startDate).isSame(moment(shortDate), 'month')) {
                return it;
            }
        }));
    }
}
SortTopicByDatesPipe.decorators = [
    { type: Pipe, args: [{
                name: 'putToDayBucket',
                pure: false
            },] }
];

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class QqTopicModule {
}
QqTopicModule.decorators = [
    { type: NgModule, args: [{
                imports: [],
                declarations: [
                    TopilListElementDirective,
                    SortTopicByDatesPipe,
                    SortTopicByMinutesAndHours,
                ],
                exports: [
                    TopilListElementDirective,
                    SortTopicByDatesPipe,
                    SortTopicByMinutesAndHours
                ]
            },] }
];

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class EventMapService {
    /**
     * @param {?} googleGeocoder
     * @param {?} changeLocationService
     */
    constructor(googleGeocoder, changeLocationService) {
        this.googleGeocoder = googleGeocoder;
        this.changeLocationService = changeLocationService;
    }
    /**
     * @param {?} eventLocation
     * @return {?}
     */
    getLocation(eventLocation) {
        if (eventLocation.latitude === 0 && eventLocation.longitude === 0) {
            navigator.geolocation.getCurrentPosition((/**
             * @param {?} postion
             * @return {?}
             */
            postion => {
                eventLocation.latitude = postion.coords.latitude;
                eventLocation.longitude = postion.coords.longitude;
            }));
        }
    }
    /**
     * @param {?} event
     * @param {?} eventLocation
     * @return {?}
     */
    changeMarker(event, eventLocation) {
        eventLocation.latitude = event.coords.lat;
        eventLocation.longitude = event.coords.lng;
        this.googleGeocoder.findAddress(eventLocation.latitude, eventLocation.longitude).subscribe((/**
         * @param {?} value
         * @return {?}
         */
        value => {
            eventLocation.formattedAddress = value;
            this.changeLocationService.changeLocation(eventLocation);
        }));
        this.googleGeocoder.findCity(eventLocation.latitude, eventLocation.longitude).subscribe((/**
         * @param {?} mapResponse
         * @return {?}
         */
        mapResponse => {
            eventLocation.placeId = mapResponse['results'][0].place_id;
            console.log(eventLocation.placeId);
            console.log(mapResponse['results'][0].place_id);
            mapResponse['results'][0].address_components.forEach((/**
             * @param {?} it
             * @return {?}
             */
            (it) => {
                if (it.types[0] === 'locality' && it.types[1] === 'political') {
                    eventLocation.cityName = it.short_name;
                }
            }));
        }));
    }
}
EventMapService.decorators = [
    { type: Injectable, args: [{
                providedIn: 'root'
            },] }
];
/** @nocollapse */
EventMapService.ctorParameters = () => [
    { type: GoogleGeocoderService },
    { type: LocationChangeService }
];
/** @nocollapse */ EventMapService.ngInjectableDef = ɵɵdefineInjectable({ factory: function EventMapService_Factory() { return new EventMapService(ɵɵinject(GoogleGeocoderService), ɵɵinject(LocationChangeService)); }, token: EventMapService, providedIn: "root" });
if (false) {
    /**
     * @type {?}
     * @private
     */
    EventMapService.prototype.googleGeocoder;
    /**
     * @type {?}
     * @private
     */
    EventMapService.prototype.changeLocationService;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class StreamCreateService {
    constructor() {
        this.subject = new Subject();
    }
    /**
     * @return {?}
     */
    cancleAdd() {
        this.subject.next({ action: false, stream: '' });
    }
    /**
     * @param {?} stream
     * @return {?}
     */
    AddStream(stream) {
        this.subject.next({ action: true, stream: stream });
    }
}
StreamCreateService.decorators = [
    { type: Injectable, args: [{
                providedIn: 'root'
            },] }
];
/** @nocollapse */ StreamCreateService.ngInjectableDef = ɵɵdefineInjectable({ factory: function StreamCreateService_Factory() { return new StreamCreateService(); }, token: StreamCreateService, providedIn: "root" });
if (false) {
    /** @type {?} */
    StreamCreateService.prototype.subject;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class EventUpdateService {
    constructor() {
        this.subject = new Subject();
    }
    /**
     * @param {?} event
     * @return {?}
     */
    notifyEventChange(event) {
        this.subject.next(event);
    }
}
EventUpdateService.decorators = [
    { type: Injectable, args: [{
                providedIn: 'root'
            },] }
];
/** @nocollapse */ EventUpdateService.ngInjectableDef = ɵɵdefineInjectable({ factory: function EventUpdateService_Factory() { return new EventUpdateService(); }, token: EventUpdateService, providedIn: "root" });
if (false) {
    /** @type {?} */
    EventUpdateService.prototype.subject;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class EventEditorService {
    /**
     * @param {?} activatedRoute
     * @param {?} router
     * @param {?} eventsService
     * @param {?} streamService
     * @param {?} snackBar
     * @param {?} locationChangeSerive
     * @param {?} eventsDetailsAdminService
     */
    constructor(activatedRoute, router, eventsService, streamService, snackBar, locationChangeSerive, eventsDetailsAdminService) {
        this.activatedRoute = activatedRoute;
        this.router = router;
        this.eventsService = eventsService;
        this.streamService = streamService;
        this.snackBar = snackBar;
        this.locationChangeSerive = locationChangeSerive;
        this.eventsDetailsAdminService = eventsDetailsAdminService;
    }
    /**
     * @param {?} event
     * @return {?}
     */
    isEventValid(event) {
        return event.title && event.title !== null;
    }
    /**
     * @param {?} event
     * @return {?}
     */
    isValidParticipantLimit(event) {
        return (new FormControl(event.participantsLimit, [
            Validators.pattern('[0-9][0-9]{0,4}$'),
        ])['status'] === 'INVALID');
    }
    /**
     * @param {?} date
     * @return {?}
     */
    isValidDate(date) {
        return date === '';
    }
    /**
     * @param {?} event
     * @return {?}
     */
    createEvent(event) {
        return this.eventsService.createEvent(event);
    }
    /**
     * @param {?} event
     * @return {?}
     */
    updateEvent(event) {
        return this.eventsService.updateEvent(event);
    }
    /**
     * @param {?} event
     * @param {?} dateStart
     * @param {?} dateEnd
     * @return {?}
     */
    setDatesRangeToEvent(event, dateStart, dateEnd) {
        event.dateEnd = dateEnd;
        event.dateStart = dateStart;
    }
    /**
     * @param {?} dateStart
     * @param {?} dateEnd
     * @param {?} topics
     * @return {?}
     */
    isEventDatesPassedToTopicsDates(dateStart, dateEnd, topics) {
        return (moment(dateEnd).unix() < moment(topics[topics.length - 1].endDate).unix()
            || moment(dateStart).unix() > moment(topics[0].startDate).unix());
    }
    /**
     * @param {?} event
     * @return {?}
     */
    parseEventTopics(event) {
        if (event.streams) {
            return event.streams
                .reduce((/**
             * @param {?} allTopics
             * @param {?} stream
             * @return {?}
             */
            (allTopics, stream) => allTopics.concat(stream.topics)), [])
                .sort((/**
             * @param {?} f
             * @param {?} n
             * @return {?}
             */
            (f, n) => this.eventsDetailsAdminService.compareDates(f, n)));
        }
        else {
            return [];
        }
    }
    /**
     * @param {?} onLocationChanges
     * @return {?}
     */
    requestLocationChanges(onLocationChanges) {
        if (this.locationChangeSerive) {
            this.locationSubscription = this.locationChangeSerive.subject.subscribe((/**
             * @param {?} location
             * @return {?}
             */
            location => {
                onLocationChanges(location);
            }));
        }
    }
    /**
     * @return {?}
     */
    unsubscribeAll() {
        this.unsubscribe(this.locationSubscription);
    }
    /**
     * @private
     * @param {?} subscription
     * @return {?}
     */
    unsubscribe(subscription) {
        if (subscription) {
            subscription.unsubscribe();
        }
    }
}
EventEditorService.decorators = [
    { type: Injectable, args: [{
                providedIn: 'root'
            },] }
];
/** @nocollapse */
EventEditorService.ctorParameters = () => [
    { type: ActivatedRoute },
    { type: Router },
    { type: EventsService },
    { type: StreamService },
    { type: MatSnackBar },
    { type: LocationChangeService },
    { type: AdminDetailsServiceService }
];
/** @nocollapse */ EventEditorService.ngInjectableDef = ɵɵdefineInjectable({ factory: function EventEditorService_Factory() { return new EventEditorService(ɵɵinject(ActivatedRoute), ɵɵinject(Router), ɵɵinject(EventsService), ɵɵinject(StreamService), ɵɵinject(MatSnackBar$1), ɵɵinject(LocationChangeService), ɵɵinject(AdminDetailsServiceService)); }, token: EventEditorService, providedIn: "root" });
if (false) {
    /**
     * @type {?}
     * @private
     */
    EventEditorService.prototype.locationSubscription;
    /**
     * @type {?}
     * @private
     */
    EventEditorService.prototype.activatedRoute;
    /**
     * @type {?}
     * @private
     */
    EventEditorService.prototype.router;
    /**
     * @type {?}
     * @private
     */
    EventEditorService.prototype.eventsService;
    /**
     * @type {?}
     * @private
     */
    EventEditorService.prototype.streamService;
    /**
     * @type {?}
     * @private
     */
    EventEditorService.prototype.snackBar;
    /**
     * @type {?}
     * @private
     */
    EventEditorService.prototype.locationChangeSerive;
    /**
     * @type {?}
     * @private
     */
    EventEditorService.prototype.eventsDetailsAdminService;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class EventNavigationSubjectService extends Subject {
    constructor() {
        super();
    }
}
EventNavigationSubjectService.decorators = [
    { type: Injectable, args: [{
                providedIn: 'root'
            },] }
];
/** @nocollapse */
EventNavigationSubjectService.ctorParameters = () => [];
/** @nocollapse */ EventNavigationSubjectService.ngInjectableDef = ɵɵdefineInjectable({ factory: function EventNavigationSubjectService_Factory() { return new EventNavigationSubjectService(); }, token: EventNavigationSubjectService, providedIn: "root" });

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class PopupsService {
    /**
     * @param {?} dialog
     * @param {?} snackBar
     */
    constructor(dialog, snackBar) {
        this.dialog = dialog;
        this.snackBar = snackBar;
    }
    /**
     * @param {?} message
     * @param {?} positiveAnswer
     * @param {?} negativeAnswer
     * @param {?} onActionConfirmed
     * @return {?}
     */
    showConfirmationDialog(message, positiveAnswer, negativeAnswer, onActionConfirmed) {
        this.confirmationDialogSubscription =
            this.openDialogWindow(message, positiveAnswer, negativeAnswer)
                .afterClosed()
                .subscribe((/**
             * @param {?} confirm
             * @return {?}
             */
            confirm => {
                onActionConfirmed(confirm);
                this.confirmationDialogSubscription.unsubscribe();
            }));
    }
    /**
     * @param {?} message
     * @return {?}
     */
    showSnackBar(message) {
        this.snackBar.openFromComponent(SnackBarComponent, {
            horizontalPosition: 'center',
            verticalPosition: 'bottom',
            data: { message: message },
            duration: 3000
        });
    }
    /**
     * @private
     * @param {?} message
     * @param {?} positiveAnswer
     * @param {?} negativeAnswer
     * @return {?}
     */
    openDialogWindow(message, positiveAnswer, negativeAnswer) {
        return this.dialog.open(ConfirmDialogWindowComponent, this.dialogDataConfig(message, positiveAnswer, negativeAnswer));
    }
    /**
     * @private
     * @param {?} message
     * @param {?} positiveAnswer
     * @param {?} negativeAnswer
     * @return {?}
     */
    dialogDataConfig(message, positiveAnswer, negativeAnswer) {
        return {
            data: {
                text: message, positiveAnswer: positiveAnswer, negativeAnswer: negativeAnswer
            }
        };
    }
}
PopupsService.decorators = [
    { type: Injectable, args: [{
                providedIn: 'root'
            },] }
];
/** @nocollapse */
PopupsService.ctorParameters = () => [
    { type: MatDialog },
    { type: MatSnackBar }
];
/** @nocollapse */ PopupsService.ngInjectableDef = ɵɵdefineInjectable({ factory: function PopupsService_Factory() { return new PopupsService(ɵɵinject(MatDialog$1), ɵɵinject(MatSnackBar$1)); }, token: PopupsService, providedIn: "root" });
if (false) {
    /**
     * @type {?}
     * @private
     */
    PopupsService.prototype.confirmationDialogSubscription;
    /** @type {?} */
    PopupsService.prototype.dialog;
    /**
     * @type {?}
     * @private
     */
    PopupsService.prototype.snackBar;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class EventUpdateDisableService {
    constructor() {
        this.subject = new Subject();
    }
    /**
     * @param {?} value
     * @return {?}
     */
    disableEventUpdate(value) {
        this.subject.next(value);
    }
}
EventUpdateDisableService.decorators = [
    { type: Injectable, args: [{
                providedIn: 'root'
            },] }
];
/** @nocollapse */ EventUpdateDisableService.ngInjectableDef = ɵɵdefineInjectable({ factory: function EventUpdateDisableService_Factory() { return new EventUpdateDisableService(); }, token: EventUpdateDisableService, providedIn: "root" });
if (false) {
    /** @type {?} */
    EventUpdateDisableService.prototype.subject;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class AdminEventCreateDetailsService {
    constructor() {
        this.subject = new Subject();
    }
    /**
     * @param {?} text
     * @return {?}
     */
    sendMessage(text) {
        this.subject.next(text);
    }
}
AdminEventCreateDetailsService.decorators = [
    { type: Injectable, args: [{
                providedIn: 'root'
            },] }
];
/** @nocollapse */ AdminEventCreateDetailsService.ngInjectableDef = ɵɵdefineInjectable({ factory: function AdminEventCreateDetailsService_Factory() { return new AdminEventCreateDetailsService(); }, token: AdminEventCreateDetailsService, providedIn: "root" });
if (false) {
    /** @type {?} */
    AdminEventCreateDetailsService.prototype.subject;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class PingBackEndService {
    /**
     * @param {?} http
     * @param {?} urlProvider
     */
    constructor(http, urlProvider) {
        this.http = http;
        this.urlProvider = urlProvider;
    }
    /**
     * @return {?}
     */
    startServer() {
        return this.http.get(`${this.urlProvider.getUrl()}api/server`);
    }
}
PingBackEndService.decorators = [
    { type: Injectable, args: [{
                providedIn: 'root'
            },] }
];
/** @nocollapse */
PingBackEndService.ctorParameters = () => [
    { type: HttpClient },
    { type: ApiUrlProvider }
];
/** @nocollapse */ PingBackEndService.ngInjectableDef = ɵɵdefineInjectable({ factory: function PingBackEndService_Factory() { return new PingBackEndService(ɵɵinject(HttpClient), ɵɵinject(ApiUrlProvider)); }, token: PingBackEndService, providedIn: "root" });
if (false) {
    /**
     * @type {?}
     * @private
     */
    PingBackEndService.prototype.http;
    /**
     * @type {?}
     * @private
     */
    PingBackEndService.prototype.urlProvider;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class EventSharedUsersService {
    /**
     * @param {?} http
     * @param {?} urlProvider
     */
    constructor(http, urlProvider) {
        this.http = http;
        this.urlProvider = urlProvider;
    }
    /**
     * @param {?} eventId
     * @return {?}
     */
    getAllSharedUsers(eventId) {
        return this.http.get(`${this.urlProvider.getUrl()}api/events/${eventId}/share`);
    }
    /**
     * @param {?} sharedUsers
     * @param {?} eventId
     * @return {?}
     */
    addAllSharedUsers(sharedUsers, eventId) {
        return this.http.post(`${this.urlProvider.getUrl()}api/events/${eventId}/share/add`, sharedUsers);
    }
    /**
     * @param {?} eventId
     * @param {?} user
     * @return {?}
     */
    deleteSharedUser(eventId, user) {
        return this.http.post(`${this.urlProvider.getUrl()}api/events/${eventId}/share/remove`, user);
    }
    /**
     * @param {?} username
     * @return {?}
     */
    getAllEventShared(username) {
        return this.http.get(`${this.urlProvider.getUrl()}api/${username}/shared`);
    }
}
EventSharedUsersService.decorators = [
    { type: Injectable, args: [{
                providedIn: 'root'
            },] }
];
/** @nocollapse */
EventSharedUsersService.ctorParameters = () => [
    { type: HttpClient },
    { type: ApiUrlProvider }
];
/** @nocollapse */ EventSharedUsersService.ngInjectableDef = ɵɵdefineInjectable({ factory: function EventSharedUsersService_Factory() { return new EventSharedUsersService(ɵɵinject(HttpClient), ɵɵinject(ApiUrlProvider)); }, token: EventSharedUsersService, providedIn: "root" });
if (false) {
    /**
     * @type {?}
     * @private
     */
    EventSharedUsersService.prototype.http;
    /**
     * @type {?}
     * @private
     */
    EventSharedUsersService.prototype.urlProvider;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class AdminEventPermeationGuard {
    /**
     * @param {?} userDetailsService
     * @param {?} activatedRoute
     * @param {?} eventsService
     * @param {?} eventSharedUserService
     * @param {?} router
     */
    constructor(userDetailsService, activatedRoute, eventsService, eventSharedUserService, router) {
        this.userDetailsService = userDetailsService;
        this.activatedRoute = activatedRoute;
        this.eventsService = eventsService;
        this.eventSharedUserService = eventSharedUserService;
        this.router = router;
    }
    /**
     * @param {?} route
     * @return {?}
     */
    canActivate(route) {
        return this.userDetailsService.getCurrentUserUsername().pipe(mergeMap((/**
         * @param {?} username
         * @return {?}
         */
        username => {
            return zip(this.eventSharedUserService.getAllSharedUsers(route.params.id), this.eventsService.findById(route.params.id), (/**
             * @param {?} sharedUsers
             * @param {?} event
             * @return {?}
             */
            (sharedUsers, event) => ({ sharedUsers, event }))).pipe(map((/**
             * @param {?} param
             * @return {?}
             */
            param => {
                return (param.event.creator.username === username) || (param.sharedUsers.some((/**
                 * @param {?} user
                 * @return {?}
                 */
                user => user.username === username)));
            })), tap((/**
             * @param {?} allowRedirect
             * @return {?}
             */
            allowRedirect => {
                if (!allowRedirect) {
                    this.redirectToPermissionDenied();
                }
            })));
        })));
    }
    /**
     * @private
     * @return {?}
     */
    redirectToPermissionDenied() {
        this.router.navigate(['forbidden']);
    }
}
AdminEventPermeationGuard.decorators = [
    { type: Injectable, args: [{
                providedIn: 'root'
            },] }
];
/** @nocollapse */
AdminEventPermeationGuard.ctorParameters = () => [
    { type: UserDetailsService },
    { type: ActivatedRoute },
    { type: EventsService },
    { type: EventSharedUsersService },
    { type: Router }
];
/** @nocollapse */ AdminEventPermeationGuard.ngInjectableDef = ɵɵdefineInjectable({ factory: function AdminEventPermeationGuard_Factory() { return new AdminEventPermeationGuard(ɵɵinject(UserDetailsService), ɵɵinject(ActivatedRoute), ɵɵinject(EventsService), ɵɵinject(EventSharedUsersService), ɵɵinject(Router)); }, token: AdminEventPermeationGuard, providedIn: "root" });
if (false) {
    /**
     * @type {?}
     * @private
     */
    AdminEventPermeationGuard.prototype.userDetailsService;
    /**
     * @type {?}
     * @private
     */
    AdminEventPermeationGuard.prototype.activatedRoute;
    /**
     * @type {?}
     * @private
     */
    AdminEventPermeationGuard.prototype.eventsService;
    /**
     * @type {?}
     * @private
     */
    AdminEventPermeationGuard.prototype.eventSharedUserService;
    /**
     * @type {?}
     * @private
     */
    AdminEventPermeationGuard.prototype.router;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class ClientEventPermeationGuard {
    /**
     * @param {?} userDetailsService
     * @param {?} activatedRoute
     * @param {?} eventsService
     * @param {?} router
     */
    constructor(userDetailsService, activatedRoute, eventsService, router) {
        this.userDetailsService = userDetailsService;
        this.activatedRoute = activatedRoute;
        this.eventsService = eventsService;
        this.router = router;
    }
    /**
     * @param {?} route
     * @return {?}
     */
    canActivate(route) {
        return this.eventsService.findById(route.params.eventId).pipe(map((/**
         * @param {?} event
         * @return {?}
         */
        event => {
            return (event.status.toString() === StatusEvent.PUBLISH.toString());
        })), tap((/**
         * @param {?} allowRedirect
         * @return {?}
         */
        allowRedirect => {
            if (!allowRedirect) {
                this.redirectToPermissionDenied();
            }
        })));
    }
    /**
     * @private
     * @return {?}
     */
    redirectToPermissionDenied() {
        this.router.navigate(['forbidden']);
    }
}
ClientEventPermeationGuard.decorators = [
    { type: Injectable, args: [{
                providedIn: 'root'
            },] }
];
/** @nocollapse */
ClientEventPermeationGuard.ctorParameters = () => [
    { type: UserDetailsService },
    { type: ActivatedRoute },
    { type: EventsService },
    { type: Router }
];
/** @nocollapse */ ClientEventPermeationGuard.ngInjectableDef = ɵɵdefineInjectable({ factory: function ClientEventPermeationGuard_Factory() { return new ClientEventPermeationGuard(ɵɵinject(UserDetailsService), ɵɵinject(ActivatedRoute), ɵɵinject(EventsService), ɵɵinject(Router)); }, token: ClientEventPermeationGuard, providedIn: "root" });
if (false) {
    /**
     * @type {?}
     * @private
     */
    ClientEventPermeationGuard.prototype.userDetailsService;
    /**
     * @type {?}
     * @private
     */
    ClientEventPermeationGuard.prototype.activatedRoute;
    /**
     * @type {?}
     * @private
     */
    ClientEventPermeationGuard.prototype.eventsService;
    /**
     * @type {?}
     * @private
     */
    ClientEventPermeationGuard.prototype.router;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class EventActualVisitorsService {
    /**
     * @param {?} http
     * @param {?} urlProvider
     */
    constructor(http, urlProvider) {
        this.http = http;
        this.urlProvider = urlProvider;
    }
    /**
     * @param {?} eventId
     * @return {?}
     */
    getAllActualVisitors(eventId) {
        return this.http.get(`${this.urlProvider.getUrl()}api/events/${eventId}/actual/visitors`);
    }
    /**
     * @param {?} eventId
     * @param {?} user
     * @return {?}
     */
    addEventActualVisitor(eventId, user) {
        return this.http.post(`${this.urlProvider.getUrl()}api/events/${eventId}/actual/visitors/add`, user);
    }
}
EventActualVisitorsService.decorators = [
    { type: Injectable, args: [{
                providedIn: 'root'
            },] }
];
/** @nocollapse */
EventActualVisitorsService.ctorParameters = () => [
    { type: HttpClient },
    { type: ApiUrlProvider }
];
/** @nocollapse */ EventActualVisitorsService.ngInjectableDef = ɵɵdefineInjectable({ factory: function EventActualVisitorsService_Factory() { return new EventActualVisitorsService(ɵɵinject(HttpClient), ɵɵinject(ApiUrlProvider)); }, token: EventActualVisitorsService, providedIn: "root" });
if (false) {
    /**
     * @type {?}
     * @private
     */
    EventActualVisitorsService.prototype.http;
    /**
     * @type {?}
     * @private
     */
    EventActualVisitorsService.prototype.urlProvider;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class EventPotentialVisitorsService {
    /**
     * @param {?} http
     * @param {?} urlProvider
     */
    constructor(http, urlProvider) {
        this.http = http;
        this.urlProvider = urlProvider;
    }
    /**
     * @param {?} eventId
     * @return {?}
     */
    getAllPotentialVisitors(eventId) {
        return this.http.get(`${this.urlProvider.getUrl()}api/events/${eventId}/potential/visitors`);
    }
    /**
     * @param {?} eventId
     * @param {?} user
     * @return {?}
     */
    addEventPotentialVisitor(eventId, user) {
        return this.http.post(`${this.urlProvider.getUrl()}api/events/${eventId}/potential/visitors/add`, user);
    }
    /**
     * @param {?} eventId
     * @param {?} user
     * @return {?}
     */
    removeEventPotentialVisitor(eventId, user) {
        return this.http.post(`${this.urlProvider.getUrl()}api/events/${eventId}/potential/visitors/remove`, user);
    }
}
EventPotentialVisitorsService.decorators = [
    { type: Injectable, args: [{
                providedIn: 'root'
            },] }
];
/** @nocollapse */
EventPotentialVisitorsService.ctorParameters = () => [
    { type: HttpClient },
    { type: ApiUrlProvider }
];
/** @nocollapse */ EventPotentialVisitorsService.ngInjectableDef = ɵɵdefineInjectable({ factory: function EventPotentialVisitorsService_Factory() { return new EventPotentialVisitorsService(ɵɵinject(HttpClient), ɵɵinject(ApiUrlProvider)); }, token: EventPotentialVisitorsService, providedIn: "root" });
if (false) {
    /**
     * @type {?}
     * @private
     */
    EventPotentialVisitorsService.prototype.http;
    /**
     * @type {?}
     * @private
     */
    EventPotentialVisitorsService.prototype.urlProvider;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class UserJoinNotificationService {
    constructor() {
        this.subject = new Subject();
    }
    /**
     * @return {?}
     */
    join() {
        this.subject.next('join');
    }
    /**
     * @return {?}
     */
    leave() {
        this.subject.next('leave');
    }
}
UserJoinNotificationService.decorators = [
    { type: Injectable, args: [{
                providedIn: 'root'
            },] }
];
/** @nocollapse */ UserJoinNotificationService.ngInjectableDef = ɵɵdefineInjectable({ factory: function UserJoinNotificationService_Factory() { return new UserJoinNotificationService(); }, token: UserJoinNotificationService, providedIn: "root" });
if (false) {
    /** @type {?} */
    UserJoinNotificationService.prototype.subject;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class EventHeaderService {
    constructor() {
        this.subject = new Subject();
    }
    /**
     * @param {?} events
     * @return {?}
     */
    sendEvents(events) {
        this.subject.next(events);
    }
}
EventHeaderService.decorators = [
    { type: Injectable, args: [{
                providedIn: 'root'
            },] }
];
/** @nocollapse */
EventHeaderService.ctorParameters = () => [];
/** @nocollapse */ EventHeaderService.ngInjectableDef = ɵɵdefineInjectable({ factory: function EventHeaderService_Factory() { return new EventHeaderService(); }, token: EventHeaderService, providedIn: "root" });
if (false) {
    /** @type {?} */
    EventHeaderService.prototype.subject;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class Tag {
}
if (false) {
    /** @type {?} */
    Tag.prototype.id;
    /** @type {?} */
    Tag.prototype.name;
    /** @type {?} */
    Tag.prototype.tagRelations;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class TagService {
    /**
     * @param {?} http
     * @param {?} urlProvider
     */
    constructor(http, urlProvider) {
        this.http = http;
        this.urlProvider = urlProvider;
    }
    /**
     * @param {?} tag
     * @return {?}
     */
    create(tag) {
        return this.http.post(`${this.urlProvider.getUrl()}api/tags`, tag);
    }
    /**
     * @param {?} eventId
     * @param {?} tagId
     * @return {?}
     */
    addTagToEvent(eventId, tagId) {
        return this.http.put(`${this.urlProvider.getUrl()}api/events/${eventId}/tags/${tagId}`, {});
    }
    /**
     * @param {?} rootTagId
     * @param {?} tagId
     * @return {?}
     */
    matTagToAnotherTag(rootTagId, tagId) {
        return this.http.put(`${this.urlProvider.getUrl()}api/tags/${rootTagId}/${tagId}`, {});
    }
    /**
     * @param {?} eventId
     * @param {?} tagId
     * @return {?}
     */
    removeFromEvent(eventId, tagId) {
        return this.http.delete(`${this.urlProvider.getUrl()}api/events/${eventId}/tags/${tagId}`);
    }
}
TagService.decorators = [
    { type: Injectable, args: [{
                providedIn: 'root'
            },] }
];
/** @nocollapse */
TagService.ctorParameters = () => [
    { type: HttpClient },
    { type: ApiUrlProvider }
];
/** @nocollapse */ TagService.ngInjectableDef = ɵɵdefineInjectable({ factory: function TagService_Factory() { return new TagService(ɵɵinject(HttpClient), ɵɵinject(ApiUrlProvider)); }, token: TagService, providedIn: "root" });
if (false) {
    /**
     * @type {?}
     * @private
     */
    TagService.prototype.http;
    /**
     * @type {?}
     * @private
     */
    TagService.prototype.urlProvider;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class SearchEventSubject {
    constructor() {
        this.searchOnSubject = new Subject();
        this.searchLifecycle = this.searchOnSubject.asObservable();
    }
    /**
     * @param {?} show
     * @return {?}
     */
    notify(show) {
        this.searchOnSubject.next(show);
    }
}
SearchEventSubject.decorators = [
    { type: Injectable, args: [{
                providedIn: 'root'
            },] }
];
/** @nocollapse */
SearchEventSubject.ctorParameters = () => [];
/** @nocollapse */ SearchEventSubject.ngInjectableDef = ɵɵdefineInjectable({ factory: function SearchEventSubject_Factory() { return new SearchEventSubject(); }, token: SearchEventSubject, providedIn: "root" });
if (false) {
    /**
     * @type {?}
     * @private
     */
    SearchEventSubject.prototype.searchOnSubject;
    /** @type {?} */
    SearchEventSubject.prototype.searchLifecycle;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class AttachmentService {
    /**
     * @param {?} http
     * @param {?} urlProvider
     */
    constructor(http, urlProvider) {
        this.http = http;
        this.urlProvider = urlProvider;
    }
    /**
     * @param {?} attachment
     * @return {?}
     */
    saveAttachment(attachment) {
        /** @type {?} */
        const formdata = new FormData();
        formdata.append('attachment', attachment);
        return this.http.post(`${this.urlProvider.getUrl()}api/attachment/add`, formdata);
    }
    /**
     * @param {?} attachmentId
     * @return {?}
     */
    deleteAttachment(attachmentId) {
        return __awaiter(this, void 0, void 0, function* () {
            return yield this.http.delete(`${this.urlProvider.getUrl()}api/attachment/${attachmentId}`, {}).toPromise();
        });
    }
}
AttachmentService.decorators = [
    { type: Injectable, args: [{
                providedIn: 'root'
            },] }
];
/** @nocollapse */
AttachmentService.ctorParameters = () => [
    { type: HttpClient },
    { type: ApiUrlProvider }
];
/** @nocollapse */ AttachmentService.ngInjectableDef = ɵɵdefineInjectable({ factory: function AttachmentService_Factory() { return new AttachmentService(ɵɵinject(HttpClient), ɵɵinject(ApiUrlProvider)); }, token: AttachmentService, providedIn: "root" });
if (false) {
    /**
     * @type {?}
     * @private
     */
    AttachmentService.prototype.http;
    /**
     * @type {?}
     * @private
     */
    AttachmentService.prototype.urlProvider;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class Attachment {
    constructor() { }
}
if (false) {
    /** @type {?} */
    Attachment.prototype.id;
    /** @type {?} */
    Attachment.prototype.name;
    /** @type {?} */
    Attachment.prototype.type;
    /** @type {?} */
    Attachment.prototype.downloadUri;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

export { AdminAuthGuard, AdminDetailsServiceService, AdminEventCreateDetailsService, AdminEventPermeationGuard, ApiUrlProvider, Attachment, AttachmentService, AuthInterceptor, BaseBehaviorSubject, ClientAuthGuard, ClientEventPermeationGuard, ComponentsModule, ConfirmDialogWindowComponent, ErrorForbiddenPageInterceptor, ErrorNotFoundPageInterceptor, Event, EventActualVisitorsService, EventEditorService, EventHeaderService, EventMapService, EventNavigationSubjectService, EventPotentialVisitorsService, EventSharedUsersService, EventStatusService, EventUpdateDisableService, EventUpdateService, EventsService, FilterByPredicatePipe, GoogleGeocoderService, Location, LocationChangeService, LoginPageGuard, NextTimeEvents, NotPublished, Oauth2Service, ParticipantsService, PingBackEndService, PipesModule, PopupsService, ProgressInterceptor, ProgressLoaderComponent, ProgressModule, PublishedEvents, QQEventModule, QQRestConfig, QqTopicModule, Question, QuestionStatusService, QuestionsService, SaveRequestNotificator, SearchEventSubject, SnackBarComponent, SortByDatePipe, SortTopicByDatesPipe, SortTopicByMinutesAndHours, Speaker, SpeakersService, Status, StatusEvent, Stream, StreamCreateService, StreamEvent, StreamEventService, StreamEventType, StreamService, Tag, TagService, Topic, TopicEditService, TopicService, TopicStatusService, TopicValidationService, TopilListElementDirective, User, UserDetailsService, UserJoinNotificationService, Visitor, Vote, DirectiveModule as ɵa, DisableDirective as ɵb };
//# sourceMappingURL=qq-core-lib.js.map
