import { Component, Inject, NgModule, Pipe, Injectable, ɵɵdefineInjectable, ɵɵinject, Directive, ViewChild, HostListener, ElementRef, Renderer2, Input } from '@angular/core';
import { MatDialogRef, MAT_DIALOG_DATA, MAT_SNACK_BAR_DATA, MatButtonModule, MatDialogModule, MatIconModule, MatProgressSpinnerModule, MatSnackBar, MatDialog } from '@angular/material';
import { CommonModule } from '@angular/common';
import { BehaviorSubject, Subject, throwError, Observable, of, zip } from 'rxjs';
import moment from 'moment';
import { __awaiter, __generator, __extends } from 'tslib';
import { concatMap, tap, map, mergeMap, catchError } from 'rxjs/operators';
import { HttpClient, HttpResponse } from '@angular/common/http';
import { LocalStorage } from '@ngx-pwa/local-storage';
import { Router, ActivatedRoute } from '@angular/router';
import { FormControl, Validators } from '@angular/forms';
import { MatSnackBar as MatSnackBar$1 } from '@angular/material/snack-bar';
import { MatDialog as MatDialog$1 } from '@angular/material/dialog';

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var ConfirmDialogWindowComponent = /** @class */ (function () {
    function ConfirmDialogWindowComponent(dialogRef, data) {
        this.dialogRef = dialogRef;
        this.data = data;
    }
    /**
     * @return {?}
     */
    ConfirmDialogWindowComponent.prototype.ngOnInit = /**
     * @return {?}
     */
    function () {
    };
    /**
     * @return {?}
     */
    ConfirmDialogWindowComponent.prototype.onNegativeAnswerClick = /**
     * @return {?}
     */
    function () {
        this.dialogRef.close(false);
    };
    /**
     * @return {?}
     */
    ConfirmDialogWindowComponent.prototype.onPositiveAnswerClick = /**
     * @return {?}
     */
    function () {
        this.dialogRef.close(true);
    };
    ConfirmDialogWindowComponent.decorators = [
        { type: Component, args: [{
                    selector: 'qsl-confirm-dialog-window',
                    template: "<div mat-dialog-content>\n  <p><span i18n=\"@@dataNext\">data.text</span> <span class=\"data-entity-class\">{{data.entity.title}}</span> <span>?</span></p>\n</div>\n<div mat-dialog-content class=\"centr\">\n    <button class=\"negative-answer\" mat-button (click)=\"onNegativeAnswerClick()\" i18n=\"@@dataNegativeAnswer\"> data.negativeAnswer </button>\n\n    <button class=\"positive-answer\" mat-button (click)=\"onPositiveAnswerClick()\" i18n=\"@@dataPositiveAnswer\"> data.positiveAnswer </button>\n</div>\n",
                    styles: [".centr{margin-right:auto;margin-left:auto;text-align:center}.positive-answer{background:#2e74e2;color:#fff}.positive-answer:hover{background-color:#2e74e2}.negative-answer{margin-right:15px;color:#4a90e2}.negative-answer:hover{background-color:rgba(68,130,226,.2)}.negative-answer:hover ::ng-deep .mat-button-focus-overlay{background:0 0}.data-entity-class{padding-left:5px;padding-right:5px}"]
                }] }
    ];
    /** @nocollapse */
    ConfirmDialogWindowComponent.ctorParameters = function () { return [
        { type: MatDialogRef },
        { type: undefined, decorators: [{ type: Inject, args: [MAT_DIALOG_DATA,] }] }
    ]; };
    return ConfirmDialogWindowComponent;
}());
if (false) {
    /** @type {?} */
    ConfirmDialogWindowComponent.prototype.dialogRef;
    /** @type {?} */
    ConfirmDialogWindowComponent.prototype.data;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var SnackBarComponent = /** @class */ (function () {
    function SnackBarComponent(data) {
        this.data = data;
    }
    /**
     * @return {?}
     */
    SnackBarComponent.prototype.ngOnInit = /**
     * @return {?}
     */
    function () {
    };
    SnackBarComponent.decorators = [
        { type: Component, args: [{
                    selector: 'snack-bar-component',
                    template: "<span i18n=\"@@popupMessage\">data.message</span>\n"
                }] }
    ];
    /** @nocollapse */
    SnackBarComponent.ctorParameters = function () { return [
        { type: undefined, decorators: [{ type: Inject, args: [MAT_SNACK_BAR_DATA,] }] }
    ]; };
    return SnackBarComponent;
}());
if (false) {
    /** @type {?} */
    SnackBarComponent.prototype.data;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var ComponentsModule = /** @class */ (function () {
    function ComponentsModule() {
    }
    ComponentsModule.decorators = [
        { type: NgModule, args: [{
                    imports: [
                        CommonModule,
                        MatButtonModule,
                        MatDialogModule
                    ],
                    declarations: [
                        ConfirmDialogWindowComponent,
                        SnackBarComponent
                    ],
                    entryComponents: [
                        ConfirmDialogWindowComponent,
                        SnackBarComponent
                    ],
                    exports: [
                        ConfirmDialogWindowComponent,
                        SnackBarComponent
                    ]
                },] }
    ];
    return ComponentsModule;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/**
 * Created by yana on 20.04.18.
 */
var  /**
 * Created by yana on 20.04.18.
 */
Event = /** @class */ (function () {
    function Event() {
        this.attachments = [];
    }
    return Event;
}());
if (false) {
    /** @type {?} */
    Event.prototype.id;
    /** @type {?} */
    Event.prototype.title;
    /** @type {?} */
    Event.prototype.description;
    /** @type {?} */
    Event.prototype.location;
    /** @type {?} */
    Event.prototype.dateStart;
    /** @type {?} */
    Event.prototype.dateEnd;
    /** @type {?} */
    Event.prototype.streams;
    /** @type {?} */
    Event.prototype.status;
    /** @type {?} */
    Event.prototype.participantsLimit;
    /** @type {?} */
    Event.prototype.creator;
    /** @type {?} */
    Event.prototype.tags;
    /** @type {?} */
    Event.prototype.attachments;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/**
 * Created by yana on 20.04.18.
 */
var  /**
 * Created by yana on 20.04.18.
 */
Location = /** @class */ (function () {
    function Location() {
    }
    return Location;
}());
if (false) {
    /** @type {?} */
    Location.prototype.id;
    /** @type {?} */
    Location.prototype.latitude;
    /** @type {?} */
    Location.prototype.longitude;
    /** @type {?} */
    Location.prototype.formattedAddress;
    /** @type {?} */
    Location.prototype.cityName;
    /** @type {?} */
    Location.prototype.placeId;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/** @enum {string} */
var StatusEvent = {
    PUBLISH: 'PUBLISH',
    NOT_PUBLISH: 'NOT_PUBLISH',
};

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var Visitor = /** @class */ (function () {
    function Visitor() {
    }
    return Visitor;
}());
if (false) {
    /** @type {?} */
    Visitor.prototype.username;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/**
 * Created by vlad on 23.04.18.
 */
var NextTimeEvents = /** @class */ (function () {
    function NextTimeEvents() {
    }
    /**
     * @param {?} items
     * @return {?}
     */
    NextTimeEvents.prototype.transform = /**
     * @param {?} items
     * @return {?}
     */
    function (items) {
        if (!items) {
            return [];
        }
        /** @type {?} */
        var currentDate = new Date();
        return items.filter((/**
         * @param {?} it
         * @return {?}
         */
        function (it) {
            return it.dateStart > currentDate;
        }));
    };
    NextTimeEvents.decorators = [
        { type: Pipe, args: [{ name: 'nextTimeEvents',
                    pure: false },] }
    ];
    return NextTimeEvents;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/**
 * Created by vlad on 25.05.18.
 */
var NotPublished = /** @class */ (function () {
    function NotPublished() {
    }
    /**
     * @param {?} items
     * @return {?}
     */
    NotPublished.prototype.transform = /**
     * @param {?} items
     * @return {?}
     */
    function (items) {
        if (!items) {
            return [];
        }
        return items.filter((/**
         * @param {?} it
         * @return {?}
         */
        function (it) {
            return (it.status.toString() === 'NOT_PUBLISH');
        }));
    };
    NotPublished.decorators = [
        { type: Pipe, args: [{ name: 'notPublishedEvents',
                    pure: false },] }
    ];
    return NotPublished;
}());
if (false) {
    /** @type {?} */
    NotPublished.prototype.statusEvent;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/**
 * Created by vlad on 25.05.18.
 */
var PublishedEvents = /** @class */ (function () {
    function PublishedEvents() {
    }
    /**
     * @param {?} items
     * @return {?}
     */
    PublishedEvents.prototype.transform = /**
     * @param {?} items
     * @return {?}
     */
    function (items) {
        if (!items) {
            return [];
        }
        return items.filter((/**
         * @param {?} it
         * @return {?}
         */
        function (it) {
            return (it.status.toString() === 'PUBLISH');
        }));
    };
    PublishedEvents.decorators = [
        { type: Pipe, args: [{ name: 'publishedEvents',
                    pure: false },] }
    ];
    return PublishedEvents;
}());
if (false) {
    /** @type {?} */
    PublishedEvents.prototype.statusEvent;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/**
 * Created by yana on 26.04.18.
 */
var SortByDatePipe = /** @class */ (function () {
    function SortByDatePipe() {
    }
    /**
     * @param {?} array
     * @param {?} args
     * @return {?}
     */
    SortByDatePipe.prototype.transform = /**
     * @param {?} array
     * @param {?} args
     * @return {?}
     */
    function (array, args) {
        if (typeof args[0] === 'undefined') {
            return array;
        }
        /** @type {?} */
        var direction;
        direction = args[0][0];
        /** @type {?} */
        var column = args.replace('-', '');
        array.sort((/**
         * @param {?} item1
         * @param {?} item2
         * @return {?}
         */
        function (item1, item2) {
            /** @type {?} */
            var left = Number(item1[column]);
            /** @type {?} */
            var right = Number(item2[column]);
            return (direction === '-') ? right - left : left - right;
        }));
        return array;
    };
    SortByDatePipe.decorators = [
        { type: Pipe, args: [{
                    name: 'sortByDate',
                    pure: false
                },] },
        { type: Injectable }
    ];
    return SortByDatePipe;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var AdminDetailsServiceService = /** @class */ (function () {
    function AdminDetailsServiceService() {
    }
    /**
     * @param {?} event
     * @return {?}
     */
    AdminDetailsServiceService.prototype.assignLocation = /**
     * @param {?} event
     * @return {?}
     */
    function (event) {
        if (event.location == null) {
            event.location = new Location();
            event.location.latitude = 0;
            event.location.longitude = 0;
        }
    };
    /**
     * @param {?} startDate
     * @param {?} endDate
     * @return {?}
     */
    AdminDetailsServiceService.prototype.compareDates = /**
     * @param {?} startDate
     * @param {?} endDate
     * @return {?}
     */
    function (startDate, endDate) {
        return startDate.startDate > endDate.startDate ? 1 : -1;
    };
    AdminDetailsServiceService.decorators = [
        { type: Injectable, args: [{
                    providedIn: 'root'
                },] }
    ];
    /** @nocollapse */
    AdminDetailsServiceService.ctorParameters = function () { return []; };
    /** @nocollapse */ AdminDetailsServiceService.ngInjectableDef = ɵɵdefineInjectable({ factory: function AdminDetailsServiceService_Factory() { return new AdminDetailsServiceService(); }, token: AdminDetailsServiceService, providedIn: "root" });
    return AdminDetailsServiceService;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/**
 * @template T
 */
var  /**
 * @template T
 */
BaseBehaviorSubject = /** @class */ (function () {
    function BaseBehaviorSubject() {
        this.subject = new BehaviorSubject([]);
    }
    /**
     * @param {?=} next
     * @return {?}
     */
    BaseBehaviorSubject.prototype.subscribe = /**
     * @param {?=} next
     * @return {?}
     */
    function (next) {
        return this.subject.subscribe(next);
    };
    /**
     * @private
     * @param {?} items
     * @return {?}
     */
    BaseBehaviorSubject.prototype.notifySubjectChanged = /**
     * @private
     * @param {?} items
     * @return {?}
     */
    function (items) {
        this.subject.next(items);
    };
    /**
     * @param {?} items
     * @return {?}
     */
    BaseBehaviorSubject.prototype.replaceAll = /**
     * @param {?} items
     * @return {?}
     */
    function (items) {
        this.notifySubjectChanged(items);
    };
    /**
     * @param {?} item
     * @return {?}
     */
    BaseBehaviorSubject.prototype.add = /**
     * @param {?} item
     * @return {?}
     */
    function (item) {
        if (!item) {
            return;
        }
        /** @type {?} */
        var currentValue = this.subject.getValue();
        currentValue.push(item);
        this.subject.next(currentValue);
    };
    /**
     * @param {?} item
     * @param {?} equals
     * @return {?}
     */
    BaseBehaviorSubject.prototype.remove = /**
     * @param {?} item
     * @param {?} equals
     * @return {?}
     */
    function (item, equals) {
        /** @type {?} */
        var items = this.subject.getValue();
        /** @type {?} */
        var positionInTheList = items.findIndex((/**
         * @param {?} e
         * @return {?}
         */
        function (e) { return equals(e, item); }));
        if (positionInTheList > -1) {
            items.splice(positionInTheList, 1);
        }
        this.notifySubjectChanged(items);
    };
    /**
     * @param {?} item
     * @param {?} equals
     * @return {?}
     */
    BaseBehaviorSubject.prototype.replace = /**
     * @param {?} item
     * @param {?} equals
     * @return {?}
     */
    function (item, equals) {
        if (!item) {
            return;
        }
        /** @type {?} */
        var items = this.subject.getValue();
        /** @type {?} */
        var positionInTheList = items.findIndex((/**
         * @param {?} e
         * @return {?}
         */
        function (e) { return equals(e, item); }));
        if (positionInTheList > -1) {
            items[positionInTheList] = item;
        }
        else {
            items.push(item);
        }
        this.notifySubjectChanged(items);
    };
    return BaseBehaviorSubject;
}());
if (false) {
    /** @type {?} */
    BaseBehaviorSubject.prototype.subject;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var EventStatusService = /** @class */ (function () {
    function EventStatusService() {
    }
    /**
     * @param {?} event
     * @return {?}
     */
    EventStatusService.prototype.upComing = /**
     * @param {?} event
     * @return {?}
     */
    function (event) {
        return moment(event.dateStart).isAfter(moment());
    };
    /**
     * @param {?} events
     * @return {?}
     */
    EventStatusService.prototype.notPassedEvents = /**
     * @param {?} events
     * @return {?}
     */
    function (events) {
        return !this.passed(events);
    };
    /**
     * @param {?} event
     * @return {?}
     */
    EventStatusService.prototype.lasting = /**
     * @param {?} event
     * @return {?}
     */
    function (event) {
        return moment().isBetween(event.dateStart, event.dateEnd);
    };
    /**
     * @param {?} event
     * @return {?}
     */
    EventStatusService.prototype.passed = /**
     * @param {?} event
     * @return {?}
     */
    function (event) {
        return moment(event.dateEnd).isBefore(moment());
    };
    /**
     * @param {?} event
     * @return {?}
     */
    EventStatusService.prototype.afterNextMonth = /**
     * @param {?} event
     * @return {?}
     */
    function (event) {
        /** @type {?} */
        var nextNextMonth = moment().add(2, 'month');
        return moment(event.dateStart).isAfter(nextNextMonth);
    };
    /**
     * @param {?} event
     * @return {?}
     */
    EventStatusService.prototype.onNextMonth = /**
     * @param {?} event
     * @return {?}
     */
    function (event) {
        /** @type {?} */
        var nextNextMonth = moment().add(2, 'month');
        /** @type {?} */
        var nextMonth = moment().add(1, 'month');
        return moment(event.dateStart).isBetween(nextMonth, nextNextMonth);
    };
    /**
     * @param {?} event
     * @return {?}
     */
    EventStatusService.prototype.onThisMonth = /**
     * @param {?} event
     * @return {?}
     */
    function (event) {
        /** @type {?} */
        var nextMonth = moment().add(1, 'month');
        return moment(event.dateStart).isBetween(moment(), nextMonth);
    };
    EventStatusService.decorators = [
        { type: Injectable, args: [{
                    providedIn: 'root'
                },] }
    ];
    /** @nocollapse */
    EventStatusService.ctorParameters = function () { return []; };
    /** @nocollapse */ EventStatusService.ngInjectableDef = ɵɵdefineInjectable({ factory: function EventStatusService_Factory() { return new EventStatusService(); }, token: EventStatusService, providedIn: "root" });
    return EventStatusService;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var QQRestConfig = /** @class */ (function () {
    function QQRestConfig() {
    }
    /**
     * @param {?} url
     * @return {?}
     */
    QQRestConfig.baseUrl = /**
     * @param {?} url
     * @return {?}
     */
    function (url) {
        this.BASE_URL = url;
    };
    QQRestConfig.BASE_URL = '';
    return QQRestConfig;
}());
if (false) {
    /** @type {?} */
    QQRestConfig.BASE_URL;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/**
 * Created by yana on 20.04.18.
 */
var ApiUrlProvider = /** @class */ (function () {
    function ApiUrlProvider() {
    }
    /**
     * @return {?}
     */
    ApiUrlProvider.prototype.getUrl = /**
     * @return {?}
     */
    function () {
        return QQRestConfig.BASE_URL;
    };
    ApiUrlProvider.decorators = [
        { type: Injectable, args: [{
                    providedIn: 'root'
                },] }
    ];
    /** @nocollapse */
    ApiUrlProvider.ctorParameters = function () { return []; };
    /** @nocollapse */ ApiUrlProvider.ngInjectableDef = ɵɵdefineInjectable({ factory: function ApiUrlProvider_Factory() { return new ApiUrlProvider(); }, token: ApiUrlProvider, providedIn: "root" });
    return ApiUrlProvider;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var UserDetailsService = /** @class */ (function () {
    function UserDetailsService(localStorage) {
        this.localStorage = localStorage;
    }
    /**
     * @return {?}
     */
    UserDetailsService.prototype.getCurrentUserDisplayName = /**
     * @return {?}
     */
    function () {
        return this.localStorage.getItem('display_name');
    };
    /**
     * @return {?}
     */
    UserDetailsService.prototype.getCurrentUserUsername = /**
     * @return {?}
     */
    function () {
        return this.localStorage.getItem('username');
    };
    /**
     * @return {?}
     */
    UserDetailsService.prototype.getCurrentUserAccessToken = /**
     * @return {?}
     */
    function () {
        return this.localStorage.getItem('access_token');
    };
    /**
     * @return {?}
     */
    UserDetailsService.prototype.getCurrentUserRefreshToken = /**
     * @return {?}
     */
    function () {
        return this.localStorage.getItem('refresh_token');
    };
    /**
     * @return {?}
     */
    UserDetailsService.prototype.getCurrentUserRole = /**
     * @return {?}
     */
    function () {
        return this.localStorage.getItem('role');
    };
    /**
     * @param {?} displayName
     * @return {?}
     */
    UserDetailsService.prototype.setCurrentUserDisplayName = /**
     * @param {?} displayName
     * @return {?}
     */
    function (displayName) {
        return this.localStorage.setItem('display_name', displayName);
    };
    /**
     * @param {?} username
     * @return {?}
     */
    UserDetailsService.prototype.setCurrentUserUsername = /**
     * @param {?} username
     * @return {?}
     */
    function (username) {
        return this.localStorage.setItem('username', username);
    };
    /**
     * @param {?} accessToken
     * @return {?}
     */
    UserDetailsService.prototype.setCurrentUserAccessToken = /**
     * @param {?} accessToken
     * @return {?}
     */
    function (accessToken) {
        return this.localStorage.setItem('access_token', accessToken);
    };
    /**
     * @param {?} refreshToken
     * @return {?}
     */
    UserDetailsService.prototype.setCurrentUserRefreshToken = /**
     * @param {?} refreshToken
     * @return {?}
     */
    function (refreshToken) {
        return this.localStorage.setItem('refresh_token', refreshToken);
    };
    /**
     * @param {?} role
     * @return {?}
     */
    UserDetailsService.prototype.setCurrentUserRole = /**
     * @param {?} role
     * @return {?}
     */
    function (role) {
        return this.localStorage.setItem('role', role);
    };
    /**
     * @return {?}
     */
    UserDetailsService.prototype.clearCurrentUserDetails = /**
     * @return {?}
     */
    function () {
        var _this = this;
        return this.localStorage.removeItem('display_name').pipe(concatMap((/**
         * @return {?}
         */
        function () { return _this.localStorage.removeItem('username'); })), concatMap((/**
         * @return {?}
         */
        function () { return _this.localStorage.removeItem('access_token'); })), concatMap((/**
         * @return {?}
         */
        function () { return _this.localStorage.removeItem('refresh_token'); })), concatMap((/**
         * @return {?}
         */
        function () { return _this.localStorage.removeItem('role'); })));
    };
    UserDetailsService.decorators = [
        { type: Injectable, args: [{
                    providedIn: 'root'
                },] }
    ];
    /** @nocollapse */
    UserDetailsService.ctorParameters = function () { return [
        { type: LocalStorage }
    ]; };
    /** @nocollapse */ UserDetailsService.ngInjectableDef = ɵɵdefineInjectable({ factory: function UserDetailsService_Factory() { return new UserDetailsService(ɵɵinject(LocalStorage)); }, token: UserDetailsService, providedIn: "root" });
    return UserDetailsService;
}());
if (false) {
    /**
     * @type {?}
     * @private
     */
    UserDetailsService.prototype.localStorage;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var User = /** @class */ (function () {
    function User() {
    }
    return User;
}());
if (false) {
    /** @type {?} */
    User.prototype.username;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var EventsService = /** @class */ (function () {
    function EventsService(http, userDetailsService, urlProvider) {
        this.http = http;
        this.userDetailsService = userDetailsService;
        this.urlProvider = urlProvider;
        this.eventsContainer = new BaseBehaviorSubject();
    }
    /**
     * @return {?}
     */
    EventsService.prototype.findAll = /**
     * @return {?}
     */
    function () {
        return __awaiter(this, void 0, void 0, function () {
            var currentEventList;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.http.get(this.urlProvider.getUrl() + "api/events")
                            .toPromise()];
                    case 1:
                        currentEventList = _a.sent();
                        if (currentEventList) {
                            this.eventsContainer.replaceAll(currentEventList);
                        }
                        return [2 /*return*/, currentEventList];
                }
            });
        });
    };
    /**
     * @return {?}
     */
    EventsService.prototype.getEventsContainer = /**
     * @return {?}
     */
    function () {
        return this.eventsContainer;
    };
    /**
     * @return {?}
     */
    EventsService.prototype.findAllCreatedByCurrentUser = /**
     * @return {?}
     */
    function () {
        var _this = this;
        return this.userDetailsService.getCurrentUserUsername().pipe(concatMap((/**
         * @param {?} username
         * @return {?}
         */
        function (username) { return _this.http.get(_this.urlProvider.getUrl() + "api/users/" + username + "/events"); })))
            .pipe(tap((/**
         * @param {?} events
         * @return {?}
         */
        function (events) { return _this.eventsContainer.replaceAll(events); })));
    };
    /**
     * @return {?}
     */
    EventsService.prototype.findPublished = /**
     * @return {?}
     */
    function () {
        var _this = this;
        return this.http.get(this.urlProvider.getUrl() + "api/events/published")
            .pipe(tap((/**
         * @param {?} events
         * @return {?}
         */
        function (events) { return _this.eventsContainer.replaceAll(events); })));
    };
    /**
     * @param {?} id
     * @return {?}
     */
    EventsService.prototype.findById = /**
     * @param {?} id
     * @return {?}
     */
    function (id) {
        var _this = this;
        return this.http.get(this.urlProvider.getUrl() + "api/events/" + id)
            .pipe(tap((/**
         * @param {?} event
         * @return {?}
         */
        function (event) { return _this.eventsContainer.replace(event, (/**
         * @param {?} e1
         * @param {?} e2
         * @return {?}
         */
        function (e1, e2) { return e1.id == e2.id; })); })));
    };
    /**
     * @return {?}
     */
    EventsService.prototype.createEmptyEvent = /**
     * @return {?}
     */
    function () {
        var _this = this;
        return this.userDetailsService.getCurrentUserUsername().pipe(map((/**
         * @param {?} currentUsername
         * @return {?}
         */
        function (currentUsername) {
            return {
                title: 'New event title',
                description: 'Description',
                dateStart: new Date(),
                dateEnd: new Date(),
                creator: { username: currentUsername }
            };
        })), mergeMap((/**
         * @param {?} requestBody
         * @return {?}
         */
        function (requestBody) { return _this.http.post(_this.urlProvider.getUrl() + "api/events/", requestBody); })));
    };
    /**
     * @param {?} event
     * @return {?}
     */
    EventsService.prototype.deleteEvent = /**
     * @param {?} event
     * @return {?}
     */
    function (event) {
        return __awaiter(this, void 0, void 0, function () {
            var _this = this;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.http.delete(this.urlProvider.getUrl() + "api/events/" + event.id)
                            .toPromise()
                            .then((/**
                         * @return {?}
                         */
                        function () {
                            _this.eventsContainer.remove(event, (/**
                             * @param {?} e1
                             * @param {?} e2
                             * @return {?}
                             */
                            function (e1, e2) { return e1.id == e2.id; }));
                        }))];
                    case 1:
                        _a.sent();
                        return [2 /*return*/];
                }
            });
        });
    };
    /**
     * @param {?} event
     * @return {?}
     */
    EventsService.prototype.updateEvent = /**
     * @param {?} event
     * @return {?}
     */
    function (event) {
        return this.http.put(this.urlProvider.getUrl() + "api/events", event);
    };
    /**
     * @param {?} id
     * @return {?}
     */
    EventsService.prototype.publishEvent = /**
     * @param {?} id
     * @return {?}
     */
    function (id) {
        return this.http.post(this.urlProvider.getUrl() + "api/events/" + id, null);
    };
    /**
     * @param {?} event
     * @return {?}
     */
    EventsService.prototype.createEvent = /**
     * @param {?} event
     * @return {?}
     */
    function (event) {
        var _this = this;
        return this.userDetailsService.getCurrentUserUsername().pipe(map((/**
         * @param {?} currentUsername
         * @return {?}
         */
        function (currentUsername) {
            event.creator = new User();
            event.creator.username = currentUsername;
            return event;
        })), mergeMap((/**
         * @param {?} eventRequestBody
         * @return {?}
         */
        function (eventRequestBody) { return _this.http.post(_this.urlProvider.getUrl() + "api/events/", eventRequestBody); })));
    };
    /**
     * @param {?} id
     * @return {?}
     */
    EventsService.prototype.getQrCode = /**
     * @param {?} id
     * @return {?}
     */
    function (id) {
        return this.http.get(this.urlProvider.getUrl() + "api/events/" + id + "/qrcode", { responseType: 'blob' });
    };
    /**
     * @param {?} text
     * @return {?}
     */
    EventsService.prototype.getEventByTagNameIn = /**
     * @param {?} text
     * @return {?}
     */
    function (text) {
        var _this = this;
        /** @type {?} */
        var filteredEventList = this.http.post(this.urlProvider.getUrl() + "api/events/filter/tags/", text);
        if (filteredEventList) {
            filteredEventList.subscribe((/**
             * @param {?} events
             * @return {?}
             */
            function (events) {
                _this.eventsContainer.replaceAll(events);
            }));
        }
        return filteredEventList;
    };
    /**
     * @param {?} tag
     * @return {?}
     */
    EventsService.prototype.getEventByTagName = /**
     * @param {?} tag
     * @return {?}
     */
    function (tag) {
        var _this = this;
        /** @type {?} */
        var filteredEventList = this.http.post(this.urlProvider.getUrl() + "api/events/filter/tag/", tag);
        if (filteredEventList) {
            filteredEventList.subscribe((/**
             * @param {?} events
             * @return {?}
             */
            function (events) {
                _this.eventsContainer.replaceAll(events);
            }));
        }
        return filteredEventList;
    };
    /**
     * @param {?} eventId
     * @param {?} attachmentId
     * @return {?}
     */
    EventsService.prototype.addAttachmentToEvent = /**
     * @param {?} eventId
     * @param {?} attachmentId
     * @return {?}
     */
    function (eventId, attachmentId) {
        return this.http.put(this.urlProvider.getUrl() + "api/events/" + eventId + "/attachments/" + attachmentId, {});
    };
    /**
     * @param {?} eventId
     * @param {?} attachmentId
     * @return {?}
     */
    EventsService.prototype.deleteAttachment = /**
     * @param {?} eventId
     * @param {?} attachmentId
     * @return {?}
     */
    function (eventId, attachmentId) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.http.delete(this.urlProvider.getUrl() + "api/events/" + eventId + "/attachment/" + attachmentId, {}).toPromise()];
                    case 1: return [2 /*return*/, _a.sent()];
                }
            });
        });
    };
    EventsService.decorators = [
        { type: Injectable, args: [{
                    providedIn: 'root'
                },] }
    ];
    /** @nocollapse */
    EventsService.ctorParameters = function () { return [
        { type: HttpClient },
        { type: UserDetailsService },
        { type: ApiUrlProvider }
    ]; };
    /** @nocollapse */ EventsService.ngInjectableDef = ɵɵdefineInjectable({ factory: function EventsService_Factory() { return new EventsService(ɵɵinject(HttpClient), ɵɵinject(UserDetailsService), ɵɵinject(ApiUrlProvider)); }, token: EventsService, providedIn: "root" });
    return EventsService;
}());
if (false) {
    /**
     * @type {?}
     * @private
     */
    EventsService.prototype.eventsContainer;
    /**
     * @type {?}
     * @private
     */
    EventsService.prototype.http;
    /**
     * @type {?}
     * @private
     */
    EventsService.prototype.userDetailsService;
    /**
     * @type {?}
     * @private
     */
    EventsService.prototype.urlProvider;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/**
 * Created by yana on 25.04.18.
 */
var GoogleGeocoderService = /** @class */ (function () {
    function GoogleGeocoderService(http) {
        this.http = http;
        this.google_api_key = 'AIzaSyDSpY2u6qFKILrAsYTTSzfFhcz_xk3WQvY';
        this.base_url = 'https://maps.googleapis.com/maps/api/';
    }
    /**
     * @param {?} latitude
     * @param {?} longitude
     * @return {?}
     */
    GoogleGeocoderService.prototype.findAddress = /**
     * @param {?} latitude
     * @param {?} longitude
     * @return {?}
     */
    function (latitude, longitude) {
        var _this = this;
        return this.http
            .get(this.base_url + "geocode/json?latlng=" + latitude + "," + longitude + "&key=" + this.google_api_key, { withCredentials: false }).pipe(map((/**
         * @param {?} response
         * @return {?}
         */
        function (response) {
            return _this.parseAddress(response);
        })));
    };
    /**
     * @private
     * @param {?} json
     * @return {?}
     */
    GoogleGeocoderService.prototype.parseAddress = /**
     * @private
     * @param {?} json
     * @return {?}
     */
    function (json) {
        return json['results'][0]['formatted_address'];
    };
    /**
     * @param {?} latitude
     * @param {?} longitude
     * @return {?}
     */
    GoogleGeocoderService.prototype.findCity = /**
     * @param {?} latitude
     * @param {?} longitude
     * @return {?}
     */
    function (latitude, longitude) {
        return this.http
            .get(this.base_url + "geocode/json?latlng=" + latitude + "," + longitude + "&key=" + this.google_api_key);
    };
    GoogleGeocoderService.decorators = [
        { type: Injectable, args: [{
                    providedIn: 'root'
                },] }
    ];
    /** @nocollapse */
    GoogleGeocoderService.ctorParameters = function () { return [
        { type: HttpClient }
    ]; };
    /** @nocollapse */ GoogleGeocoderService.ngInjectableDef = ɵɵdefineInjectable({ factory: function GoogleGeocoderService_Factory() { return new GoogleGeocoderService(ɵɵinject(HttpClient)); }, token: GoogleGeocoderService, providedIn: "root" });
    return GoogleGeocoderService;
}());
if (false) {
    /**
     * @type {?}
     * @private
     */
    GoogleGeocoderService.prototype.google_api_key;
    /**
     * @type {?}
     * @private
     */
    GoogleGeocoderService.prototype.base_url;
    /**
     * @type {?}
     * @private
     */
    GoogleGeocoderService.prototype.http;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var LocationChangeService = /** @class */ (function () {
    function LocationChangeService() {
        this.subject = new Subject();
    }
    /**
     * @param {?} location
     * @return {?}
     */
    LocationChangeService.prototype.changeLocation = /**
     * @param {?} location
     * @return {?}
     */
    function (location) {
        this.subject.next(location);
    };
    LocationChangeService.decorators = [
        { type: Injectable, args: [{
                    providedIn: 'root'
                },] }
    ];
    /** @nocollapse */
    LocationChangeService.ctorParameters = function () { return []; };
    /** @nocollapse */ LocationChangeService.ngInjectableDef = ɵɵdefineInjectable({ factory: function LocationChangeService_Factory() { return new LocationChangeService(); }, token: LocationChangeService, providedIn: "root" });
    return LocationChangeService;
}());
if (false) {
    /** @type {?} */
    LocationChangeService.prototype.subject;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var ParticipantsService = /** @class */ (function () {
    function ParticipantsService(http, urlProvider) {
        this.http = http;
        this.urlProvider = urlProvider;
    }
    /**
     * @param {?} participantsCount
     * @param {?} participantsLimit
     * @return {?}
     */
    ParticipantsService.prototype.formattedParticipantsStr = /**
     * @param {?} participantsCount
     * @param {?} participantsLimit
     * @return {?}
     */
    function (participantsCount, participantsLimit) {
        return this.isParticipantsCountLimited(participantsLimit)
            ? participantsCount + "/" + participantsLimit
            : "" + participantsCount;
    };
    /**
     * @param {?} participantsCount
     * @param {?} participantsLimit
     * @return {?}
     */
    ParticipantsService.prototype.placesNotAvailable = /**
     * @param {?} participantsCount
     * @param {?} participantsLimit
     * @return {?}
     */
    function (participantsCount, participantsLimit) {
        return this.isParticipantsCountLimited(participantsLimit) && participantsCount >= participantsLimit;
    };
    /**
     * @param {?} participantsLimit
     * @return {?}
     */
    ParticipantsService.prototype.isParticipantsCountLimited = /**
     * @param {?} participantsLimit
     * @return {?}
     */
    function (participantsLimit) {
        return participantsLimit > 0;
    };
    ParticipantsService.decorators = [
        { type: Injectable, args: [{
                    providedIn: 'root'
                },] }
    ];
    /** @nocollapse */
    ParticipantsService.ctorParameters = function () { return [
        { type: HttpClient },
        { type: ApiUrlProvider }
    ]; };
    /** @nocollapse */ ParticipantsService.ngInjectableDef = ɵɵdefineInjectable({ factory: function ParticipantsService_Factory() { return new ParticipantsService(ɵɵinject(HttpClient), ɵɵinject(ApiUrlProvider)); }, token: ParticipantsService, providedIn: "root" });
    return ParticipantsService;
}());
if (false) {
    /**
     * @type {?}
     * @private
     */
    ParticipantsService.prototype.http;
    /**
     * @type {?}
     * @private
     */
    ParticipantsService.prototype.urlProvider;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var DisableDirective = /** @class */ (function () {
    function DisableDirective() {
    }
    /**
     * @return {?}
     */
    DisableDirective.prototype.disableClick = /**
     * @return {?}
     */
    function () {
        console.log(this.elementRef.nativeElement);
    };
    DisableDirective.decorators = [
        { type: Directive, args: [{
                    selector: '[qslDisable]'
                },] }
    ];
    DisableDirective.propDecorators = {
        elementRef: [{ type: ViewChild, args: ['mat-button', { static: false },] }],
        disableClick: [{ type: HostListener, args: ['click',] }]
    };
    return DisableDirective;
}());
if (false) {
    /** @type {?} */
    DisableDirective.prototype.elementRef;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var DirectiveModule = /** @class */ (function () {
    function DirectiveModule() {
    }
    DirectiveModule.decorators = [
        { type: NgModule, args: [{
                    declarations: [DisableDirective]
                },] }
    ];
    return DirectiveModule;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var QQEventModule = /** @class */ (function () {
    function QQEventModule() {
    }
    QQEventModule.decorators = [
        { type: NgModule, args: [{
                    declarations: [
                        NextTimeEvents,
                        NotPublished,
                        PublishedEvents,
                        SortByDatePipe
                    ],
                    exports: [
                        NextTimeEvents,
                        NotPublished,
                        PublishedEvents,
                        SortByDatePipe
                    ],
                    imports: [
                        DirectiveModule
                    ]
                },] }
    ];
    return QQEventModule;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var SaveRequestNotificator = /** @class */ (function () {
    function SaveRequestNotificator() {
        this.requestSubject = new Subject();
        this.requestLifecycle = this.requestSubject.asObservable();
    }
    /**
     * @param {?} show
     * @return {?}
     */
    SaveRequestNotificator.prototype.notify = /**
     * @param {?} show
     * @return {?}
     */
    function (show) {
        this.requestSubject.next(show);
    };
    SaveRequestNotificator.decorators = [
        { type: Injectable, args: [{
                    providedIn: 'root'
                },] }
    ];
    /** @nocollapse */
    SaveRequestNotificator.ctorParameters = function () { return []; };
    /** @nocollapse */ SaveRequestNotificator.ngInjectableDef = ɵɵdefineInjectable({ factory: function SaveRequestNotificator_Factory() { return new SaveRequestNotificator(); }, token: SaveRequestNotificator, providedIn: "root" });
    return SaveRequestNotificator;
}());
if (false) {
    /**
     * @type {?}
     * @private
     */
    SaveRequestNotificator.prototype.requestSubject;
    /** @type {?} */
    SaveRequestNotificator.prototype.requestLifecycle;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var ProgressInterceptor = /** @class */ (function () {
    function ProgressInterceptor(loader) {
        this.loader = loader;
    }
    /**
     * @param {?} req
     * @param {?} next
     * @return {?}
     */
    ProgressInterceptor.prototype.intercept = /**
     * @param {?} req
     * @param {?} next
     * @return {?}
     */
    function (req, next) {
        var _this = this;
        /** @type {?} */
        var condition = this.conditionSpining(req);
        if (condition) {
            this.showSaveIndicator();
        }
        console.log();
        return next
            .handle(req).pipe(tap((/**
         * @param {?} event
         * @return {?}
         */
        function (event) {
            if (event instanceof HttpResponse && condition) {
                _this.hideSaveIndicator();
            }
        })), catchError((/**
         * @param {?} e
         * @return {?}
         */
        function (e) {
            _this.errorMessage();
            return throwError(e);
        })));
    };
    /**
     * @param {?} req
     * @return {?}
     */
    ProgressInterceptor.prototype.conditionSpining = /**
     * @param {?} req
     * @return {?}
     */
    function (req) {
        return (req.method === 'POST' || req.method === 'DELETE' || req.method === 'PUT');
    };
    /**
     * @return {?}
     */
    ProgressInterceptor.prototype.showSaveIndicator = /**
     * @return {?}
     */
    function () {
        this.loader.notify(true);
    };
    /**
     * @return {?}
     */
    ProgressInterceptor.prototype.hideSaveIndicator = /**
     * @return {?}
     */
    function () {
        this.loader.notify(false);
    };
    /**
     * @return {?}
     */
    ProgressInterceptor.prototype.errorMessage = /**
     * @return {?}
     */
    function () {
        this.loader.notify(null);
    };
    ProgressInterceptor.decorators = [
        { type: Injectable }
    ];
    /** @nocollapse */
    ProgressInterceptor.ctorParameters = function () { return [
        { type: SaveRequestNotificator }
    ]; };
    return ProgressInterceptor;
}());
if (false) {
    /**
     * @type {?}
     * @private
     */
    ProgressInterceptor.prototype.loader;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var ErrorForbiddenPageInterceptor = /** @class */ (function () {
    function ErrorForbiddenPageInterceptor(router) {
        this.router = router;
    }
    /**
     * @param {?} req
     * @param {?} next
     * @return {?}
     */
    ErrorForbiddenPageInterceptor.prototype.intercept = /**
     * @param {?} req
     * @param {?} next
     * @return {?}
     */
    function (req, next) {
        var _this = this;
        return next
            .handle(req).pipe(tap((/**
         * @return {?}
         */
        function () { })), catchError((/**
         * @param {?} e
         * @return {?}
         */
        function (e) {
            if (e['status'] === 403) {
                _this.router.navigate(['forbidden']);
            }
            return throwError(e);
        })));
    };
    ErrorForbiddenPageInterceptor.decorators = [
        { type: Injectable }
    ];
    /** @nocollapse */
    ErrorForbiddenPageInterceptor.ctorParameters = function () { return [
        { type: Router }
    ]; };
    return ErrorForbiddenPageInterceptor;
}());
if (false) {
    /**
     * @type {?}
     * @private
     */
    ErrorForbiddenPageInterceptor.prototype.router;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var ErrorNotFoundPageInterceptor = /** @class */ (function () {
    function ErrorNotFoundPageInterceptor(router) {
        this.router = router;
    }
    /**
     * @param {?} req
     * @param {?} next
     * @return {?}
     */
    ErrorNotFoundPageInterceptor.prototype.intercept = /**
     * @param {?} req
     * @param {?} next
     * @return {?}
     */
    function (req, next) {
        var _this = this;
        return next
            .handle(req).pipe(tap((/**
         * @return {?}
         */
        function () { })), catchError((/**
         * @param {?} e
         * @return {?}
         */
        function (e) {
            if (e['status'] === 404) {
                _this.router.navigate(['error']);
            }
            return throwError(e);
        })));
    };
    ErrorNotFoundPageInterceptor.decorators = [
        { type: Injectable }
    ];
    /** @nocollapse */
    ErrorNotFoundPageInterceptor.ctorParameters = function () { return [
        { type: Router }
    ]; };
    return ErrorNotFoundPageInterceptor;
}());
if (false) {
    /**
     * @type {?}
     * @private
     */
    ErrorNotFoundPageInterceptor.prototype.router;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var FilterByPredicatePipe = /** @class */ (function () {
    function FilterByPredicatePipe() {
    }
    /**
     * @param {?} fields
     * @param {?} predicate
     * @return {?}
     */
    FilterByPredicatePipe.prototype.transform = /**
     * @param {?} fields
     * @param {?} predicate
     * @return {?}
     */
    function (fields, predicate) {
        return fields.filter((/**
         * @param {?} e
         * @return {?}
         */
        function (e) { return predicate(e); }));
    };
    FilterByPredicatePipe.decorators = [
        { type: Pipe, args: [{
                    name: 'filterByPredicate',
                    pure: false
                },] }
    ];
    return FilterByPredicatePipe;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var ProgressLoaderComponent = /** @class */ (function () {
    function ProgressLoaderComponent(requestNotificator) {
        this.requestNotificator = requestNotificator;
        this.showSpiner = false;
        this.showSuccess = false;
        this.showError = false;
        this.startSaveProcess = false;
        this.count = 0;
    }
    /**
     * @return {?}
     */
    ProgressLoaderComponent.prototype.ngOnInit = /**
     * @return {?}
     */
    function () {
        var _this = this;
        this.requestNotificator.requestLifecycle.subscribe((/**
         * @param {?} startSaveProcess
         * @return {?}
         */
        function (startSaveProcess) {
            _this.startSaveProcess = startSaveProcess;
            _this.turnOnSaveIndicator();
        }));
    };
    /**
     * @return {?}
     */
    ProgressLoaderComponent.prototype.zeroingCountOfRequest = /**
     * @return {?}
     */
    function () {
        if (this.startSaveProcess) {
            this.count++;
        }
        else {
            if (!this.startSaveProcess) {
                --this.count;
            }
        }
    };
    /**
     * @return {?}
     */
    ProgressLoaderComponent.prototype.setIndicators = /**
     * @return {?}
     */
    function () {
        var _this = this;
        if (this.count !== 0) {
            this.showSpiner = true;
            this.showSuccess = false;
            this.showError = false;
        }
        else {
            if (this.count === 0) {
                setTimeout((/**
                 * @return {?}
                 */
                function () {
                    _this.showSpiner = false;
                    _this.showError = false;
                    _this.showSuccess = true;
                    setTimeout((/**
                     * @return {?}
                     */
                    function () {
                        _this.showSuccess = false;
                    }), 1000);
                }), 1000);
            }
        }
    };
    /**
     * @return {?}
     */
    ProgressLoaderComponent.prototype.errorIndicator = /**
     * @return {?}
     */
    function () {
        var _this = this;
        this.count--;
        this.showSpiner = true;
        this.showSuccess = false;
        this.showError = false;
        setTimeout((/**
         * @return {?}
         */
        function () {
            _this.showSpiner = false;
            _this.showError = true;
            setTimeout((/**
             * @return {?}
             */
            function () {
                _this.showError = false;
            }), 1000);
        }), 2000);
    };
    /**
     * @return {?}
     */
    ProgressLoaderComponent.prototype.turnOnSaveIndicator = /**
     * @return {?}
     */
    function () {
        if (this.startSaveProcess != null) {
            this.zeroingCountOfRequest();
            this.setIndicators();
        }
        else {
            this.errorIndicator();
        }
    };
    ProgressLoaderComponent.decorators = [
        { type: Component, args: [{
                    selector: 'qsl-progress-loader',
                    template: "<mat-progress-spinner mode=\"indeterminate\" diameter=\"30\" strokeWidth=\"3\" [style.display]=\"showSpiner ? 'block' : 'none'\">\n</mat-progress-spinner>\n<mat-icon    [style.display]=\"showSuccess ? 'block' : 'none'\"\n             [style.animation-name]=\"showSuccess ? 'trans' : 'none'\">check_circle</mat-icon>\n<mat-icon    [style.display]=\"showError ? 'block' : 'none'\"\n             [style.animation-name]=\"showSuccess ? 'trans' : 'none'\">highlight_off</mat-icon>\n\n",
                    styles: [".mat-spinner circle,::ng-deep .mat-progress-spinner circle{stroke:#9b9b9b;position:absolute}.mat-icon{height:30px!important;width:30px!important;font-size:30px;color:#9b9b9b;-webkit-animation-delay:.5s;animation-delay:.5s;-webkit-animation-duration:1s;animation-duration:1s}@-webkit-keyframes trans{from{opacity:1}to{opacity:0}}@keyframes trans{from{opacity:1}to{opacity:0}}"]
                }] }
    ];
    /** @nocollapse */
    ProgressLoaderComponent.ctorParameters = function () { return [
        { type: SaveRequestNotificator }
    ]; };
    return ProgressLoaderComponent;
}());
if (false) {
    /** @type {?} */
    ProgressLoaderComponent.prototype.showSpiner;
    /** @type {?} */
    ProgressLoaderComponent.prototype.showSuccess;
    /** @type {?} */
    ProgressLoaderComponent.prototype.showError;
    /** @type {?} */
    ProgressLoaderComponent.prototype.startSaveProcess;
    /** @type {?} */
    ProgressLoaderComponent.prototype.count;
    /**
     * @type {?}
     * @private
     */
    ProgressLoaderComponent.prototype.requestNotificator;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var PipesModule = /** @class */ (function () {
    function PipesModule() {
    }
    PipesModule.decorators = [
        { type: NgModule, args: [{
                    declarations: [
                        FilterByPredicatePipe
                    ],
                    exports: [
                        FilterByPredicatePipe
                    ]
                },] }
    ];
    return PipesModule;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var ProgressModule = /** @class */ (function () {
    function ProgressModule() {
    }
    ProgressModule.decorators = [
        { type: NgModule, args: [{
                    imports: [
                        MatIconModule,
                        MatProgressSpinnerModule
                    ],
                    declarations: [
                        ProgressLoaderComponent
                    ],
                    exports: [
                        ProgressLoaderComponent
                    ]
                },] }
    ];
    return ProgressModule;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/**
 * Created by yana on 26.04.18.
 */
var  /**
 * Created by yana on 26.04.18.
 */
Question = /** @class */ (function () {
    function Question() {
    }
    return Question;
}());
if (false) {
    /** @type {?} */
    Question.prototype.id;
    /** @type {?} */
    Question.prototype.votes;
    /** @type {?} */
    Question.prototype.content;
    /** @type {?} */
    Question.prototype.questionStatus;
    /** @type {?} */
    Question.prototype.authorDisplayName;
    /** @type {?} */
    Question.prototype.authorUserName;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/** @enum {number} */
var Status = {
    NEW: 0, OPENED: 1, CLOSED: 2,
};
Status[Status.NEW] = 'NEW';
Status[Status.OPENED] = 'OPENED';
Status[Status.CLOSED] = 'CLOSED';

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var Vote = /** @class */ (function () {
    function Vote() {
    }
    return Vote;
}());
if (false) {
    /** @type {?} */
    Vote.prototype.username;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var QuestionStatusService = /** @class */ (function () {
    function QuestionStatusService() {
    }
    /**
     * @param {?} isTopicPassed
     * @param {?} question
     * @return {?}
     */
    QuestionStatusService.prototype.isUpcoming = /**
     * @param {?} isTopicPassed
     * @param {?} question
     * @return {?}
     */
    function (isTopicPassed, question) {
        return isTopicPassed
            ? question.questionStatus === 'NEW' || question.questionStatus === 'ACTIVE'
            : question.questionStatus === 'NEW';
    };
    QuestionStatusService.decorators = [
        { type: Injectable, args: [{
                    providedIn: 'root'
                },] }
    ];
    /** @nocollapse */
    QuestionStatusService.ctorParameters = function () { return []; };
    /** @nocollapse */ QuestionStatusService.ngInjectableDef = ɵɵdefineInjectable({ factory: function QuestionStatusService_Factory() { return new QuestionStatusService(); }, token: QuestionStatusService, providedIn: "root" });
    return QuestionStatusService;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/**
 * Created by yana on 26.04.18.
 */
var QuestionsService = /** @class */ (function () {
    function QuestionsService(http, urlProvider) {
        this.http = http;
        this.urlProvider = urlProvider;
        this.questionsCollection = new BaseBehaviorSubject();
    }
    /**
     * @param {?} topicId
     * @return {?}
     */
    QuestionsService.prototype.findAllByTopicId = /**
     * @param {?} topicId
     * @return {?}
     */
    function (topicId) {
        var _this = this;
        return this.http.get(this.urlProvider.getUrl() + "api/topics/" + topicId + "/questions")
            .pipe(tap((/**
         * @param {?} questions
         * @return {?}
         */
        function (questions) { return _this.questionsCollection.replaceAll(questions); })));
    };
    /**
     * @param {?} questionId
     * @return {?}
     */
    QuestionsService.prototype.findById = /**
     * @param {?} questionId
     * @return {?}
     */
    function (questionId) {
        return this.http.get(this.urlProvider.getUrl() + "api/questions/" + questionId);
    };
    /**
     * @param {?} topicId
     * @param {?} question
     * @return {?}
     */
    QuestionsService.prototype.post = /**
     * @param {?} topicId
     * @param {?} question
     * @return {?}
     */
    function (topicId, question) {
        return this.http.post(this.urlProvider.getUrl() + "api/topics/" + topicId + "/questions", question);
    };
    /**
     * @param {?} questionId
     * @return {?}
     */
    QuestionsService.prototype.vote = /**
     * @param {?} questionId
     * @return {?}
     */
    function (questionId) {
        return this.http.post(this.urlProvider.getUrl() + "api/questions/" + questionId + "/vote", null);
    };
    /**
     * @param {?} questionId
     * @return {?}
     */
    QuestionsService.prototype.removeVote = /**
     * @param {?} questionId
     * @return {?}
     */
    function (questionId) {
        return this.http.post(this.urlProvider.getUrl() + "api/questions/" + questionId + "/unvote", null);
    };
    /**
     * @param {?} questionId
     * @return {?}
     */
    QuestionsService.prototype.delete = /**
     * @param {?} questionId
     * @return {?}
     */
    function (questionId) {
        return this.http.delete(this.urlProvider.getUrl() + "api/questions/" + questionId);
    };
    /**
     * @param {?} questionId
     * @return {?}
     */
    QuestionsService.prototype.open = /**
     * @param {?} questionId
     * @return {?}
     */
    function (questionId) {
        return this.http.post(this.urlProvider.getUrl() + "api/questions/" + questionId + "/open", null);
    };
    /**
     * @param {?} questionId
     * @return {?}
     */
    QuestionsService.prototype.close = /**
     * @param {?} questionId
     * @return {?}
     */
    function (questionId) {
        return this.http.post(this.urlProvider.getUrl() + "api/questions/" + questionId + "/close", null);
    };
    QuestionsService.decorators = [
        { type: Injectable, args: [{
                    providedIn: 'root'
                },] }
    ];
    /** @nocollapse */
    QuestionsService.ctorParameters = function () { return [
        { type: HttpClient },
        { type: ApiUrlProvider }
    ]; };
    /** @nocollapse */ QuestionsService.ngInjectableDef = ɵɵdefineInjectable({ factory: function QuestionsService_Factory() { return new QuestionsService(ɵɵinject(HttpClient), ɵɵinject(ApiUrlProvider)); }, token: QuestionsService, providedIn: "root" });
    return QuestionsService;
}());
if (false) {
    /** @type {?} */
    QuestionsService.prototype.questionsCollection;
    /**
     * @type {?}
     * @private
     */
    QuestionsService.prototype.http;
    /**
     * @type {?}
     * @private
     */
    QuestionsService.prototype.urlProvider;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var Oauth2Service = /** @class */ (function () {
    function Oauth2Service(http, urlProvider, userDetailsService) {
        this.http = http;
        this.urlProvider = urlProvider;
        this.userDetailsService = userDetailsService;
        this.basicAuthToken = 'Basic Y29uZmFzc2lzdGFudDpzZWNyZXQ=';
    }
    /**
     * @param {?} userId
     * @param {?} displayName
     * @param {?} image
     * @return {?}
     */
    Oauth2Service.prototype.authorize = /**
     * @param {?} userId
     * @param {?} displayName
     * @param {?} image
     * @return {?}
     */
    function (userId, displayName, image) {
        var _this = this;
        return this.registerUser(userId, displayName, image).pipe(concatMap((/**
         * @param {?} user
         * @return {?}
         */
        function (user) { return _this.authenticate(user['username'], user['password']); })));
    };
    /**
     * @param {?} userId
     * @param {?} displayName
     * @param {?} image
     * @return {?}
     */
    Oauth2Service.prototype.authorizeAdmin = /**
     * @param {?} userId
     * @param {?} displayName
     * @param {?} image
     * @return {?}
     */
    function (userId, displayName, image) {
        var _this = this;
        return this.registerAdmin(userId, displayName, image).pipe(concatMap((/**
         * @param {?} admin
         * @return {?}
         */
        function (admin) { return _this.authenticate(admin['username'], admin['password']); })));
    };
    /**
     * @param {?} username
     * @param {?} password
     * @return {?}
     */
    Oauth2Service.prototype.authenticate = /**
     * @param {?} username
     * @param {?} password
     * @return {?}
     */
    function (username, password) {
        var _this = this;
        return this.requestToken(username, password).pipe(concatMap((/**
         * @param {?} authData
         * @return {?}
         */
        function (authData) { return _this.parseAndSaveAuthData(authData); })), concatMap((/**
         * @return {?}
         */
        function () { return _this.requestUserInfo(); })), concatMap((/**
         * @param {?} user
         * @return {?}
         */
        function (user) { return _this.userDetailsService.setCurrentUserDisplayName(user['displayName']).pipe(concatMap((/**
         * @return {?}
         */
        function () { return _this.userDetailsService.setCurrentUserUsername(user['username']); })), concatMap((/**
         * @return {?}
         */
        function () { return _this.userDetailsService.setCurrentUserRole(user['role']); }))); })));
    };
    /**
     * @return {?}
     */
    Oauth2Service.prototype.logout = /**
     * @return {?}
     */
    function () {
        return this.userDetailsService.clearCurrentUserDetails();
    };
    /**
     * @param {?} username
     * @param {?} password
     * @return {?}
     */
    Oauth2Service.prototype.requestToken = /**
     * @param {?} username
     * @param {?} password
     * @return {?}
     */
    function (username, password) {
        return this.http.post(this.urlProvider.getUrl() + "oauth/token", "grant_type=password&username=" + username + "&password=" + password, { headers: { 'Content-Type': 'application/x-www-form-urlencoded' }, withCredentials: true });
    };
    /**
     * @return {?}
     */
    Oauth2Service.prototype.requestUserInfo = /**
     * @return {?}
     */
    function () {
        return this.http.get(this.urlProvider.getUrl() + "users/me");
    };
    /**
     * @return {?}
     */
    Oauth2Service.prototype.refreshToken = /**
     * @return {?}
     */
    function () {
        var _this = this;
        return this.userDetailsService.getCurrentUserRefreshToken().pipe(concatMap((/**
         * @param {?} refreshToken
         * @return {?}
         */
        function (refreshToken) {
            return _this.http.post(_this.urlProvider.getUrl() + "oauth/token", "grant_type=refresh_token&refresh_token=" + refreshToken, { headers: { 'Content-Type': 'application/x-www-form-urlencoded' }, withCredentials: true });
        })), concatMap((/**
         * @param {?} authData
         * @return {?}
         */
        function (authData) {
            if (authData) {
                return _this.parseAndSaveAuthData(authData);
            }
        })));
    };
    /**
     * @private
     * @param {?} username
     * @param {?} displayName
     * @param {?} image
     * @return {?}
     */
    Oauth2Service.prototype.registerUser = /**
     * @private
     * @param {?} username
     * @param {?} displayName
     * @param {?} image
     * @return {?}
     */
    function (username, displayName, image) {
        return this.http.post(this.urlProvider.getUrl() + "users/register", {
            'username': username,
            'displayName': displayName,
            'image': image
        });
    };
    /**
     * @private
     * @param {?} username
     * @param {?} displayName
     * @param {?} image
     * @return {?}
     */
    Oauth2Service.prototype.registerAdmin = /**
     * @private
     * @param {?} username
     * @param {?} displayName
     * @param {?} image
     * @return {?}
     */
    function (username, displayName, image) {
        return this.http.post(this.urlProvider.getUrl() + "users/register/admin", {
            'username': username,
            'displayName': displayName,
            'image': image
        });
    };
    /**
     * @param {?} authData
     * @return {?}
     */
    Oauth2Service.prototype.parseAndSaveAuthData = /**
     * @param {?} authData
     * @return {?}
     */
    function (authData) {
        var _this = this;
        /** @type {?} */
        var accessToken = authData['access_token'];
        /** @type {?} */
        var refreshToken = authData['refresh_token'];
        return this.userDetailsService.setCurrentUserAccessToken(accessToken).pipe(concatMap((/**
         * @return {?}
         */
        function () { return _this.userDetailsService.setCurrentUserRefreshToken(refreshToken); })));
    };
    /**
     * @return {?}
     */
    Oauth2Service.prototype.isAuthenticated = /**
     * @return {?}
     */
    function () {
        return this.userDetailsService.getCurrentUserAccessToken().pipe(map((/**
         * @param {?} accessToken
         * @return {?}
         */
        function (accessToken) { return accessToken !== null; })));
    };
    Oauth2Service.decorators = [
        { type: Injectable, args: [{
                    providedIn: 'root'
                },] }
    ];
    /** @nocollapse */
    Oauth2Service.ctorParameters = function () { return [
        { type: HttpClient },
        { type: ApiUrlProvider },
        { type: UserDetailsService }
    ]; };
    /** @nocollapse */ Oauth2Service.ngInjectableDef = ɵɵdefineInjectable({ factory: function Oauth2Service_Factory() { return new Oauth2Service(ɵɵinject(HttpClient), ɵɵinject(ApiUrlProvider), ɵɵinject(UserDetailsService)); }, token: Oauth2Service, providedIn: "root" });
    return Oauth2Service;
}());
if (false) {
    /** @type {?} */
    Oauth2Service.prototype.basicAuthToken;
    /**
     * @type {?}
     * @private
     */
    Oauth2Service.prototype.http;
    /**
     * @type {?}
     * @private
     */
    Oauth2Service.prototype.urlProvider;
    /**
     * @type {?}
     * @private
     */
    Oauth2Service.prototype.userDetailsService;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var StreamService = /** @class */ (function () {
    function StreamService(http, urlProvider) {
        this.http = http;
        this.urlProvider = urlProvider;
    }
    /**
     * @param {?} streamId
     * @return {?}
     */
    StreamService.prototype.getStreamById = /**
     * @param {?} streamId
     * @return {?}
     */
    function (streamId) {
        return this.http.get(this.urlProvider.getUrl() + "api/streams/" + streamId);
    };
    /**
     * @param {?} eventId
     * @return {?}
     */
    StreamService.prototype.getStreamsByEvent = /**
     * @param {?} eventId
     * @return {?}
     */
    function (eventId) {
        return this.http.get(this.urlProvider.getUrl() + "api/events/" + eventId + "/streams");
    };
    /**
     * @param {?} eventId
     * @param {?} stream
     * @return {?}
     */
    StreamService.prototype.add = /**
     * @param {?} eventId
     * @param {?} stream
     * @return {?}
     */
    function (eventId, stream) {
        return this.http.post(this.urlProvider.getUrl() + "api/events/" + eventId + "/streams/", stream);
    };
    /**
     * @param {?} stream
     * @return {?}
     */
    StreamService.prototype.update = /**
     * @param {?} stream
     * @return {?}
     */
    function (stream) {
        return this.http.put(this.urlProvider.getUrl() + "api/streams/", stream);
    };
    /**
     * @param {?} stream
     * @return {?}
     */
    StreamService.prototype.delete = /**
     * @param {?} stream
     * @return {?}
     */
    function (stream) {
        return this.http.delete(this.urlProvider.getUrl() + "api/streams/" + stream.id);
    };
    StreamService.decorators = [
        { type: Injectable, args: [{
                    providedIn: 'root'
                },] }
    ];
    /** @nocollapse */
    StreamService.ctorParameters = function () { return [
        { type: HttpClient },
        { type: ApiUrlProvider }
    ]; };
    /** @nocollapse */ StreamService.ngInjectableDef = ɵɵdefineInjectable({ factory: function StreamService_Factory() { return new StreamService(ɵɵinject(HttpClient), ɵɵinject(ApiUrlProvider)); }, token: StreamService, providedIn: "root" });
    return StreamService;
}());
if (false) {
    /**
     * @type {?}
     * @private
     */
    StreamService.prototype.http;
    /**
     * @type {?}
     * @private
     */
    StreamService.prototype.urlProvider;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var AdminAuthGuard = /** @class */ (function () {
    function AdminAuthGuard(userDetailsService, oauthService, streamService, router) {
        this.userDetailsService = userDetailsService;
        this.oauthService = oauthService;
        this.streamService = streamService;
        this.router = router;
    }
    /**
     * @param {?} route
     * @return {?}
     */
    AdminAuthGuard.prototype.canActivate = /**
     * @param {?} route
     * @return {?}
     */
    function (route) {
        var _this = this;
        return this.userDetailsService.getCurrentUserRole().pipe(map((/**
         * @param {?} userRole
         * @return {?}
         */
        function (userRole) {
            if (!userRole || userRole !== route.data.expectedRole) {
                _this.redirectToLogin();
                return false;
            }
            return true;
        })));
    };
    /**
     * @private
     * @return {?}
     */
    AdminAuthGuard.prototype.redirectToLogin = /**
     * @private
     * @return {?}
     */
    function () {
        this.router.navigate(['login']);
    };
    AdminAuthGuard.decorators = [
        { type: Injectable, args: [{
                    providedIn: 'root'
                },] }
    ];
    /** @nocollapse */
    AdminAuthGuard.ctorParameters = function () { return [
        { type: UserDetailsService },
        { type: Oauth2Service },
        { type: StreamService },
        { type: Router }
    ]; };
    /** @nocollapse */ AdminAuthGuard.ngInjectableDef = ɵɵdefineInjectable({ factory: function AdminAuthGuard_Factory() { return new AdminAuthGuard(ɵɵinject(UserDetailsService), ɵɵinject(Oauth2Service), ɵɵinject(StreamService), ɵɵinject(Router)); }, token: AdminAuthGuard, providedIn: "root" });
    return AdminAuthGuard;
}());
if (false) {
    /**
     * @type {?}
     * @private
     */
    AdminAuthGuard.prototype.userDetailsService;
    /**
     * @type {?}
     * @private
     */
    AdminAuthGuard.prototype.oauthService;
    /**
     * @type {?}
     * @private
     */
    AdminAuthGuard.prototype.streamService;
    /**
     * @type {?}
     * @private
     */
    AdminAuthGuard.prototype.router;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var ClientAuthGuard = /** @class */ (function () {
    function ClientAuthGuard(authService, streamService, router) {
        this.authService = authService;
        this.streamService = streamService;
        this.router = router;
    }
    /**
     * @param {?} next
     * @param {?} state
     * @return {?}
     */
    ClientAuthGuard.prototype.canActivate = /**
     * @param {?} next
     * @param {?} state
     * @return {?}
     */
    function (next, state) {
        return true;
        // this.authService.isAuthenticated().pipe(
        //   tap(authenticated => {
        //     if (!authenticated) {
        //       this.router.navigate(['login'], { queryParams: { returnUrl: state.url }});
        //     }
        //   }));
    };
    ClientAuthGuard.decorators = [
        { type: Injectable, args: [{
                    providedIn: 'root'
                },] }
    ];
    /** @nocollapse */
    ClientAuthGuard.ctorParameters = function () { return [
        { type: Oauth2Service },
        { type: StreamService },
        { type: Router }
    ]; };
    /** @nocollapse */ ClientAuthGuard.ngInjectableDef = ɵɵdefineInjectable({ factory: function ClientAuthGuard_Factory() { return new ClientAuthGuard(ɵɵinject(Oauth2Service), ɵɵinject(StreamService), ɵɵinject(Router)); }, token: ClientAuthGuard, providedIn: "root" });
    return ClientAuthGuard;
}());
if (false) {
    /**
     * @type {?}
     * @private
     */
    ClientAuthGuard.prototype.authService;
    /**
     * @type {?}
     * @private
     */
    ClientAuthGuard.prototype.streamService;
    /**
     * @type {?}
     * @private
     */
    ClientAuthGuard.prototype.router;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
// import {AuthService} from 'angularx-social-login';
var LoginPageGuard = /** @class */ (function () {
    function LoginPageGuard(authService, router) {
        this.authService = authService;
        this.router = router;
    }
    /**
     * @param {?} next
     * @param {?} state
     * @return {?}
     */
    LoginPageGuard.prototype.canActivate = /**
     * @param {?} next
     * @param {?} state
     * @return {?}
     */
    function (next, state) {
        return true;
        // this.authService.isAuthenticated().pipe(
        //   tap(authenticated => {
        //     if (authenticated) {
        //       this.router.navigate(next.data.destinationRoute);
        //     }
        //   }),
        //   map(authentificated => !authentificated ),);
    };
    LoginPageGuard.decorators = [
        { type: Injectable, args: [{
                    providedIn: 'root'
                },] }
    ];
    /** @nocollapse */
    LoginPageGuard.ctorParameters = function () { return [
        { type: Oauth2Service },
        { type: Router }
    ]; };
    /** @nocollapse */ LoginPageGuard.ngInjectableDef = ɵɵdefineInjectable({ factory: function LoginPageGuard_Factory() { return new LoginPageGuard(ɵɵinject(Oauth2Service), ɵɵinject(Router)); }, token: LoginPageGuard, providedIn: "root" });
    return LoginPageGuard;
}());
if (false) {
    /**
     * @type {?}
     * @private
     */
    LoginPageGuard.prototype.authService;
    /**
     * @type {?}
     * @private
     */
    LoginPageGuard.prototype.router;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var AuthInterceptor = /** @class */ (function () {
    function AuthInterceptor(authService, userDetailsService, router) {
        this.authService = authService;
        this.userDetailsService = userDetailsService;
        this.router = router;
    }
    /**
     * @param {?} originRequest
     * @param {?} next
     * @return {?}
     */
    AuthInterceptor.prototype.intercept = /**
     * @param {?} originRequest
     * @param {?} next
     * @return {?}
     */
    function (originRequest, next) {
        var _this = this;
        return this.addAuthHeader(originRequest).pipe(concatMap((/**
         * @param {?} request
         * @return {?}
         */
        function (request) { return next.handle(request); })), catchError((/**
         * @param {?} error
         * @return {?}
         */
        function (error) {
            switch (error.status) {
                case 401:
                    return _this.handle401Error(originRequest, next);
                case 400:
                    return _this.handle401Error(originRequest, next);
                default:
                    return throwError(error);
            }
        })));
    };
    /**
     * @param {?} originRequest
     * @param {?} next
     * @return {?}
     */
    AuthInterceptor.prototype.handle401Error = /**
     * @param {?} originRequest
     * @param {?} next
     * @return {?}
     */
    function (originRequest, next) {
        var _this = this;
        return this.authService.refreshToken().pipe(concatMap((/**
         * @param {?} success
         * @return {?}
         */
        function (success) {
            if (success) {
                return _this.addAuthHeader(originRequest).pipe(concatMap((/**
                 * @param {?} request
                 * @return {?}
                 */
                function (request) { return next.handle(request); })));
            }
        })), catchError((/**
         * @return {?}
         */
        function () { return _this.logout(); })));
    };
    /**
     * @private
     * @param {?} request
     * @return {?}
     */
    AuthInterceptor.prototype.addAuthHeader = /**
     * @private
     * @param {?} request
     * @return {?}
     */
    function (request) {
        var _this = this;
        /** @type {?} */
        var url = request.url;
        if (url.includes('users/register')
            || url.includes('oauth/token') || request.method === 'GET') {
            return Observable.create((/**
             * @param {?} observer
             * @return {?}
             */
            function (observer) {
                /** @type {?} */
                var headers = request.headers.set('Authorization', _this.authService.basicAuthToken);
                observer.next(request.clone({ headers: headers }));
                observer.complete();
            }));
        }
        else if (!url.includes('maps.googleapis.com') && (url.includes('/api/') || url.includes('/users/me'))) {
            return this.userDetailsService.getCurrentUserAccessToken().pipe(map((/**
             * @param {?} accessToken
             * @return {?}
             */
            function (accessToken) {
                /** @type {?} */
                var headers = request.headers.set('Authorization', "bearer " + accessToken);
                return request.clone({ headers: headers });
            })));
        }
        else {
            return of(request);
        }
    };
    /**
     * @private
     * @return {?}
     */
    AuthInterceptor.prototype.logout = /**
     * @private
     * @return {?}
     */
    function () {
        var _this = this;
        return this.authService.logout().pipe(concatMap((/**
         * @return {?}
         */
        function () { return _this.router.navigate(['login']); })));
    };
    AuthInterceptor.decorators = [
        { type: Injectable, args: [{
                    providedIn: 'root'
                },] }
    ];
    /** @nocollapse */
    AuthInterceptor.ctorParameters = function () { return [
        { type: Oauth2Service },
        { type: UserDetailsService },
        { type: Router }
    ]; };
    /** @nocollapse */ AuthInterceptor.ngInjectableDef = ɵɵdefineInjectable({ factory: function AuthInterceptor_Factory() { return new AuthInterceptor(ɵɵinject(Oauth2Service), ɵɵinject(UserDetailsService), ɵɵinject(Router)); }, token: AuthInterceptor, providedIn: "root" });
    return AuthInterceptor;
}());
if (false) {
    /**
     * @type {?}
     * @private
     */
    AuthInterceptor.prototype.authService;
    /**
     * @type {?}
     * @private
     */
    AuthInterceptor.prototype.userDetailsService;
    /**
     * @type {?}
     * @private
     */
    AuthInterceptor.prototype.router;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/**
 * Created by yana on 25.04.18.
 */
var Speaker = /** @class */ (function () {
    function Speaker() {
    }
    return Speaker;
}());
if (false) {
    /** @type {?} */
    Speaker.prototype.username;
    /** @type {?} */
    Speaker.prototype.email;
    /** @type {?} */
    Speaker.prototype.displayName;
    /** @type {?} */
    Speaker.prototype.image;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var SpeakersService = /** @class */ (function () {
    function SpeakersService(http, urlProvider) {
        this.http = http;
        this.urlProvider = urlProvider;
    }
    /**
     * @param {?} eventId
     * @return {?}
     */
    SpeakersService.prototype.findAllByEvent = /**
     * @param {?} eventId
     * @return {?}
     */
    function (eventId) {
        return this.http.get(this.urlProvider.getUrl() + "users/events/" + eventId + "/speakers");
    };
    /**
     * @param {?} topicId
     * @return {?}
     */
    SpeakersService.prototype.findAllByTopic = /**
     * @param {?} topicId
     * @return {?}
     */
    function (topicId) {
        return this.http.get(this.urlProvider.getUrl() + "users/topics/" + topicId + "/speakers");
    };
    /**
     * @return {?}
     */
    SpeakersService.prototype.findAll = /**
     * @return {?}
     */
    function () {
        return this.http.get(this.urlProvider.getUrl() + "users/public");
    };
    /**
     * @param {?} eventId
     * @return {?}
     */
    SpeakersService.prototype.findAllEventUsers = /**
     * @param {?} eventId
     * @return {?}
     */
    function (eventId) {
        return this.http.get(this.urlProvider.getUrl() + "users/events/" + eventId + "/all");
    };
    SpeakersService.decorators = [
        { type: Injectable, args: [{
                    providedIn: 'root'
                },] }
    ];
    /** @nocollapse */
    SpeakersService.ctorParameters = function () { return [
        { type: HttpClient },
        { type: ApiUrlProvider }
    ]; };
    /** @nocollapse */ SpeakersService.ngInjectableDef = ɵɵdefineInjectable({ factory: function SpeakersService_Factory() { return new SpeakersService(ɵɵinject(HttpClient), ɵɵinject(ApiUrlProvider)); }, token: SpeakersService, providedIn: "root" });
    return SpeakersService;
}());
if (false) {
    /**
     * @type {?}
     * @private
     */
    SpeakersService.prototype.http;
    /**
     * @type {?}
     * @private
     */
    SpeakersService.prototype.urlProvider;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var Stream = /** @class */ (function () {
    function Stream(id, location, name, topics) {
        this.id = id;
        this.location = location;
        this.name = name;
        this.topics = topics;
    }
    return Stream;
}());
if (false) {
    /** @type {?} */
    Stream.prototype.id;
    /** @type {?} */
    Stream.prototype.location;
    /** @type {?} */
    Stream.prototype.name;
    /** @type {?} */
    Stream.prototype.topics;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var StreamEvent = /** @class */ (function () {
    function StreamEvent(event_, stream_) {
        this.eventType = event_;
        this.stream = stream_;
    }
    return StreamEvent;
}());
if (false) {
    /** @type {?} */
    StreamEvent.prototype.eventType;
    /** @type {?} */
    StreamEvent.prototype.stream;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/** @enum {number} */
var StreamEventType = {
    delete: 0,
    add: 1,
};
StreamEventType[StreamEventType.delete] = 'delete';
StreamEventType[StreamEventType.add] = 'add';

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var StreamEventService = /** @class */ (function () {
    function StreamEventService() {
        this.subject = new Subject();
    }
    /**
     * @param {?} stream
     * @return {?}
     */
    StreamEventService.prototype.addEvent = /**
     * @param {?} stream
     * @return {?}
     */
    function (stream) {
        this.subject.next(new StreamEvent(StreamEventType.add, stream));
    };
    /**
     * @param {?} stream
     * @return {?}
     */
    StreamEventService.prototype.deleteEvent = /**
     * @param {?} stream
     * @return {?}
     */
    function (stream) {
        this.subject.next(new StreamEvent(StreamEventType.delete, stream));
    };
    /**
     * @return {?}
     */
    StreamEventService.prototype.getEvent = /**
     * @return {?}
     */
    function () {
        return this.subject;
    };
    StreamEventService.decorators = [
        { type: Injectable, args: [{
                    providedIn: 'root'
                },] }
    ];
    /** @nocollapse */
    StreamEventService.ctorParameters = function () { return []; };
    /** @nocollapse */ StreamEventService.ngInjectableDef = ɵɵdefineInjectable({ factory: function StreamEventService_Factory() { return new StreamEventService(); }, token: StreamEventService, providedIn: "root" });
    return StreamEventService;
}());
if (false) {
    /**
     * @type {?}
     * @private
     */
    StreamEventService.prototype.subject;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var TopilListElementDirective = /** @class */ (function () {
    function TopilListElementDirective(elementRef, render) {
        this.elementRef = elementRef;
        this.render = render;
    }
    Object.defineProperty(TopilListElementDirective.prototype, "changeColor", {
        set: /**
         * @param {?} topicActivity
         * @return {?}
         */
        function (topicActivity) {
            if (topicActivity === 'ACTIVE') {
                this.render.setStyle(this.elementRef.nativeElement, 'background-color', '#6391E6');
                this.render.setStyle(this.elementRef.nativeElement, 'color', '#E6E4D9');
            }
        },
        enumerable: true,
        configurable: true
    });
    TopilListElementDirective.decorators = [
        { type: Directive, args: [{
                    selector: '[backGround]'
                },] }
    ];
    /** @nocollapse */
    TopilListElementDirective.ctorParameters = function () { return [
        { type: ElementRef },
        { type: Renderer2 }
    ]; };
    TopilListElementDirective.propDecorators = {
        changeColor: [{ type: Input, args: ['backGround',] }]
    };
    return TopilListElementDirective;
}());
if (false) {
    /**
     * @type {?}
     * @private
     */
    TopilListElementDirective.prototype.elementRef;
    /**
     * @type {?}
     * @private
     */
    TopilListElementDirective.prototype.render;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var Topic = /** @class */ (function () {
    function Topic() {
    }
    return Topic;
}());
if (false) {
    /** @type {?} */
    Topic.prototype.id;
    /** @type {?} */
    Topic.prototype.description;
    /** @type {?} */
    Topic.prototype.startDate;
    /** @type {?} */
    Topic.prototype.endDate;
    /** @type {?} */
    Topic.prototype.title;
    /** @type {?} */
    Topic.prototype.users;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var TopicStatusService = /** @class */ (function () {
    function TopicStatusService() {
    }
    /**
     * @param {?} topic
     * @return {?}
     */
    TopicStatusService.prototype.ongoing = /**
     * @param {?} topic
     * @return {?}
     */
    function (topic) {
        return moment(topic.startDate).isSameOrBefore(moment()) && moment(topic.endDate).isSameOrAfter(moment());
    };
    /**
     * @param {?} topic
     * @return {?}
     */
    TopicStatusService.prototype.upcoming = /**
     * @param {?} topic
     * @return {?}
     */
    function (topic) {
        return moment(topic.startDate).isAfter(moment());
    };
    /**
     * @param {?} topic
     * @return {?}
     */
    TopicStatusService.prototype.passed = /**
     * @param {?} topic
     * @return {?}
     */
    function (topic) {
        return moment(topic.endDate).isBefore(moment());
    };
    TopicStatusService.decorators = [
        { type: Injectable, args: [{
                    providedIn: 'root'
                },] }
    ];
    /** @nocollapse */
    TopicStatusService.ctorParameters = function () { return []; };
    /** @nocollapse */ TopicStatusService.ngInjectableDef = ɵɵdefineInjectable({ factory: function TopicStatusService_Factory() { return new TopicStatusService(); }, token: TopicStatusService, providedIn: "root" });
    return TopicStatusService;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var TopicService = /** @class */ (function () {
    function TopicService(http, urlProvider) {
        this.http = http;
        this.urlProvider = urlProvider;
    }
    /**
     * @param {?} streamId
     * @return {?}
     */
    TopicService.prototype.getTopics = /**
     * @param {?} streamId
     * @return {?}
     */
    function (streamId) {
        return this.http.get(this.urlProvider.getUrl() + "api/streams/" + streamId + "/topics");
    };
    /**
     * @param {?} topicId
     * @return {?}
     */
    TopicService.prototype.findById = /**
     * @param {?} topicId
     * @return {?}
     */
    function (topicId) {
        return this.http.get(this.urlProvider.getUrl() + "api/topics/" + topicId);
    };
    /**
     * @param {?} topicId
     * @return {?}
     */
    TopicService.prototype.delete = /**
     * @param {?} topicId
     * @return {?}
     */
    function (topicId) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.http.delete(this.urlProvider.getUrl() + "api/topics/" + topicId)
                            .toPromise()];
                    case 1: return [2 /*return*/, _a.sent()];
                }
            });
        });
    };
    /**
     * @param {?} streamId
     * @param {?} topic
     * @return {?}
     */
    TopicService.prototype.update = /**
     * @param {?} streamId
     * @param {?} topic
     * @return {?}
     */
    function (streamId, topic) {
        return this.http.put(this.urlProvider.getUrl() + "api/streams/" + streamId + "/topics", topic);
    };
    /**
     * @param {?} streamId
     * @param {?} topic
     * @return {?}
     */
    TopicService.prototype.create = /**
     * @param {?} streamId
     * @param {?} topic
     * @return {?}
     */
    function (streamId, topic) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.http.post(this.urlProvider.getUrl() + "api/streams/" + streamId + "/topics", topic)
                            .toPromise()];
                    case 1: return [2 /*return*/, _a.sent()];
                }
            });
        });
    };
    TopicService.decorators = [
        { type: Injectable, args: [{
                    providedIn: 'root'
                },] }
    ];
    /** @nocollapse */
    TopicService.ctorParameters = function () { return [
        { type: HttpClient },
        { type: ApiUrlProvider }
    ]; };
    /** @nocollapse */ TopicService.ngInjectableDef = ɵɵdefineInjectable({ factory: function TopicService_Factory() { return new TopicService(ɵɵinject(HttpClient), ɵɵinject(ApiUrlProvider)); }, token: TopicService, providedIn: "root" });
    return TopicService;
}());
if (false) {
    /**
     * @type {?}
     * @private
     */
    TopicService.prototype.http;
    /**
     * @type {?}
     * @private
     */
    TopicService.prototype.urlProvider;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var TopicEditService = /** @class */ (function () {
    function TopicEditService() {
        this.subject = new Subject();
    }
    /**
     * @param {?} topic
     * @return {?}
     */
    TopicEditService.prototype.edit = /**
     * @param {?} topic
     * @return {?}
     */
    function (topic) {
        this.subject.next(topic);
    };
    /**
     * @return {?}
     */
    TopicEditService.prototype.getEditedTopic = /**
     * @return {?}
     */
    function () {
        return this.subject.asObservable();
    };
    TopicEditService.decorators = [
        { type: Injectable, args: [{
                    providedIn: 'root'
                },] }
    ];
    /** @nocollapse */
    TopicEditService.ctorParameters = function () { return []; };
    /** @nocollapse */ TopicEditService.ngInjectableDef = ɵɵdefineInjectable({ factory: function TopicEditService_Factory() { return new TopicEditService(); }, token: TopicEditService, providedIn: "root" });
    return TopicEditService;
}());
if (false) {
    /**
     * @type {?}
     * @private
     */
    TopicEditService.prototype.subject;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var TopicValidationService = /** @class */ (function () {
    function TopicValidationService() {
    }
    /**
     * @param {?} value
     * @return {?}
     */
    TopicValidationService.prototype.isStatusValid = /**
     * @param {?} value
     * @return {?}
     */
    function (value) {
        return new FormControl(value, [Validators.required])['status'] === 'INVALID';
    };
    /**
     * @param {?} topicDate
     * @param {?} event
     * @return {?}
     */
    TopicValidationService.prototype.isDateOfTopicIncludeInEventRange = /**
     * @param {?} topicDate
     * @param {?} event
     * @return {?}
     */
    function (topicDate, event) {
        return (!moment(topicDate).set({ 'hour': 0, 'minutes': 0, 'seconds': 1 }).isBetween(moment(event.dateStart).set({ 'hour': 0, 'minutes': 0, 'seconds': 0 }).startOf('day'), moment(event.dateEnd).endOf('day')));
    };
    /**
     * @param {?} topic
     * @return {?}
     */
    TopicValidationService.prototype.isTitleNotEmpty = /**
     * @param {?} topic
     * @return {?}
     */
    function (topic) {
        return topic.title === undefined || topic.title.length === 0;
    };
    TopicValidationService.decorators = [
        { type: Injectable, args: [{
                    providedIn: 'root'
                },] }
    ];
    /** @nocollapse */
    TopicValidationService.ctorParameters = function () { return []; };
    /** @nocollapse */ TopicValidationService.ngInjectableDef = ɵɵdefineInjectable({ factory: function TopicValidationService_Factory() { return new TopicValidationService(); }, token: TopicValidationService, providedIn: "root" });
    return TopicValidationService;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var SortTopicByMinutesAndHours = /** @class */ (function () {
    function SortTopicByMinutesAndHours() {
    }
    /**
     * @param {?} array
     * @return {?}
     */
    SortTopicByMinutesAndHours.prototype.transform = /**
     * @param {?} array
     * @return {?}
     */
    function (array) {
        return array.sort((/**
         * @param {?} a
         * @param {?} b
         * @return {?}
         */
        function (a, b) {
            return moment(a.startDate).unix() - moment(b.startDate).unix();
        }));
    };
    SortTopicByMinutesAndHours.decorators = [
        { type: Pipe, args: [{
                    name: 'uniqueHoursminutes',
                    pure: false
                },] }
    ];
    return SortTopicByMinutesAndHours;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var SortTopicByDatesPipe = /** @class */ (function () {
    function SortTopicByDatesPipe() {
    }
    /**
     * @param {?} value
     * @param {?} shortDate
     * @return {?}
     */
    SortTopicByDatesPipe.prototype.transform = /**
     * @param {?} value
     * @param {?} shortDate
     * @return {?}
     */
    function (value, shortDate) {
        return value.filter((/**
         * @param {?} it
         * @return {?}
         */
        function (it) {
            if (moment(it.startDate).isSame(moment(shortDate), 'day') && moment(it.startDate).isSame(moment(shortDate), 'month')) {
                return it;
            }
        }));
    };
    SortTopicByDatesPipe.decorators = [
        { type: Pipe, args: [{
                    name: 'putToDayBucket',
                    pure: false
                },] }
    ];
    return SortTopicByDatesPipe;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var QqTopicModule = /** @class */ (function () {
    function QqTopicModule() {
    }
    QqTopicModule.decorators = [
        { type: NgModule, args: [{
                    imports: [],
                    declarations: [
                        TopilListElementDirective,
                        SortTopicByDatesPipe,
                        SortTopicByMinutesAndHours,
                    ],
                    exports: [
                        TopilListElementDirective,
                        SortTopicByDatesPipe,
                        SortTopicByMinutesAndHours
                    ]
                },] }
    ];
    return QqTopicModule;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var EventMapService = /** @class */ (function () {
    function EventMapService(googleGeocoder, changeLocationService) {
        this.googleGeocoder = googleGeocoder;
        this.changeLocationService = changeLocationService;
    }
    /**
     * @param {?} eventLocation
     * @return {?}
     */
    EventMapService.prototype.getLocation = /**
     * @param {?} eventLocation
     * @return {?}
     */
    function (eventLocation) {
        if (eventLocation.latitude === 0 && eventLocation.longitude === 0) {
            navigator.geolocation.getCurrentPosition((/**
             * @param {?} postion
             * @return {?}
             */
            function (postion) {
                eventLocation.latitude = postion.coords.latitude;
                eventLocation.longitude = postion.coords.longitude;
            }));
        }
    };
    /**
     * @param {?} event
     * @param {?} eventLocation
     * @return {?}
     */
    EventMapService.prototype.changeMarker = /**
     * @param {?} event
     * @param {?} eventLocation
     * @return {?}
     */
    function (event, eventLocation) {
        var _this = this;
        eventLocation.latitude = event.coords.lat;
        eventLocation.longitude = event.coords.lng;
        this.googleGeocoder.findAddress(eventLocation.latitude, eventLocation.longitude).subscribe((/**
         * @param {?} value
         * @return {?}
         */
        function (value) {
            eventLocation.formattedAddress = value;
            _this.changeLocationService.changeLocation(eventLocation);
        }));
        this.googleGeocoder.findCity(eventLocation.latitude, eventLocation.longitude).subscribe((/**
         * @param {?} mapResponse
         * @return {?}
         */
        function (mapResponse) {
            eventLocation.placeId = mapResponse['results'][0].place_id;
            console.log(eventLocation.placeId);
            console.log(mapResponse['results'][0].place_id);
            mapResponse['results'][0].address_components.forEach((/**
             * @param {?} it
             * @return {?}
             */
            function (it) {
                if (it.types[0] === 'locality' && it.types[1] === 'political') {
                    eventLocation.cityName = it.short_name;
                }
            }));
        }));
    };
    EventMapService.decorators = [
        { type: Injectable, args: [{
                    providedIn: 'root'
                },] }
    ];
    /** @nocollapse */
    EventMapService.ctorParameters = function () { return [
        { type: GoogleGeocoderService },
        { type: LocationChangeService }
    ]; };
    /** @nocollapse */ EventMapService.ngInjectableDef = ɵɵdefineInjectable({ factory: function EventMapService_Factory() { return new EventMapService(ɵɵinject(GoogleGeocoderService), ɵɵinject(LocationChangeService)); }, token: EventMapService, providedIn: "root" });
    return EventMapService;
}());
if (false) {
    /**
     * @type {?}
     * @private
     */
    EventMapService.prototype.googleGeocoder;
    /**
     * @type {?}
     * @private
     */
    EventMapService.prototype.changeLocationService;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var StreamCreateService = /** @class */ (function () {
    function StreamCreateService() {
        this.subject = new Subject();
    }
    /**
     * @return {?}
     */
    StreamCreateService.prototype.cancleAdd = /**
     * @return {?}
     */
    function () {
        this.subject.next({ action: false, stream: '' });
    };
    /**
     * @param {?} stream
     * @return {?}
     */
    StreamCreateService.prototype.AddStream = /**
     * @param {?} stream
     * @return {?}
     */
    function (stream) {
        this.subject.next({ action: true, stream: stream });
    };
    StreamCreateService.decorators = [
        { type: Injectable, args: [{
                    providedIn: 'root'
                },] }
    ];
    /** @nocollapse */ StreamCreateService.ngInjectableDef = ɵɵdefineInjectable({ factory: function StreamCreateService_Factory() { return new StreamCreateService(); }, token: StreamCreateService, providedIn: "root" });
    return StreamCreateService;
}());
if (false) {
    /** @type {?} */
    StreamCreateService.prototype.subject;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var EventUpdateService = /** @class */ (function () {
    function EventUpdateService() {
        this.subject = new Subject();
    }
    /**
     * @param {?} event
     * @return {?}
     */
    EventUpdateService.prototype.notifyEventChange = /**
     * @param {?} event
     * @return {?}
     */
    function (event) {
        this.subject.next(event);
    };
    EventUpdateService.decorators = [
        { type: Injectable, args: [{
                    providedIn: 'root'
                },] }
    ];
    /** @nocollapse */ EventUpdateService.ngInjectableDef = ɵɵdefineInjectable({ factory: function EventUpdateService_Factory() { return new EventUpdateService(); }, token: EventUpdateService, providedIn: "root" });
    return EventUpdateService;
}());
if (false) {
    /** @type {?} */
    EventUpdateService.prototype.subject;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var EventEditorService = /** @class */ (function () {
    function EventEditorService(activatedRoute, router, eventsService, streamService, snackBar, locationChangeSerive, eventsDetailsAdminService) {
        this.activatedRoute = activatedRoute;
        this.router = router;
        this.eventsService = eventsService;
        this.streamService = streamService;
        this.snackBar = snackBar;
        this.locationChangeSerive = locationChangeSerive;
        this.eventsDetailsAdminService = eventsDetailsAdminService;
    }
    /**
     * @param {?} event
     * @return {?}
     */
    EventEditorService.prototype.isEventValid = /**
     * @param {?} event
     * @return {?}
     */
    function (event) {
        return event.title && event.title !== null;
    };
    /**
     * @param {?} event
     * @return {?}
     */
    EventEditorService.prototype.isValidParticipantLimit = /**
     * @param {?} event
     * @return {?}
     */
    function (event) {
        return (new FormControl(event.participantsLimit, [
            Validators.pattern('[0-9][0-9]{0,4}$'),
        ])['status'] === 'INVALID');
    };
    /**
     * @param {?} date
     * @return {?}
     */
    EventEditorService.prototype.isValidDate = /**
     * @param {?} date
     * @return {?}
     */
    function (date) {
        return date === '';
    };
    /**
     * @param {?} event
     * @return {?}
     */
    EventEditorService.prototype.createEvent = /**
     * @param {?} event
     * @return {?}
     */
    function (event) {
        return this.eventsService.createEvent(event);
    };
    /**
     * @param {?} event
     * @return {?}
     */
    EventEditorService.prototype.updateEvent = /**
     * @param {?} event
     * @return {?}
     */
    function (event) {
        return this.eventsService.updateEvent(event);
    };
    /**
     * @param {?} event
     * @param {?} dateStart
     * @param {?} dateEnd
     * @return {?}
     */
    EventEditorService.prototype.setDatesRangeToEvent = /**
     * @param {?} event
     * @param {?} dateStart
     * @param {?} dateEnd
     * @return {?}
     */
    function (event, dateStart, dateEnd) {
        event.dateEnd = dateEnd;
        event.dateStart = dateStart;
    };
    /**
     * @param {?} dateStart
     * @param {?} dateEnd
     * @param {?} topics
     * @return {?}
     */
    EventEditorService.prototype.isEventDatesPassedToTopicsDates = /**
     * @param {?} dateStart
     * @param {?} dateEnd
     * @param {?} topics
     * @return {?}
     */
    function (dateStart, dateEnd, topics) {
        return (moment(dateEnd).unix() < moment(topics[topics.length - 1].endDate).unix()
            || moment(dateStart).unix() > moment(topics[0].startDate).unix());
    };
    /**
     * @param {?} event
     * @return {?}
     */
    EventEditorService.prototype.parseEventTopics = /**
     * @param {?} event
     * @return {?}
     */
    function (event) {
        var _this = this;
        if (event.streams) {
            return event.streams
                .reduce((/**
             * @param {?} allTopics
             * @param {?} stream
             * @return {?}
             */
            function (allTopics, stream) { return allTopics.concat(stream.topics); }), [])
                .sort((/**
             * @param {?} f
             * @param {?} n
             * @return {?}
             */
            function (f, n) { return _this.eventsDetailsAdminService.compareDates(f, n); }));
        }
        else {
            return [];
        }
    };
    /**
     * @param {?} onLocationChanges
     * @return {?}
     */
    EventEditorService.prototype.requestLocationChanges = /**
     * @param {?} onLocationChanges
     * @return {?}
     */
    function (onLocationChanges) {
        if (this.locationChangeSerive) {
            this.locationSubscription = this.locationChangeSerive.subject.subscribe((/**
             * @param {?} location
             * @return {?}
             */
            function (location) {
                onLocationChanges(location);
            }));
        }
    };
    /**
     * @return {?}
     */
    EventEditorService.prototype.unsubscribeAll = /**
     * @return {?}
     */
    function () {
        this.unsubscribe(this.locationSubscription);
    };
    /**
     * @private
     * @param {?} subscription
     * @return {?}
     */
    EventEditorService.prototype.unsubscribe = /**
     * @private
     * @param {?} subscription
     * @return {?}
     */
    function (subscription) {
        if (subscription) {
            subscription.unsubscribe();
        }
    };
    EventEditorService.decorators = [
        { type: Injectable, args: [{
                    providedIn: 'root'
                },] }
    ];
    /** @nocollapse */
    EventEditorService.ctorParameters = function () { return [
        { type: ActivatedRoute },
        { type: Router },
        { type: EventsService },
        { type: StreamService },
        { type: MatSnackBar },
        { type: LocationChangeService },
        { type: AdminDetailsServiceService }
    ]; };
    /** @nocollapse */ EventEditorService.ngInjectableDef = ɵɵdefineInjectable({ factory: function EventEditorService_Factory() { return new EventEditorService(ɵɵinject(ActivatedRoute), ɵɵinject(Router), ɵɵinject(EventsService), ɵɵinject(StreamService), ɵɵinject(MatSnackBar$1), ɵɵinject(LocationChangeService), ɵɵinject(AdminDetailsServiceService)); }, token: EventEditorService, providedIn: "root" });
    return EventEditorService;
}());
if (false) {
    /**
     * @type {?}
     * @private
     */
    EventEditorService.prototype.locationSubscription;
    /**
     * @type {?}
     * @private
     */
    EventEditorService.prototype.activatedRoute;
    /**
     * @type {?}
     * @private
     */
    EventEditorService.prototype.router;
    /**
     * @type {?}
     * @private
     */
    EventEditorService.prototype.eventsService;
    /**
     * @type {?}
     * @private
     */
    EventEditorService.prototype.streamService;
    /**
     * @type {?}
     * @private
     */
    EventEditorService.prototype.snackBar;
    /**
     * @type {?}
     * @private
     */
    EventEditorService.prototype.locationChangeSerive;
    /**
     * @type {?}
     * @private
     */
    EventEditorService.prototype.eventsDetailsAdminService;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var EventNavigationSubjectService = /** @class */ (function (_super) {
    __extends(EventNavigationSubjectService, _super);
    function EventNavigationSubjectService() {
        return _super.call(this) || this;
    }
    EventNavigationSubjectService.decorators = [
        { type: Injectable, args: [{
                    providedIn: 'root'
                },] }
    ];
    /** @nocollapse */
    EventNavigationSubjectService.ctorParameters = function () { return []; };
    /** @nocollapse */ EventNavigationSubjectService.ngInjectableDef = ɵɵdefineInjectable({ factory: function EventNavigationSubjectService_Factory() { return new EventNavigationSubjectService(); }, token: EventNavigationSubjectService, providedIn: "root" });
    return EventNavigationSubjectService;
}(Subject));

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var PopupsService = /** @class */ (function () {
    function PopupsService(dialog, snackBar) {
        this.dialog = dialog;
        this.snackBar = snackBar;
    }
    /**
     * @param {?} message
     * @param {?} positiveAnswer
     * @param {?} negativeAnswer
     * @param {?} onActionConfirmed
     * @return {?}
     */
    PopupsService.prototype.showConfirmationDialog = /**
     * @param {?} message
     * @param {?} positiveAnswer
     * @param {?} negativeAnswer
     * @param {?} onActionConfirmed
     * @return {?}
     */
    function (message, positiveAnswer, negativeAnswer, onActionConfirmed) {
        var _this = this;
        this.confirmationDialogSubscription =
            this.openDialogWindow(message, positiveAnswer, negativeAnswer)
                .afterClosed()
                .subscribe((/**
             * @param {?} confirm
             * @return {?}
             */
            function (confirm) {
                onActionConfirmed(confirm);
                _this.confirmationDialogSubscription.unsubscribe();
            }));
    };
    /**
     * @param {?} message
     * @return {?}
     */
    PopupsService.prototype.showSnackBar = /**
     * @param {?} message
     * @return {?}
     */
    function (message) {
        this.snackBar.openFromComponent(SnackBarComponent, {
            horizontalPosition: 'center',
            verticalPosition: 'bottom',
            data: { message: message },
            duration: 3000
        });
    };
    /**
     * @private
     * @param {?} message
     * @param {?} positiveAnswer
     * @param {?} negativeAnswer
     * @return {?}
     */
    PopupsService.prototype.openDialogWindow = /**
     * @private
     * @param {?} message
     * @param {?} positiveAnswer
     * @param {?} negativeAnswer
     * @return {?}
     */
    function (message, positiveAnswer, negativeAnswer) {
        return this.dialog.open(ConfirmDialogWindowComponent, this.dialogDataConfig(message, positiveAnswer, negativeAnswer));
    };
    /**
     * @private
     * @param {?} message
     * @param {?} positiveAnswer
     * @param {?} negativeAnswer
     * @return {?}
     */
    PopupsService.prototype.dialogDataConfig = /**
     * @private
     * @param {?} message
     * @param {?} positiveAnswer
     * @param {?} negativeAnswer
     * @return {?}
     */
    function (message, positiveAnswer, negativeAnswer) {
        return {
            data: {
                text: message, positiveAnswer: positiveAnswer, negativeAnswer: negativeAnswer
            }
        };
    };
    PopupsService.decorators = [
        { type: Injectable, args: [{
                    providedIn: 'root'
                },] }
    ];
    /** @nocollapse */
    PopupsService.ctorParameters = function () { return [
        { type: MatDialog },
        { type: MatSnackBar }
    ]; };
    /** @nocollapse */ PopupsService.ngInjectableDef = ɵɵdefineInjectable({ factory: function PopupsService_Factory() { return new PopupsService(ɵɵinject(MatDialog$1), ɵɵinject(MatSnackBar$1)); }, token: PopupsService, providedIn: "root" });
    return PopupsService;
}());
if (false) {
    /**
     * @type {?}
     * @private
     */
    PopupsService.prototype.confirmationDialogSubscription;
    /** @type {?} */
    PopupsService.prototype.dialog;
    /**
     * @type {?}
     * @private
     */
    PopupsService.prototype.snackBar;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var EventUpdateDisableService = /** @class */ (function () {
    function EventUpdateDisableService() {
        this.subject = new Subject();
    }
    /**
     * @param {?} value
     * @return {?}
     */
    EventUpdateDisableService.prototype.disableEventUpdate = /**
     * @param {?} value
     * @return {?}
     */
    function (value) {
        this.subject.next(value);
    };
    EventUpdateDisableService.decorators = [
        { type: Injectable, args: [{
                    providedIn: 'root'
                },] }
    ];
    /** @nocollapse */ EventUpdateDisableService.ngInjectableDef = ɵɵdefineInjectable({ factory: function EventUpdateDisableService_Factory() { return new EventUpdateDisableService(); }, token: EventUpdateDisableService, providedIn: "root" });
    return EventUpdateDisableService;
}());
if (false) {
    /** @type {?} */
    EventUpdateDisableService.prototype.subject;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var AdminEventCreateDetailsService = /** @class */ (function () {
    function AdminEventCreateDetailsService() {
        this.subject = new Subject();
    }
    /**
     * @param {?} text
     * @return {?}
     */
    AdminEventCreateDetailsService.prototype.sendMessage = /**
     * @param {?} text
     * @return {?}
     */
    function (text) {
        this.subject.next(text);
    };
    AdminEventCreateDetailsService.decorators = [
        { type: Injectable, args: [{
                    providedIn: 'root'
                },] }
    ];
    /** @nocollapse */ AdminEventCreateDetailsService.ngInjectableDef = ɵɵdefineInjectable({ factory: function AdminEventCreateDetailsService_Factory() { return new AdminEventCreateDetailsService(); }, token: AdminEventCreateDetailsService, providedIn: "root" });
    return AdminEventCreateDetailsService;
}());
if (false) {
    /** @type {?} */
    AdminEventCreateDetailsService.prototype.subject;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var PingBackEndService = /** @class */ (function () {
    function PingBackEndService(http, urlProvider) {
        this.http = http;
        this.urlProvider = urlProvider;
    }
    /**
     * @return {?}
     */
    PingBackEndService.prototype.startServer = /**
     * @return {?}
     */
    function () {
        return this.http.get(this.urlProvider.getUrl() + "api/server");
    };
    PingBackEndService.decorators = [
        { type: Injectable, args: [{
                    providedIn: 'root'
                },] }
    ];
    /** @nocollapse */
    PingBackEndService.ctorParameters = function () { return [
        { type: HttpClient },
        { type: ApiUrlProvider }
    ]; };
    /** @nocollapse */ PingBackEndService.ngInjectableDef = ɵɵdefineInjectable({ factory: function PingBackEndService_Factory() { return new PingBackEndService(ɵɵinject(HttpClient), ɵɵinject(ApiUrlProvider)); }, token: PingBackEndService, providedIn: "root" });
    return PingBackEndService;
}());
if (false) {
    /**
     * @type {?}
     * @private
     */
    PingBackEndService.prototype.http;
    /**
     * @type {?}
     * @private
     */
    PingBackEndService.prototype.urlProvider;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var EventSharedUsersService = /** @class */ (function () {
    function EventSharedUsersService(http, urlProvider) {
        this.http = http;
        this.urlProvider = urlProvider;
    }
    /**
     * @param {?} eventId
     * @return {?}
     */
    EventSharedUsersService.prototype.getAllSharedUsers = /**
     * @param {?} eventId
     * @return {?}
     */
    function (eventId) {
        return this.http.get(this.urlProvider.getUrl() + "api/events/" + eventId + "/share");
    };
    /**
     * @param {?} sharedUsers
     * @param {?} eventId
     * @return {?}
     */
    EventSharedUsersService.prototype.addAllSharedUsers = /**
     * @param {?} sharedUsers
     * @param {?} eventId
     * @return {?}
     */
    function (sharedUsers, eventId) {
        return this.http.post(this.urlProvider.getUrl() + "api/events/" + eventId + "/share/add", sharedUsers);
    };
    /**
     * @param {?} eventId
     * @param {?} user
     * @return {?}
     */
    EventSharedUsersService.prototype.deleteSharedUser = /**
     * @param {?} eventId
     * @param {?} user
     * @return {?}
     */
    function (eventId, user) {
        return this.http.post(this.urlProvider.getUrl() + "api/events/" + eventId + "/share/remove", user);
    };
    /**
     * @param {?} username
     * @return {?}
     */
    EventSharedUsersService.prototype.getAllEventShared = /**
     * @param {?} username
     * @return {?}
     */
    function (username) {
        return this.http.get(this.urlProvider.getUrl() + "api/" + username + "/shared");
    };
    EventSharedUsersService.decorators = [
        { type: Injectable, args: [{
                    providedIn: 'root'
                },] }
    ];
    /** @nocollapse */
    EventSharedUsersService.ctorParameters = function () { return [
        { type: HttpClient },
        { type: ApiUrlProvider }
    ]; };
    /** @nocollapse */ EventSharedUsersService.ngInjectableDef = ɵɵdefineInjectable({ factory: function EventSharedUsersService_Factory() { return new EventSharedUsersService(ɵɵinject(HttpClient), ɵɵinject(ApiUrlProvider)); }, token: EventSharedUsersService, providedIn: "root" });
    return EventSharedUsersService;
}());
if (false) {
    /**
     * @type {?}
     * @private
     */
    EventSharedUsersService.prototype.http;
    /**
     * @type {?}
     * @private
     */
    EventSharedUsersService.prototype.urlProvider;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var AdminEventPermeationGuard = /** @class */ (function () {
    function AdminEventPermeationGuard(userDetailsService, activatedRoute, eventsService, eventSharedUserService, router) {
        this.userDetailsService = userDetailsService;
        this.activatedRoute = activatedRoute;
        this.eventsService = eventsService;
        this.eventSharedUserService = eventSharedUserService;
        this.router = router;
    }
    /**
     * @param {?} route
     * @return {?}
     */
    AdminEventPermeationGuard.prototype.canActivate = /**
     * @param {?} route
     * @return {?}
     */
    function (route) {
        var _this = this;
        return this.userDetailsService.getCurrentUserUsername().pipe(mergeMap((/**
         * @param {?} username
         * @return {?}
         */
        function (username) {
            return zip(_this.eventSharedUserService.getAllSharedUsers(route.params.id), _this.eventsService.findById(route.params.id), (/**
             * @param {?} sharedUsers
             * @param {?} event
             * @return {?}
             */
            function (sharedUsers, event) { return ({ sharedUsers: sharedUsers, event: event }); })).pipe(map((/**
             * @param {?} param
             * @return {?}
             */
            function (param) {
                return (param.event.creator.username === username) || (param.sharedUsers.some((/**
                 * @param {?} user
                 * @return {?}
                 */
                function (user) { return user.username === username; })));
            })), tap((/**
             * @param {?} allowRedirect
             * @return {?}
             */
            function (allowRedirect) {
                if (!allowRedirect) {
                    _this.redirectToPermissionDenied();
                }
            })));
        })));
    };
    /**
     * @private
     * @return {?}
     */
    AdminEventPermeationGuard.prototype.redirectToPermissionDenied = /**
     * @private
     * @return {?}
     */
    function () {
        this.router.navigate(['forbidden']);
    };
    AdminEventPermeationGuard.decorators = [
        { type: Injectable, args: [{
                    providedIn: 'root'
                },] }
    ];
    /** @nocollapse */
    AdminEventPermeationGuard.ctorParameters = function () { return [
        { type: UserDetailsService },
        { type: ActivatedRoute },
        { type: EventsService },
        { type: EventSharedUsersService },
        { type: Router }
    ]; };
    /** @nocollapse */ AdminEventPermeationGuard.ngInjectableDef = ɵɵdefineInjectable({ factory: function AdminEventPermeationGuard_Factory() { return new AdminEventPermeationGuard(ɵɵinject(UserDetailsService), ɵɵinject(ActivatedRoute), ɵɵinject(EventsService), ɵɵinject(EventSharedUsersService), ɵɵinject(Router)); }, token: AdminEventPermeationGuard, providedIn: "root" });
    return AdminEventPermeationGuard;
}());
if (false) {
    /**
     * @type {?}
     * @private
     */
    AdminEventPermeationGuard.prototype.userDetailsService;
    /**
     * @type {?}
     * @private
     */
    AdminEventPermeationGuard.prototype.activatedRoute;
    /**
     * @type {?}
     * @private
     */
    AdminEventPermeationGuard.prototype.eventsService;
    /**
     * @type {?}
     * @private
     */
    AdminEventPermeationGuard.prototype.eventSharedUserService;
    /**
     * @type {?}
     * @private
     */
    AdminEventPermeationGuard.prototype.router;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var ClientEventPermeationGuard = /** @class */ (function () {
    function ClientEventPermeationGuard(userDetailsService, activatedRoute, eventsService, router) {
        this.userDetailsService = userDetailsService;
        this.activatedRoute = activatedRoute;
        this.eventsService = eventsService;
        this.router = router;
    }
    /**
     * @param {?} route
     * @return {?}
     */
    ClientEventPermeationGuard.prototype.canActivate = /**
     * @param {?} route
     * @return {?}
     */
    function (route) {
        var _this = this;
        return this.eventsService.findById(route.params.eventId).pipe(map((/**
         * @param {?} event
         * @return {?}
         */
        function (event) {
            return (event.status.toString() === StatusEvent.PUBLISH.toString());
        })), tap((/**
         * @param {?} allowRedirect
         * @return {?}
         */
        function (allowRedirect) {
            if (!allowRedirect) {
                _this.redirectToPermissionDenied();
            }
        })));
    };
    /**
     * @private
     * @return {?}
     */
    ClientEventPermeationGuard.prototype.redirectToPermissionDenied = /**
     * @private
     * @return {?}
     */
    function () {
        this.router.navigate(['forbidden']);
    };
    ClientEventPermeationGuard.decorators = [
        { type: Injectable, args: [{
                    providedIn: 'root'
                },] }
    ];
    /** @nocollapse */
    ClientEventPermeationGuard.ctorParameters = function () { return [
        { type: UserDetailsService },
        { type: ActivatedRoute },
        { type: EventsService },
        { type: Router }
    ]; };
    /** @nocollapse */ ClientEventPermeationGuard.ngInjectableDef = ɵɵdefineInjectable({ factory: function ClientEventPermeationGuard_Factory() { return new ClientEventPermeationGuard(ɵɵinject(UserDetailsService), ɵɵinject(ActivatedRoute), ɵɵinject(EventsService), ɵɵinject(Router)); }, token: ClientEventPermeationGuard, providedIn: "root" });
    return ClientEventPermeationGuard;
}());
if (false) {
    /**
     * @type {?}
     * @private
     */
    ClientEventPermeationGuard.prototype.userDetailsService;
    /**
     * @type {?}
     * @private
     */
    ClientEventPermeationGuard.prototype.activatedRoute;
    /**
     * @type {?}
     * @private
     */
    ClientEventPermeationGuard.prototype.eventsService;
    /**
     * @type {?}
     * @private
     */
    ClientEventPermeationGuard.prototype.router;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var EventActualVisitorsService = /** @class */ (function () {
    function EventActualVisitorsService(http, urlProvider) {
        this.http = http;
        this.urlProvider = urlProvider;
    }
    /**
     * @param {?} eventId
     * @return {?}
     */
    EventActualVisitorsService.prototype.getAllActualVisitors = /**
     * @param {?} eventId
     * @return {?}
     */
    function (eventId) {
        return this.http.get(this.urlProvider.getUrl() + "api/events/" + eventId + "/actual/visitors");
    };
    /**
     * @param {?} eventId
     * @param {?} user
     * @return {?}
     */
    EventActualVisitorsService.prototype.addEventActualVisitor = /**
     * @param {?} eventId
     * @param {?} user
     * @return {?}
     */
    function (eventId, user) {
        return this.http.post(this.urlProvider.getUrl() + "api/events/" + eventId + "/actual/visitors/add", user);
    };
    EventActualVisitorsService.decorators = [
        { type: Injectable, args: [{
                    providedIn: 'root'
                },] }
    ];
    /** @nocollapse */
    EventActualVisitorsService.ctorParameters = function () { return [
        { type: HttpClient },
        { type: ApiUrlProvider }
    ]; };
    /** @nocollapse */ EventActualVisitorsService.ngInjectableDef = ɵɵdefineInjectable({ factory: function EventActualVisitorsService_Factory() { return new EventActualVisitorsService(ɵɵinject(HttpClient), ɵɵinject(ApiUrlProvider)); }, token: EventActualVisitorsService, providedIn: "root" });
    return EventActualVisitorsService;
}());
if (false) {
    /**
     * @type {?}
     * @private
     */
    EventActualVisitorsService.prototype.http;
    /**
     * @type {?}
     * @private
     */
    EventActualVisitorsService.prototype.urlProvider;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var EventPotentialVisitorsService = /** @class */ (function () {
    function EventPotentialVisitorsService(http, urlProvider) {
        this.http = http;
        this.urlProvider = urlProvider;
    }
    /**
     * @param {?} eventId
     * @return {?}
     */
    EventPotentialVisitorsService.prototype.getAllPotentialVisitors = /**
     * @param {?} eventId
     * @return {?}
     */
    function (eventId) {
        return this.http.get(this.urlProvider.getUrl() + "api/events/" + eventId + "/potential/visitors");
    };
    /**
     * @param {?} eventId
     * @param {?} user
     * @return {?}
     */
    EventPotentialVisitorsService.prototype.addEventPotentialVisitor = /**
     * @param {?} eventId
     * @param {?} user
     * @return {?}
     */
    function (eventId, user) {
        return this.http.post(this.urlProvider.getUrl() + "api/events/" + eventId + "/potential/visitors/add", user);
    };
    /**
     * @param {?} eventId
     * @param {?} user
     * @return {?}
     */
    EventPotentialVisitorsService.prototype.removeEventPotentialVisitor = /**
     * @param {?} eventId
     * @param {?} user
     * @return {?}
     */
    function (eventId, user) {
        return this.http.post(this.urlProvider.getUrl() + "api/events/" + eventId + "/potential/visitors/remove", user);
    };
    EventPotentialVisitorsService.decorators = [
        { type: Injectable, args: [{
                    providedIn: 'root'
                },] }
    ];
    /** @nocollapse */
    EventPotentialVisitorsService.ctorParameters = function () { return [
        { type: HttpClient },
        { type: ApiUrlProvider }
    ]; };
    /** @nocollapse */ EventPotentialVisitorsService.ngInjectableDef = ɵɵdefineInjectable({ factory: function EventPotentialVisitorsService_Factory() { return new EventPotentialVisitorsService(ɵɵinject(HttpClient), ɵɵinject(ApiUrlProvider)); }, token: EventPotentialVisitorsService, providedIn: "root" });
    return EventPotentialVisitorsService;
}());
if (false) {
    /**
     * @type {?}
     * @private
     */
    EventPotentialVisitorsService.prototype.http;
    /**
     * @type {?}
     * @private
     */
    EventPotentialVisitorsService.prototype.urlProvider;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var UserJoinNotificationService = /** @class */ (function () {
    function UserJoinNotificationService() {
        this.subject = new Subject();
    }
    /**
     * @return {?}
     */
    UserJoinNotificationService.prototype.join = /**
     * @return {?}
     */
    function () {
        this.subject.next('join');
    };
    /**
     * @return {?}
     */
    UserJoinNotificationService.prototype.leave = /**
     * @return {?}
     */
    function () {
        this.subject.next('leave');
    };
    UserJoinNotificationService.decorators = [
        { type: Injectable, args: [{
                    providedIn: 'root'
                },] }
    ];
    /** @nocollapse */ UserJoinNotificationService.ngInjectableDef = ɵɵdefineInjectable({ factory: function UserJoinNotificationService_Factory() { return new UserJoinNotificationService(); }, token: UserJoinNotificationService, providedIn: "root" });
    return UserJoinNotificationService;
}());
if (false) {
    /** @type {?} */
    UserJoinNotificationService.prototype.subject;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var EventHeaderService = /** @class */ (function () {
    function EventHeaderService() {
        this.subject = new Subject();
    }
    /**
     * @param {?} events
     * @return {?}
     */
    EventHeaderService.prototype.sendEvents = /**
     * @param {?} events
     * @return {?}
     */
    function (events) {
        this.subject.next(events);
    };
    EventHeaderService.decorators = [
        { type: Injectable, args: [{
                    providedIn: 'root'
                },] }
    ];
    /** @nocollapse */
    EventHeaderService.ctorParameters = function () { return []; };
    /** @nocollapse */ EventHeaderService.ngInjectableDef = ɵɵdefineInjectable({ factory: function EventHeaderService_Factory() { return new EventHeaderService(); }, token: EventHeaderService, providedIn: "root" });
    return EventHeaderService;
}());
if (false) {
    /** @type {?} */
    EventHeaderService.prototype.subject;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var Tag = /** @class */ (function () {
    function Tag() {
    }
    return Tag;
}());
if (false) {
    /** @type {?} */
    Tag.prototype.id;
    /** @type {?} */
    Tag.prototype.name;
    /** @type {?} */
    Tag.prototype.tagRelations;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var TagService = /** @class */ (function () {
    function TagService(http, urlProvider) {
        this.http = http;
        this.urlProvider = urlProvider;
    }
    /**
     * @param {?} tag
     * @return {?}
     */
    TagService.prototype.create = /**
     * @param {?} tag
     * @return {?}
     */
    function (tag) {
        return this.http.post(this.urlProvider.getUrl() + "api/tags", tag);
    };
    /**
     * @param {?} eventId
     * @param {?} tagId
     * @return {?}
     */
    TagService.prototype.addTagToEvent = /**
     * @param {?} eventId
     * @param {?} tagId
     * @return {?}
     */
    function (eventId, tagId) {
        return this.http.put(this.urlProvider.getUrl() + "api/events/" + eventId + "/tags/" + tagId, {});
    };
    /**
     * @param {?} rootTagId
     * @param {?} tagId
     * @return {?}
     */
    TagService.prototype.matTagToAnotherTag = /**
     * @param {?} rootTagId
     * @param {?} tagId
     * @return {?}
     */
    function (rootTagId, tagId) {
        return this.http.put(this.urlProvider.getUrl() + "api/tags/" + rootTagId + "/" + tagId, {});
    };
    /**
     * @param {?} eventId
     * @param {?} tagId
     * @return {?}
     */
    TagService.prototype.removeFromEvent = /**
     * @param {?} eventId
     * @param {?} tagId
     * @return {?}
     */
    function (eventId, tagId) {
        return this.http.delete(this.urlProvider.getUrl() + "api/events/" + eventId + "/tags/" + tagId);
    };
    TagService.decorators = [
        { type: Injectable, args: [{
                    providedIn: 'root'
                },] }
    ];
    /** @nocollapse */
    TagService.ctorParameters = function () { return [
        { type: HttpClient },
        { type: ApiUrlProvider }
    ]; };
    /** @nocollapse */ TagService.ngInjectableDef = ɵɵdefineInjectable({ factory: function TagService_Factory() { return new TagService(ɵɵinject(HttpClient), ɵɵinject(ApiUrlProvider)); }, token: TagService, providedIn: "root" });
    return TagService;
}());
if (false) {
    /**
     * @type {?}
     * @private
     */
    TagService.prototype.http;
    /**
     * @type {?}
     * @private
     */
    TagService.prototype.urlProvider;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var SearchEventSubject = /** @class */ (function () {
    function SearchEventSubject() {
        this.searchOnSubject = new Subject();
        this.searchLifecycle = this.searchOnSubject.asObservable();
    }
    /**
     * @param {?} show
     * @return {?}
     */
    SearchEventSubject.prototype.notify = /**
     * @param {?} show
     * @return {?}
     */
    function (show) {
        this.searchOnSubject.next(show);
    };
    SearchEventSubject.decorators = [
        { type: Injectable, args: [{
                    providedIn: 'root'
                },] }
    ];
    /** @nocollapse */
    SearchEventSubject.ctorParameters = function () { return []; };
    /** @nocollapse */ SearchEventSubject.ngInjectableDef = ɵɵdefineInjectable({ factory: function SearchEventSubject_Factory() { return new SearchEventSubject(); }, token: SearchEventSubject, providedIn: "root" });
    return SearchEventSubject;
}());
if (false) {
    /**
     * @type {?}
     * @private
     */
    SearchEventSubject.prototype.searchOnSubject;
    /** @type {?} */
    SearchEventSubject.prototype.searchLifecycle;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var AttachmentService = /** @class */ (function () {
    function AttachmentService(http, urlProvider) {
        this.http = http;
        this.urlProvider = urlProvider;
    }
    /**
     * @param {?} attachment
     * @return {?}
     */
    AttachmentService.prototype.saveAttachment = /**
     * @param {?} attachment
     * @return {?}
     */
    function (attachment) {
        /** @type {?} */
        var formdata = new FormData();
        formdata.append('attachment', attachment);
        return this.http.post(this.urlProvider.getUrl() + "api/attachment/add", formdata);
    };
    /**
     * @param {?} attachmentId
     * @return {?}
     */
    AttachmentService.prototype.deleteAttachment = /**
     * @param {?} attachmentId
     * @return {?}
     */
    function (attachmentId) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.http.delete(this.urlProvider.getUrl() + "api/attachment/" + attachmentId, {}).toPromise()];
                    case 1: return [2 /*return*/, _a.sent()];
                }
            });
        });
    };
    AttachmentService.decorators = [
        { type: Injectable, args: [{
                    providedIn: 'root'
                },] }
    ];
    /** @nocollapse */
    AttachmentService.ctorParameters = function () { return [
        { type: HttpClient },
        { type: ApiUrlProvider }
    ]; };
    /** @nocollapse */ AttachmentService.ngInjectableDef = ɵɵdefineInjectable({ factory: function AttachmentService_Factory() { return new AttachmentService(ɵɵinject(HttpClient), ɵɵinject(ApiUrlProvider)); }, token: AttachmentService, providedIn: "root" });
    return AttachmentService;
}());
if (false) {
    /**
     * @type {?}
     * @private
     */
    AttachmentService.prototype.http;
    /**
     * @type {?}
     * @private
     */
    AttachmentService.prototype.urlProvider;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var Attachment = /** @class */ (function () {
    function Attachment() {
    }
    return Attachment;
}());
if (false) {
    /** @type {?} */
    Attachment.prototype.id;
    /** @type {?} */
    Attachment.prototype.name;
    /** @type {?} */
    Attachment.prototype.type;
    /** @type {?} */
    Attachment.prototype.downloadUri;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

export { AdminAuthGuard, AdminDetailsServiceService, AdminEventCreateDetailsService, AdminEventPermeationGuard, ApiUrlProvider, Attachment, AttachmentService, AuthInterceptor, BaseBehaviorSubject, ClientAuthGuard, ClientEventPermeationGuard, ComponentsModule, ConfirmDialogWindowComponent, ErrorForbiddenPageInterceptor, ErrorNotFoundPageInterceptor, Event, EventActualVisitorsService, EventEditorService, EventHeaderService, EventMapService, EventNavigationSubjectService, EventPotentialVisitorsService, EventSharedUsersService, EventStatusService, EventUpdateDisableService, EventUpdateService, EventsService, FilterByPredicatePipe, GoogleGeocoderService, Location, LocationChangeService, LoginPageGuard, NextTimeEvents, NotPublished, Oauth2Service, ParticipantsService, PingBackEndService, PipesModule, PopupsService, ProgressInterceptor, ProgressLoaderComponent, ProgressModule, PublishedEvents, QQEventModule, QQRestConfig, QqTopicModule, Question, QuestionStatusService, QuestionsService, SaveRequestNotificator, SearchEventSubject, SnackBarComponent, SortByDatePipe, SortTopicByDatesPipe, SortTopicByMinutesAndHours, Speaker, SpeakersService, Status, StatusEvent, Stream, StreamCreateService, StreamEvent, StreamEventService, StreamEventType, StreamService, Tag, TagService, Topic, TopicEditService, TopicService, TopicStatusService, TopicValidationService, TopilListElementDirective, User, UserDetailsService, UserJoinNotificationService, Visitor, Vote, DirectiveModule as ɵa, DisableDirective as ɵb };
//# sourceMappingURL=qq-core-lib.js.map
