import { MatSnackBar } from '@angular/material';
import { ActivatedRoute, Router } from '@angular/router';
import { Observable } from 'rxjs';
import { EventsService } from './events.service';
import { StreamService } from '../../stream/services/stream.service';
import { LocationChangeService } from './location.change.service';
import { AdminDetailsServiceService } from './admin-details-service.service';
import { Event } from '../models/Event';
import { Topic } from '../../topic/model/Topic';
export declare class EventEditorService {
    private activatedRoute;
    private router;
    private eventsService;
    private streamService;
    private snackBar;
    private locationChangeSerive;
    private eventsDetailsAdminService;
    private locationSubscription;
    constructor(activatedRoute: ActivatedRoute, router: Router, eventsService: EventsService, streamService: StreamService, snackBar: MatSnackBar, locationChangeSerive: LocationChangeService, eventsDetailsAdminService: AdminDetailsServiceService);
    isEventValid(event: Event): boolean;
    isValidParticipantLimit(event: Event): boolean;
    isValidDate(date: String): boolean;
    createEvent(event: Event): Observable<Event>;
    updateEvent(event: Event): Observable<Event>;
    setDatesRangeToEvent(event: Event, dateStart: Date, dateEnd: Date): void;
    isEventDatesPassedToTopicsDates(dateStart: Date, dateEnd: Date, topics: Topic[]): boolean;
    parseEventTopics(event: Event): Topic[];
    requestLocationChanges(onLocationChanges: (location: any) => void): void;
    unsubscribeAll(): void;
    private unsubscribe;
}
