import { HttpClient } from '@angular/common/http';
import { Observable } from 'rxjs';
import { Event } from '../models/Event';
import { ApiUrlProvider } from '../../services/api-url-provider';
import { UserDetailsService } from '../../security/services/user-details.service';
import { BaseBehaviorSubject } from './base-behaviour.subject';
export declare class EventsService {
    private http;
    private userDetailsService;
    private urlProvider;
    private eventsContainer;
    constructor(http: HttpClient, userDetailsService: UserDetailsService, urlProvider: ApiUrlProvider);
    findAll(): Promise<Event[]>;
    getEventsContainer(): BaseBehaviorSubject<Event>;
    findAllCreatedByCurrentUser(): Observable<Array<Event>>;
    findPublished(): Observable<Event[]>;
    findById(id: number): Observable<Event>;
    createEmptyEvent(): Observable<Object>;
    deleteEvent(event: Event): Promise<void>;
    updateEvent(event: Event): Observable<Event>;
    publishEvent(id: any): Observable<Event>;
    createEvent(event: Event): Observable<Event>;
    getQrCode(id: number): Observable<Blob>;
    getEventByTagNameIn(text: string): Observable<Event[]>;
    getEventByTagName(tag: string): Observable<Event[]>;
    addAttachmentToEvent(eventId: number, attachmentId: number): Observable<Event>;
    deleteAttachment(eventId: number, attachmentId: number): Promise<Event>;
}
