import { HttpClient } from '@angular/common/http';
import { Question } from '../models/Question';
import { Observable } from 'rxjs';
import { ApiUrlProvider } from '../../services/api-url-provider';
import { BaseBehaviorSubject } from '../../event/services/base-behaviour.subject';
/**
 * Created by yana on 26.04.18.
 */
export declare class QuestionsService {
    private http;
    private urlProvider;
    questionsCollection: BaseBehaviorSubject<Question>;
    constructor(http: HttpClient, urlProvider: ApiUrlProvider);
    findAllByTopicId(topicId: number): Observable<Array<Question>>;
    findById(questionId: number): Observable<Question>;
    post(topicId: string, question: Question): Observable<Question>;
    vote(questionId: number): Observable<Question>;
    removeVote(questionId: number): Observable<Question>;
    delete(questionId: number): Observable<void>;
    open(questionId: number): Observable<Question>;
    close(questionId: number): Observable<Question>;
}
