import { HttpClient } from '@angular/common/http';
import { ApiUrlProvider } from '../../services/api-url-provider';
import { Observable } from 'rxjs';
import { UserDetailsService } from './user-details.service';
export declare class Oauth2Service {
    private http;
    private urlProvider;
    private userDetailsService;
    basicAuthToken: string;
    constructor(http: HttpClient, urlProvider: ApiUrlProvider, userDetailsService: UserDetailsService);
    authorize(userId: string, displayName: string, image: string): Observable<boolean>;
    authorizeAdmin(userId: string, displayName: string, image: string): Observable<boolean>;
    authenticate(username: string, password: string): Observable<boolean>;
    logout(): Observable<boolean>;
    requestToken(username: string, password: string): Observable<any>;
    requestUserInfo(): Observable<any>;
    refreshToken(): Observable<boolean>;
    private registerUser;
    private registerAdmin;
    parseAndSaveAuthData(authData: Object): Observable<boolean>;
    isAuthenticated(): Observable<boolean>;
}
